#    Triple Triad PSP
#    Copyright (C) 2006, 2007 Sakya
#    sakya_tg@yahoo.it
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
import psp2d, userdata
from clsCard import card

class cardSet(object):
  """Class cards"""
  name = None
  path = None
  shortDesc = None
  elements = None
  imageBack = None
  elementals = None


  def __init__(self):
    self.name = ""
    self.path = ""
    self.font = None
    self.drawValues = True
    self.shortDesc = ""
    self.elements = []
    self.elementsIndex = []
    self.levels = [[] for i in xrange(0,11)]
    self.imageBack = None
    self.elementals = []
    self.elementalsImages = []


  def load(self, pCardsName):
    """Import cards"""
    if len(pCardsName) > 0:
      self.levels = [[] for i in xrange(0,11)]
      self.path = "cardsets/" + pCardsName + "/"
      self.font = psp2d.Font("cardsets/" + pCardsName + "/font_card.png")
      self.imageBack = psp2d.Image("cardsets/" + pCardsName + "/images/back.png")
      #Importo il file di definizione:
      try:
        temp = __import__("cardsets." + pCardsName + "." + userdata.LANG , None, None,pCardsName)
      except ImportError:
        temp = __import__("cardsets." + pCardsName + ".english", None, None,pCardsName)

      self.name = temp.NAME
      self.shortDesc = temp.SDESC
      self.drawValues = temp.DRAW_VALUES
      for i, tEl in enumerate(temp.ELEMENTS):
        self.elementals.append(tEl)
        self.elementalsImages.append(psp2d.Image("cardsets/" + pCardsName + "/images/ele_" + str(i) + ".png"))

      for i, tC in enumerate(temp.CARDS):
        tCard = card(self)
        tCard.ID = i
        tCard.name = tC[1]
        tCard.count = 0
        tCard.level = tC[0]
        tCard.imageP1 = "cardsets/" + pCardsName + "/images/" + tC[2].replace(".", ".p1.")
        tCard.imageP2 = "cardsets/" + pCardsName + "/images/" + tC[2].replace(".", ".p2.")
        if tC[3] == "A":
          tC[3] = 10
        tCard.top = tC[3]
        if tC[4] == "A":
          tC[4] = 10
        tCard.right = int(tC[4])
        if tC[5] == "A":
          tC[5] = 10
        tCard.bottom = int(tC[5])
        if tC[6] == "A":
          tC[6] = 10
        tCard.left = int(tC[6])
        tCard.elemental = tC[7]
        if tC[7] != None:
          tCard.elementalString = self.elementals[tC[7]]
        self.elements.append(tCard)
        self.elementsIndex.append(tCard.name)

        #Aggiungo la carta al livello:
        self.levels[tCard.level].append(tCard)


  def value(self):
    """Returns the cardset value"""
    value = 0
    for tCard in self.elements:
      value += tCard.count * tCard.value()
    return value


  def totalCards(self):
    """Returns total number of cards"""
    value = 0
    for tCard in self.elements:
      value += tCard.count
    return value


  def getCard(self, pName):
    try:
      return self.elements[self.elementsIndex.index(pName)]
    except:
      pass
    return None