#    Triple Triad PSP
#    Copyright (C) 2006, 2007 Sakya
#    sakya_tg@yahoo.it
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
import psp2d
import functions
#from copy import copy
from os import name

class graphicElement(object):
  """Classe graphicElement"""
  def __init__(self):
    """Inizializzazioni"""
    self.name = ""
    self.image = None
    self.icon = None
    self.iconPosition = None
    self.text = None
    self.font = None
    self.posX = 0
    self.posY = 0
    self.maxWidth = -1
    self.multiLine = False
    self.subX = 0
    self.subY = 0
    self.subWidth = -1
    self.subHeight = -1
    self.height = -1
    self.width = -1
    self.status = None
    self.animation = None
    self.data = None
    self.visible = True
    self.blend = True
    self.priority = 0


  def buildTextImage(self):
    #Build the image for a text graphic element:
    if self.multiLine:
      self.buildMultiLineTextImage()
    else:
      tWidth = functions.textWidth(self.font, self.text)
      tHeight = functions.textHeight(self.font, "I")
      if self.icon:
        tWidth += self.icon.width
        if self.icon.height > tHeight:
          tHeight = self.icon.height
      self.image = psp2d.Image(tWidth, tHeight)
      if name == "psp":
        self.image.clear(psp2d.Color(0,0,0))
      if self.icon:
        diff = (self.icon.height - functions.textHeight(self.font, "I")) / 2
        if self.iconPosition == "RIGHT":
          self.image.blit(self.icon, 0, 0, self.icon.width, self.icon.height, tWidth - self.icon.width, 0, True)
          self.font.drawText(self.image, 0, 0 + diff, self.text)
          self.posY -= diff
        else:
          self.image.blit(self.icon, 0, 0, self.icon.width, self.icon.height, 0, 0, True)
          self.font.drawText(self.image, self.icon.width, 0 + diff, self.text)
          self.posY -= diff
      else:
        self.font.drawText(self.image, 0, 0, self.text)


  def buildMultiLineTextImage(self):
    #Calcolo le righe del testo:
    righe = []
    riga = None
    tWidth = 0
    for p in self.text.split(" "):
      tWidth += functions.textWidth(self.font, p + " ")
      if tWidth > self.maxWidth:
        righe.append(riga)
        tWidth = functions.textWidth(self.font, p)
        riga = p
        continue
      if not riga:
        riga = p
      else:
        riga += " " + p
    if riga:
      righe.append(riga)
    tHeight = functions.textHeight(self.font, "I")
    self.image = psp2d.Image(self.maxWidth, tHeight * (len(righe) + 1))
    if name == "psp":
      self.image.clear(psp2d.Color(0,0,0))
    for i, riga in enumerate(righe):
      self.font.drawText(self.image, 0, i * tHeight, riga)


  #def copy(self):
  #  """Returns a copy of the graphic element"""
  #  return copy(self)
