#    Triple Triad PSP
#    Copyright (C) 2006, 2007 Sakya
#    sakya_tg@yahoo.it
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
import psp2d, pspsnd, pspos, gc, sys
from os import name
from core import functions, animation, graphicElement, dataStore, menu, menuElement, buttons, gameType, card, \
                 cardSet, helpItem, deck, TTplayer, vKeyboard, city, clsNet, logFile
from formsFunction import *
from random import _random
from linecache import clearcache
from sre import purge

#Volume al massimo:
pspsnd.setSndFxVolume(255)
userData = __import__("userdata")

#Loading message:
screen = psp2d.Screen()
screen.clear(psp2d.Color(0,0,0,255))
bg = psp2d.Image('themes/' + userData.THEME + '/loading.png')
pg = psp2d.Image('themes/' + userData.THEME + '/progress_03.png')
screen.blit(bg, 0, 0, bg.width, bg.height, 0, 0)
screen.blit(pg, 0, 0, pg.width, pg.height, 170, 245)
screen.swap()

class tmain(object):
  """Classe main"""

  def __init__(self):
    """Inizializzazioni"""
    gc.enable()
    self.version = "0.04.21"

    #Variabili globali:
    self.globalVars = dataStore()

    #Carico le opzioni:
    userData = __import__("userdata")

    self.debug = False
    self.debugScreen = False
    if userData.DEBUG == "YES":
      self.debug = True
      if userData.DEBUG_SCREEN == "YES":
        self.debugScreen = True
    self.globalVars.set(self.debug, "debug")

    #Nome utente di default:
    if len(userData.USERNAME) == 0:
      userData.USERNAME = pspos.getnickname()

    #Opzioni del tema:
    themeOptions = __import__("themes." + userData.THEME, None, None, userData.THEME)

    #Carico i messaggi della lingua:
    messages = __import__("languages." + userData.LANG, None, None,userData.LANG)

    #Loading message:
    screen = psp2d.Screen()
    bg = psp2d.Image('themes/' + userData.THEME + '/loading.png')
    pg = psp2d.Image('themes/' + userData.THEME + '/progress_05.png')
    screen.blit(bg, 0, 0, bg.width, bg.height, 0, 0)
    screen.blit(pg, 0, 0, pg.width, pg.height, 170, 245)
    screen.swap()

    #Font condivisi:
    self.fonts = dataStore()
    self.fonts.set(psp2d.Font('themes/' + userData.THEME + '/font_title.png'), "fontTitle")
    self.fonts.set(psp2d.Font('themes/' + userData.THEME + '/font_message.png'), "fontMessage")
    self.fonts.set(psp2d.Font('themes/' + userData.THEME + '/font_menu.png'), "fontMenu")
    self.fonts.set(psp2d.Font('themes/' + userData.THEME + '/font_menuselected.png'), "fontMenuSel")
    self.fonts.set(psp2d.Font('themes/' + userData.THEME + '/font_menudisabled.png'), "fontMenuDisabled")

    #Suoni condivisi:
    self.sounds = dataStore()
    self.sounds.set(pspsnd.Sound("themes/" + userData.THEME + "/menu_change.wav"), "menuChangeSound")
    self.sounds.set(pspsnd.Sound("themes/" + userData.THEME + "/menu_select.wav"), "menuSelectSound")
    self.sounds.set(pspsnd.Sound("themes/" + userData.THEME + "/menu_cancel.wav"), "menuCancelSound")

    #Immagini condivise:
    self.images = dataStore()
    self.images.set(psp2d.Image('themes/' + userData.THEME + '/background.png'), "defaultBkgImage")
    self.images.set(psp2d.Image('themes/' + userData.THEME + '/button_cross.png'), "buttonCross")
    self.images.set(psp2d.Image('themes/' + userData.THEME + '/button_circle.png'), "buttonCircle")
    self.images.set(psp2d.Image('themes/' + userData.THEME + '/button_square.png'), "buttonSquare")
    self.images.set(psp2d.Image('themes/' + userData.THEME + '/button_triangle.png'), "buttonTriangle")
    self.images.set(psp2d.Image('themes/' + userData.THEME + '/button_start.png'), "buttonStart")
    self.images.set(psp2d.Image('themes/' + userData.THEME + '/button_select.png'), "buttonSelect")
    self.images.set(psp2d.Image('themes/' + userData.THEME + '/button_left_trigger.png'), "buttonLeftTrigger")
    self.images.set(psp2d.Image('themes/' + userData.THEME + '/button_right_trigger.png'), "buttonRightTrigger")
    self.images.set(psp2d.Image('themes/' + userData.THEME + '/button_up.png'), "buttonUp")
    self.images.set(psp2d.Image('themes/' + userData.THEME + '/button_left.png'), "buttonLeft")
    self.images.set(psp2d.Image('themes/' + userData.THEME + '/button_down.png'), "buttonDown")
    self.images.set(psp2d.Image('themes/' + userData.THEME + '/button_right.png'), "buttonRight")

    self.images.set(psp2d.Image('themes/' + userData.THEME + '/leveldown.png'), "levelDown")
    self.images.set(psp2d.Image('themes/' + userData.THEME + '/levelup.png'), "levelUp")

    #Loading message:
    pg = psp2d.Image('themes/' + userData.THEME + '/progress_09.png')
    screen.blit(bg, 0, 0, bg.width, bg.height, 0, 0)
    screen.blit(pg, 0, 0, pg.width, pg.height, 170, 245)
    screen.swap()

    #Mazzi:
    self.globalVars.set([], "cardSets")
    self.loadCardSets()

    #Imposto le variabili globali:
    self.globalVars.set(self.version, "version")
    self.globalVars.set(userData, "userData")
    self.globalVars.set(messages, "messages")
    self.globalVars.set(None, "message")
    self.globalVars.set(themeOptions, "themeOptions")
    self.globalVars.set(self.fonts, "fonts")
    self.globalVars.set(self.sounds, "sounds")
    self.globalVars.set(self.images, "images")
    self.globalVars.set(None, "playingSound")
    self.globalVars.set(None, "lastForm")
    self.globalVars.set([], "lastForms")
    self.globalVars.set([], "lastFormsModules")

    #Log generale:
    self.globalVars.set(logFile(), "logFile")
    self.globalVars.get("logFile").log("-" * 80)
    self.globalVars.get("logFile").log(("Triple Triad PSP Vers." + self.version).center(80))
    self.globalVars.get("logFile").log("-" * 80)

    #Variabili per backup/restore forms:
    self.lastForms = self.globalVars.get("lastForms")
    self.lastFormsModules = self.globalVars.get("lastFormsModules")
    self.lastForm = None

    #Modulo net:
    self.globalVars.set(clsNet.net(self.globalVars), "net")

    #Common graphics:
    self.commonGraphics = dataStore()
    self.createCommonGraphics()
    self.globalVars.set(self.commonGraphics, "commonGraphics")

    #Loading message:
    pg = psp2d.Image('themes/' + userData.THEME + '/progress_12.png')
    screen.blit(bg, 0, 0, bg.width, bg.height, 0, 0)
    screen.blit(pg, 0, 0, pg.width, pg.height, 170, 245)
    screen.swap()


  def start(self):
    """Main loop"""
    #Set CPU & BUS clock:
    pspos.setclock(266)
    self.globalVars.get("logFile").log("CPU Clock         : %i" % pspos.getclock())
    pspos.setbus(133)
    self.globalVars.get("logFile").log("BUS Clock         : %i" % pspos.getbus())

    #Mi salvo i moduli caricati:
    self.modulesList = sys.modules.keys()

    self.globalVars.set("mdlMainMenu", "formName")
    while True:
      self.globalVars.get("net").changingForm = False
      formName = self.globalVars.get("formName")
      if formName:
        #Pulisco la memoria:
        gc.collect()
        clearcache()
        purge()
        #Cambio form
        #execfile(formName + ".py", {"globalVars":self.globalVars})
        currentForm = __import__(formName, None, None, formName)
        self.globalVars.set(None, "message")
        self.globalVars.set(None, "playingSound")
        #Init:
        currentForm.init(self.globalVars, self.globalVars.get("formParams"))
        self.globalVars.set(None, "formParams")

        #Show
        self.globalVars.get("logFile").log(("Current: " + formName).ljust(31) + (str(pspos.realmem() / 1024) + "kb").rjust(20) + (str(pspos.freemem() / 1024) + "kb").rjust(10))
        currentForm.show(self.globalVars, currentForm.formVars, currentForm.button_down)
        
        #Elimino le richieste della form:
        self.globalVars.get("net").changingForm = True
        self.globalVars.get("net").requests = [req for req in self.globalVars.get("net").requests if req.callingForm != formName]
        #Aspetto eventuali richieste in sospeso:
        while self.globalVars.get("net").currentRequest \
        and self.globalVars.get("net").currentRequest.callingForm == formName:
          sleep(0.01)

        currentForm.formGraphics.clear()
        currentForm.formVars.clear()
        del currentForm
        try:
          del sys.modules[formName]
        except KeyError:
          pass
        self.clearModules()
      #Controllo uscita dal programma:
      if self.globalVars.get("exitTTPSP") == "YES":
        self.globalVars.get("logFile").log("Exiting TTPSP!")
        self.globalVars.get("logFile").log("Bye!")
        #Chiudo il log:
        self.globalVars.get("logFile").close()
        break


  def clearModules(self, modulesList=None):
    """Clear modules from memory"""
    if not modulesList:
      modulesList = self.modulesList
    for tMod in sys.modules.keys():
      if tMod not in modulesList:
        try:
          exec("del " + tMod)
        except NameError:
          pass
        del sys.modules[tMod]
          

  def createCommonGraphics(self):
    #Elementi grafici comuni:
    graph = graphicElement()
    graph.name = "CE_FORM_MESSAGE"
    graph.priority = 1
    graph.font = self.globalVars.get("fonts").get("fontMessage")
    tY = (22 - functions.textHeight(self.globalVars.get("fonts").get("fontMessage"), "I")) / 2
    graph.posY = int(250 + tY)
    self.commonGraphics.set(graph)

    if self.debug:
      graph = graphicElement()
      graph.name = "CE_FORM_DEBUG"
      graph.priority = 9999
      graph.posX = 0
      graph.posY = 0
      graph.font = self.globalVars.get("fonts").get("fontMessage")
      self.commonGraphics.set(graph)

    graph = graphicElement()
    graph.name = "CE_FORM_FPS"
    graph.priority = 1
    tX = 1
    tY = functions.textHeight(self.globalVars.get("fonts").get("fontMessage"), "I")
    graph.posX = tX
    graph.posY = 272 - tY
    graph.font = self.globalVars.get("fonts").get("fontMessage")
    graph.text = "FPS: " + str(0)
    if self.globalVars.get("userData").SHOW_FPS != "YES":
      graph.visible = False
    self.commonGraphics.set(graph)

    #Indicatore batteria:
    if name == "psp":
      graph = graphicElement()
      graph.name = "CE_BATT_LEVEL"
      graph.priority = 1
      graph.posX = 452
      graph.posY = 252
      graph.lastUpdate = None
      graph.data = [None, None]
      anim = animation()
      anim.name = graph.name
      anim.lockKeyboard = False
      def code(globalVars, formVars, target):
        #Controllo il valore della batteria:
        if not target.lastUpdate  \
        or target.lastUpdate \
        and globalVars.get("currentFPSTime") - target.lastUpdate >= 5:
          batt = pspos.battery()
          perc = batt[3]
          if batt[0] == 1:
            baseName = "battPlug"
          else:
            baseName = "batt"

          if not target.data[1] or target.data[1] != batt[0]:
            target.data[0] = 0
          target.data[1] = batt[0]

          if perc >= 75:
            if target.data[0] != 100:
              target.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/' + baseName + '_100.png')
              target.data[0] = 100
          elif perc >= 50:
            if target.data[0] != 75:
              target.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/' + baseName + '_75.png')
              target.data[0] = 75
          elif perc >= 25:
            if target.data[0] != 50:
              target.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/' + baseName + '_50.png')
              target.data[0] = 50
          elif perc >= 10:
            if target.data[0] != 25:
                target.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/' + baseName + '_25.png')
                target.data[0] = 25
          elif perc < 10:
            if target.data[0] != 10:
              target.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/' + baseName + '_0.png')
              target.data[0] = 10
          target.lastUpdate = globalVars.get("currentFPSTime")
      anim.code = code
      graph.animation = anim
      self.commonGraphics.set(graph)


  def loadCardSets(self):
    #Carico i cardsets:
    cardSets = self.globalVars.get("cardSets")
    if len(cardSets) == 0:
      #Carico la prima volta:
      cardSets = []
      list = __import__("cardsets")
      for cs in list.LIST:
        tCardSet = cardSet()
        tCardSet.load(cs)
        cardSets.append(tCardSet)
      self.globalVars.set(cardSets, "cardSets")
    else:
      #Ricarico:
      for set in cardSets:
        set.load(set.path[9:-1])

#Sempre in fondo!!
del bg, pg, userData, screen
