#    Triple Triad PSP
#    Copyright (C) 2006, 2007 Sakya
#    sakya_tg@yahoo.it
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
import psp2d
from core import functions, animation, graphicElement, dataStore, menu, menuElement, buttons, TTplayer
from formsFunction import *

"""Form blacklist"""
formGraphics = dataStore()
formVars = dataStore()
formVars.set(formGraphics, "formGraphics")
globalVars = None

def init(pGlobalVars, pParams):
  global formVars, globalVars, formGraphics

  formGraphics = dataStore()
  formVars = dataStore()
  formVars.set(formGraphics, "formGraphics")
  globalVars = pGlobalVars

  formVars.set(psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_bg_blacklist.png'), "bkgImage")
  formVars.set('themes/' + globalVars.get("userData").THEME + '/gm_bg_blacklist.png', "bkgImageName")
  formVars.set(0, "bkgImagePosX")
  formVars.set(0, "bkgImagePosY")

  #Carico icone degli elementi:
  formVars.set(globalVars.get("elements"), "elements")

  formVars.set(False, "menuCreated")
  formVars.set(False, "playerMenuCreated")

  #Titolo:
  graph = graphicElement()
  graph.name = "TITLE"
  graph.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_bg_title.png')
  graph.posX = -476
  graph.posY = 2
  anim = animation()
  anim.name = graph.name
  anim.data = [2, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)

  graph = graphicElement()
  graph.name = "TITLET"
  graph.font = globalVars.get("fonts").get("fontTitle")
  graph.posY = 4
  graph.text = globalVars.get("messages").GM_BLACKLIST_TITLE
  graph.posX = -functions.textWidth(graph.font, graph.text)
  anim = animation()
  anim.name = graph.name
  anim.data = [(480 - functions.textWidth(graph.font, graph.text)) / 2, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)

  #Messaggi:
  formGraphics.set(createMessagesGE(globalVars, formVars))

  #Black list
  blackList = menu(formGraphics, pGlobalVars, formVars)
  blackList.name = "BLACK_LIST"
  blackList.background_image =  psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_bg_200x200.png')
  blackList.menuHeight = 200
  blackList.menuWidth = 200
  blackList.posX = 2
  blackList.posY = 41
  blackList.selector = "RIGHT"
  blackList.menuAlignment = "LEFT"
  def code(globalVars, formVars, menu, element):
    #Torno al gioco:
    globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingSound")
    globalVars.get("playingSound").start()
    globalVars.get("net").changeStatus("N")
    globalVars.set(["RESTORE"], "formParams")
    globalVars.set("mdlGame", "formName")
    globalVars.set("YES", "breakLoop")
  blackList.trigger_cancel = code
  formVars.set(blackList, "blackList")

  #Player menu:
  playerMenu = menu(formGraphics, pGlobalVars, formVars)
  playerMenu.name = "PLAYER_MENU"
  playerMenu.menuWidth = 200
  playerMenu.menuHeight = 110
  playerMenu.background_image =  psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_bg_playermenu.png')
  playerMenu.posX = blackList.posX + blackList.menuWidth + 2
  playerMenu.menuAlignment = "RIGHT"
  playerMenu.menuVAlignment = "CENTER"
  playerMenu.selector = "LEFT"
  formVars.set(playerMenu, "playerMenu")

  formVars.set("LIST", "status")
  createBlacklistMenu()
  formVars.set(blackList, "formMenu")


def createBlacklistMenu():
  """Create black list"""
  blackList = formVars.get("blackList")
  blackList.elements = []
  for b in globalVars.get("blackList"):
    player = TTplayer()
    player.name = b
    player.status = "O"
    tElement = menuElement()
    tElement.data = player
    tElement.value = player.name
    tElement.text = player.name
    tElement.icon = globalVars.get("iconOffline")
    def code(globalVars, formVars, menu, element):
      #Apro il player menu:
      globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
      globalVars.get("playingSound").start()
      showPlayerMenu()
    tElement.trigger_select = code
    blackList.elements.append(tElement)

  if not blackList.selected and len(blackList.elements) > 0:
    if blackList.firstVisible:
      blackList.selected = blackList.firstVisible.value
    else:
      blackList.selectFirstElement()

  if not formVars.get("menuCreated"):
    formVars.set(True, "menuCreated")
    blackList.createGraphicElements("BOTTOM")
  else:
    blackList.createGraphicElements()
  if formVars.get("status") == "LIST":
    sel = blackList.getGraphicElement("MENU_SELECTOR_RIGHT")
    if sel:
      sel.visible = True
  blackList.creating = False


def showPlayerMenu():
  #Cambio stato alla form:
  formVars.set("PLAYER", "status")

  #Salvo gli oggetti grafici del menu:
  posY = formVars.get("blackList").getGraphicElement("MENU_SELECTOR_RIGHT").posY
  if formVars.get("formMenu").name != "PLAYERMENU":
    sel = formVars.get("formMenu").getGraphicElement("MENU_SELECTOR_RIGHT")
    if sel:
      sel.visible = False

  #Cambio menu:
  pMenu = formVars.get("playerMenu")
  pMenu.elements = []
  if posY + pMenu.menuHeight > 247:
    posY = 247 - pMenu.menuHeight
  pMenu.posY = posY

  tElement = menuElement()
  tElement.text = globalVars.get("messages").GM_INFO
  tElement.helpText = globalVars.get("messages").GM_INFOH
  tElement.icon = globalVars.get("iconUserInfo")
  tElement.value = "INFO"
  def code(globalVars, formVars, menu, element):
    menu.formVars.set("PLAYER_INFO", "status")
    menu.delGraphics()
    formVars.set(None, "formMenu")

    #Informazioni sul giocatore:
    globalVars.set(None, "message")
    graph = graphicElement()
    graph.name = "PLAYER_INFO"
    graph.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_bg_blplayerinfo.png')

    posX = 5
    posY = 5
    tHeight = functions.textHeight(globalVars.get("fonts").get("fontMenu"), "I")
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 0 * tHeight, menu.globalVars.get("messages").GM_NAME)
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 1 * tHeight, menu.globalVars.get("messages").GM_STATUS)
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 2 * tHeight, menu.globalVars.get("messages").GM_LANG)
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 3 * tHeight, menu.globalVars.get("messages").GM_SYSTEM)
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 4 * tHeight, menu.globalVars.get("messages").GM_VERSION)
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 5 * tHeight, menu.globalVars.get("messages").GM_PLAY)
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, 60 - functions.textWidth(globalVars.get("fonts").get("fontMenu"), menu.globalVars.get("messages").GM_WIN), posY + 6 * tHeight, menu.globalVars.get("messages").GM_WIN)
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, 60 * 2 - functions.textWidth(globalVars.get("fonts").get("fontMenu"), menu.globalVars.get("messages").GM_DRAW), posY + 6 * tHeight, menu.globalVars.get("messages").GM_DRAW)
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, 60 * 3 - functions.textWidth(globalVars.get("fonts").get("fontMenu"), menu.globalVars.get("messages").GM_LOSE), posY + 6 * tHeight, menu.globalVars.get("messages").GM_LOSE)

    tX = formVars.get("playerMenu").posX
    tY = formVars.get("playerMenu").posY + formVars.get("playerMenu").menuHeight - graph.image.height
    graph.posX = 480
    graph.posY = tY
    anim = animation()
    anim.name = graph.name
    anim.data = [tX, tY, 99]
    anim.code = functions.moveFromTo
    graph.animation = anim
    menu.formGraphics.set(graph)
    globalVars.get("net").playerInfo(formVars.get("blackList").getSelected().data.name, playerInfoCallback)

  tElement.trigger_select = code
  pMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").GM_MESSAGE
  tElement.helpText = globalVars.get("messages").GM_MESSAGEH
  tElement.icon = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_replymessage.png')
  tElement.value = "SEND_MSG"
  def code(globalVars, formVars, menu, element):
    #Scrivo un nuovo messaggio:
    globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
    globalVars.get("playingSound").start()
    globalVars.set("mdlNewMessage", "formName")
    globalVars.set([formVars.get("blackList").getSelected().data.name, "", "mdlBlackList", None], "formParams")
    globalVars.set("YES", "breakLoop")
  tElement.trigger_select = code
  pMenu.elements.append(tElement)

   #Chiudo il menu con cerchio:
  def code(globalVars, formVars, menu, element):
    globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingSound")
    globalVars.get("playingSound").start()
    hidePlayerMenu()
  pMenu.trigger_cancel = code

  tElement = menuElement()
  tElement.text = globalVars.get("messages").GM_DELBLACK
  tElement.icon = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_delblack.png')
  tElement.helpText = globalVars.get("messages").GM_DELBLACKH
  tElement.value = "DELBLACK"
  def code(globalVars, formVars, menu, element):
    #Rimuovo un utente dalla black list:
    waitMessage(globalVars, formVars, globalVars.get("messages").GM_WAIT)
    globalVars.get("net").removeFromBlackList(formVars.get("blackList").getElement(formVars.get("blackList").selected).data.name, removeFromBlackListCallback)

    #Nascondo il selector:
    menu.getGraphicElement("MENU_SELECTOR_LEFT").visible = False

    #Messaggio di attesa:
    waitMessage(globalVars, formVars, globalVars.get("messages").GM_WAIT)
  tElement.trigger_select = code
  pMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").GM_CLOSE
  tElement.helpText = globalVars.get("messages").GM_CLOSEH
  tElement.icon = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_logout.png')
  tElement.value = "CLOSE"
  tElement.trigger_select = pMenu.trigger_cancel
  pMenu.elements.append(tElement)

  pMenu.selected = pMenu.elements[0].value

  formVars.set(pMenu, "formMenu")
  if not formVars.get("playerMenuCreated"):
    formVars.get("formMenu").createGraphicElements("RIGHT")
    formVars.set(True, "playerMenuCreated")
  else:
    formVars.get("formMenu").createGraphicElements()


def hidePlayerMenu():
  #Hide player menu:
  formVars.set(False, "playerMenuCreated")
  formVars.set("LIST", "status")
  formVars.get("formMenu").delGraphics()

  formVars.set(formVars.get("blackList"), "formMenu")
  sel = formVars.get("formMenu").getGraphicElement("MENU_SELECTOR_RIGHT")
  if sel:
    sel.visible = True
  globalVars.set(None, "message")


def playerInfoCallback(pResponse, pError):
  #Visualizzo le informazioni del giocatore:
  if pError:
    waitMessage(globalVars, formVars, pError[1][1], False, 10)
    return

  response = functions.analyzeServerString(pResponse)
  if len(response) > 0:
    graph = formGraphics.get("PLAYER_INFO")
    if not graph:
      return
    posX = 5
    posY = 5
    tHeight = functions.textHeight(globalVars.get("fonts").get("fontMenu"), "I")
    elementImage = eval("globalVars.get(\"images\").get(\"element" + response[9].title() + "Image\")")
    graph.image.blit(elementImage, 0, 0, elementImage.width, elementImage.height, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), globalVars.get("messages").GM_NAME + " "), posY + 0 * tHeight, True)
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), globalVars.get("messages").GM_NAME + " ") + elementImage.width, posY + 0 * tHeight, response[0])
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), globalVars.get("messages").GM_STATUS + " "), posY + 1 * tHeight, eval("globalVars.get(\"messages\").GM_STATUS_" + response[1][:1]))
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), globalVars.get("messages").GM_LANG + " "), posY + 2 * tHeight, response[2])
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), globalVars.get("messages").GM_SYSTEM + " "), posY + 3 * tHeight, response[7])
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), globalVars.get("messages").GM_VERSION + " "), posY + 4 * tHeight, response[8])
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), globalVars.get("messages").GM_PLAY + " "), posY + 5 * tHeight, response[3])
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, 60 - functions.textWidth(globalVars.get("fonts").get("fontMenu"), response[4]), posY + 7 * tHeight, str(response[4]))
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, 60 * 2 - functions.textWidth(globalVars.get("fonts").get("fontMenu"), response[6]), posY + 7 * tHeight, str(response[6]))
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, 60 * 3 - functions.textWidth(globalVars.get("fonts").get("fontMenu"), response[5]), posY + 7 * tHeight, str(response[5]))


def removeFromBlackListCallback(pResponse, pError):
  #Rimuovo l'utente alla black list:
  if pError:
    waitMessage(globalVars, formVars, pError[1][1], False, 10)
    return

  #Tolgo l'utente dalla blacklist:
  formVars.get("formMenu").getGraphicElement("MENU_SELECTOR_LEFT").visible = True
  hideWaitMessage(globalVars, formVars)
  formVars.get("blackList").elements.remove(formVars.get("blackList").getElement(formVars.get("blackList").getSelected().data.name))
  formVars.get("blackList").firstVisible = None
  formVars.get("blackList").lastVisible = None
  formVars.get("blackList").selectFirstElement()
  formVars.get("blackList").createGraphicElements()
  hidePlayerMenu()


def button_down(pbuttons):
  #Gestione tasti form di gioco:
  if formVars.get("status") == "PLAYER_INFO":
    #Nascondo le informazioni del giocatore:
    globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingSound")
    globalVars.get("playingSound").start()
    delGraphic(formGraphics, "PLAYER_INFO")
    formVars.set(formVars.get("playerMenu"), "formMenu")
    formVars.get("formMenu").createGraphicElements()
    formVars.set("PLAYER_MENU", "status")
    return True
