#    Triple Triad PSP
#    Copyright (C) 2006, 2007 Sakya
#    sakya_tg@yahoo.it
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
import psp2d
from core import functions, animation, graphicElement, dataStore, menu, menuElement, buttons, TTplayer
from formsFunction import *

"""Form buddylist"""
formGraphics = dataStore()
formVars = dataStore()
formVars.set(formGraphics, "formGraphics")
globalVars = None

def init(pGlobalVars, pParams):
  global formVars, globalVars, formGraphics

  formGraphics = dataStore()
  formVars = dataStore()
  formVars.set(formGraphics, "formGraphics")
  globalVars = pGlobalVars

  formVars.set(psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_bg_buddylist.png'), "bkgImage")
  formVars.set('themes/' + globalVars.get("userData").THEME + '/gm_bg_buddylist.png', "bkgImageName")
  formVars.set(0, "bkgImagePosX")
  formVars.set(0, "bkgImagePosY")

  #Carico icone degli elementi:
  formVars.set(globalVars.get("elements"), "elements")

  formVars.set(False, "menuCreated")
  formVars.set(False, "playerMenuCreated")

  #Timer per buddylist:
  graph = graphicElement()
  graph.name = "UPDATE"
  anim = animation()
  def code(globalVars, formVars, target):
    if not target.data \
    or globalVars.get("currentFPSTime") - target.data >= 5:
      if target.visible:
        globalVars.get("net").myBuddyList(myBuddyListCallback)
        target.visible = False
      target.data = globalVars.get("currentFPSTime")
  anim.name = graph.name
  anim.lockKeyboard = False
  anim.code = code
  graph.animation = anim
  formGraphics.set(graph)

  #Titolo:
  graph = graphicElement()
  graph.name = "TITLE"
  graph.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_bg_title.png')
  graph.posX = -476
  graph.posY = 2
  anim = animation()
  anim.name = graph.name
  anim.data = [2, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)

  graph = graphicElement()
  graph.name = "TITLET"
  graph.font = globalVars.get("fonts").get("fontTitle")
  graph.posY = 4
  graph.text = globalVars.get("messages").GM_BUDDYLIST_TITLE
  graph.posX = -functions.textWidth(graph.font, graph.text)
  anim = animation()
  anim.name = graph.name
  anim.data = [(480 - functions.textWidth(graph.font, graph.text)) / 2, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)

  #Messaggi:
  formGraphics.set(createMessagesGE(globalVars, formVars))

  #Buddy list
  buddyList = menu(formGraphics, pGlobalVars, formVars)
  buddyList.name = "BUDDY_LIST"
  buddyList.menuHeight = 200
  buddyList.menuWidth = 200
  buddyList.background_image =  psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_bg_200x200.png')
  buddyList.posX = 2
  buddyList.posY = 41
  buddyList.selector = "RIGHT"
  buddyList.menuAlignment = "LEFT"
  def code(globalVars, formVars, menu, element):
    #Torno al gioco:
    formVars.remove("elements", False)
    globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingSound")
    globalVars.get("playingSound").start()
    globalVars.get("net").changeStatus("N")
    globalVars.set(["RESTORE"], "formParams")
    globalVars.set("mdlGame", "formName")
    globalVars.set("YES", "breakLoop")

  buddyList.trigger_cancel = code
  formVars.set(buddyList, "buddyList")
  formVars.set(buddyList, "formMenu")

  #Player menu:
  playerMenu = menu(formGraphics, pGlobalVars, formVars)
  playerMenu.name = "PLAYER_MENU"
  playerMenu.menuWidth = 200
  playerMenu.menuHeight = 110
  playerMenu.background_image =  psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_bg_playermenu.png')
  playerMenu.posX = buddyList.posX + buddyList.menuWidth + 2
  playerMenu.menuAlignment = "RIGHT"
  playerMenu.menuVAlignment = "CENTER"
  playerMenu.selector = "LEFT"
  formVars.set(playerMenu, "playerMenu")

  formVars.set("LIST", "status")


def myBuddyListCallback(pResponse, pError):
  """Update buddy list"""
  formGraphics.get("UPDATE").visible = True
  functions.waitSafeMenu(formVars.get("buddyList"))
  if pError:
    waitMessage(globalVars, formVars, pError[1][1], False, 10)
    return

  response = functions.analyzeServerString(pResponse)
  formVars.get("buddyList").creating = True
  formVars.get("buddyList").elements = []
  globalVars.get("buddyList")
  for b in response:
    player = TTplayer()
    cb = b.split("||")
    if len(cb) >= 5:
      player.name = cb[0]
      player.city = int(cb[2])
      #Descrizione citta':
      player.cityDescription = ""
      for tCity in globalVars.get("cityList"):
        if tCity.cityID == player.city:
          player.cityDescription = tCity.name
          break
      player.location = int(cb[3])
      player.status = cb[4]
      tElement = menuElement()
      tElement.data = player
      tElement.value = player.name
      tElement.text = player.name
      tElement.icon = getStatusIcon(globalVars, player.status)
      def code(globalVars, formVars, menu, element):
        #Apro il player menu:
        globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
        globalVars.get("playingSound").start()
        showPlayerMenu()
      tElement.trigger_select = code
      globalVars.get("buddyList").append(player.name)
      formVars.get("buddyList").elements.append(tElement)

  if not formVars.get("buddyList").selected and len(formVars.get("buddyList").elements) > 0:
    if formVars.get("buddyList").firstVisible:
      formVars.get("buddyList").selected = formVars.get("buddyList").firstVisible.value
    else:
      formVars.get("buddyList").selected = formVars.get("buddyList").elements[0].value

  if not formVars.get("menuCreated"):
    formVars.set(True, "menuCreated")
    formVars.get("buddyList").createGraphicElements("BOTTOM")
  else:
    formVars.get("buddyList").createGraphicElements()

  if formVars.get("status") == "LIST":
    sel = formVars.get("buddyList").getGraphicElement("MENU_SELECTOR_RIGHT")
    if sel:
      sel.visible = True
  formVars.get("buddyList").creating = False


def showPlayerMenu():
  #Cambio stato alla form:
  formVars.set("PLAYER", "status")

  #Salvo gli oggetti grafici del menu:
  if formVars.get("formMenu").name != "PLAYERMENU":
    formVars.get("formMenu").getGraphicElement("MENU_SELECTOR_RIGHT").visible = False

  posY = formVars.get("buddyList").getGraphicElement("MENU_SELECTOR_RIGHT").posY
  formVars.get("buddyList").getGraphicElement("MENU_SELECTOR_RIGHT").visible = False

  #Cambio menu:
  pMenu = formVars.get("playerMenu")
  pMenu.elements = []

  if posY + pMenu.menuHeight > 247:
    posY = 247 - pMenu.menuHeight
  pMenu.posY = posY

  tElement = menuElement()
  tElement.text = globalVars.get("messages").GM_INFO
  tElement.helpText = globalVars.get("messages").GM_INFOH
  tElement.icon = globalVars.get("iconUserInfo")
  tElement.value = "INFO"
  def code(globalVars, formVars, menu, element):
    formVars.set("PLAYER_INFO", "status")
    menu.delGraphics()
    formVars.set(None, "formMenu")

    #Informazioni sul giocatore:
    globalVars.set(None, "message")
    graph = graphicElement()
    graph.name = "PLAYER_INFO"
    graph.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_bg_budplayerinfo.png')

    posX = 5
    posY = 5
    tHeight = functions.textHeight(globalVars.get("fonts").get("fontMenu"), "I")
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 0 * tHeight, globalVars.get("messages").GM_NAME)
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 1 * tHeight, globalVars.get("messages").GM_STATUS)
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 2 * tHeight, globalVars.get("messages").GM_LANG)
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 3 * tHeight, globalVars.get("messages").GM_SYSTEM)
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 4 * tHeight, globalVars.get("messages").GM_VERSION)
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 5 * tHeight, globalVars.get("messages").GM_PLAY)
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, 60 - functions.textWidth(globalVars.get("fonts").get("fontMenuSel"), globalVars.get("messages").GM_WIN), posY + 6 * tHeight, globalVars.get("messages").GM_WIN)
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, 60 * 2 - functions.textWidth(globalVars.get("fonts").get("fontMenuSel"), globalVars.get("messages").GM_DRAW), posY + 6 * tHeight, globalVars.get("messages").GM_DRAW)
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, 60 * 3 - functions.textWidth(globalVars.get("fonts").get("fontMenuSel"), globalVars.get("messages").GM_LOSE), posY + 6 * tHeight, globalVars.get("messages").GM_LOSE)
    if formVars.get("buddyList").getSelected().data.status != "O":
      globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 8 * tHeight, globalVars.get("messages").GM_NOWIN)

    tX = formVars.get("playerMenu").posX
    tY = formVars.get("playerMenu").posY + formVars.get("playerMenu").menuHeight - graph.image.height
    graph.posX = 480
    graph.posY = tY
    anim = animation()
    anim.name = graph.name
    anim.data = [tX, tY, 99]
    anim.code = functions.moveFromTo
    graph.animation = anim
    menu.formGraphics.set(graph)
    globalVars.get("net").playerInfo(formVars.get("buddyList").getSelected().data.name, playerInfoCallback)

  tElement.trigger_select = code
  pMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").GM_MESSAGE
  tElement.helpText = globalVars.get("messages").GM_MESSAGEH
  tElement.icon = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_replymessage.png')
  tElement.value = "SEND_MSG"
  def code(globalVars, formVars, menu, element):
    #Scrivo un nuovo messaggio:
    globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
    globalVars.get("playingSound").start()
    globalVars.set("mdlNewMessage", "formName")
    globalVars.set([formVars.get("buddyList").getSelected().data.name, "", "mdlBuddyList", None], "formParams")
    globalVars.set("YES", "breakLoop")
  tElement.trigger_select = code
  pMenu.elements.append(tElement)

  sel = formVars.get("buddyList").getSelected().data
  if sel.status != "O" \
  and (sel.city != globalVars.get("player").city \
  or sel.location != globalVars.get("player").location):
    tElement = menuElement()
    tElement.text = globalVars.get("messages").GM_JOINBUDDY
    tElement.helpText = globalVars.get("messages").GM_JOINBUDDYH + " " + sel.cityDescription
    tElement.icon = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_join.png')
    tElement.value = "JOIN"
    def code(globalVars, formVars, menu, element):
      #Raggiungo il buddy:
      globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
      globalVars.get("playingSound").start()
      sel = formVars.get("buddyList").getSelected().data
      waitMessage(globalVars, formVars, globalVars.get("messages").GM_CHANGINGCITY + " " + sel.cityDescription)
      globalVars.get("net").enterLocation(sel.city, sel.location, enterLocationCallback)
    tElement.trigger_select = code
    pMenu.elements.append(tElement)

   #Chiudo il menu con cerchio:
  def code(globalVars, formVars, menu, element):
    globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingSound")
    globalVars.get("playingSound").start()
    hidePlayerMenu()
  pMenu.trigger_cancel = code

  tElement = menuElement()
  tElement.text = globalVars.get("messages").GM_DELBUDDY
  tElement.icon = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_delbuddy.png')
  tElement.helpText = globalVars.get("messages").GM_DELBUDDYH
  tElement.value = "DELBUDDY"
  def code(globalVars, formVars, menu, element):
    #Rimuovo un utente dalla buddy list:
    waitMessage(globalVars, formVars, globalVars.get("messages").GM_WAIT)
    globalVars.get("net").removeFromBuddyList(formVars.get("buddyList").getElement(formVars.get("buddyList").selected).data.name, removeFromBuddyListCallback)

    #Nascondo il selector:
    menu.getGraphicElement("MENU_SELECTOR_LEFT").visible = False

    #Messaggio di attesa:
    waitMessage(globalVars, formVars, globalVars.get("messages").GM_WAIT)
  tElement.trigger_select = code
  pMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").GM_CLOSE
  tElement.helpText = globalVars.get("messages").GM_CLOSEH
  tElement.icon = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_logout.png')
  tElement.value = "CLOSE"
  tElement.trigger_select = pMenu.trigger_cancel
  pMenu.elements.append(tElement)

  pMenu.selected = pMenu.elements[0].value

  formVars.set(pMenu, "formMenu")
  if not formVars.get("playerMenuCreated"):
    pMenu.createGraphicElements("RIGHT")
    formVars.set(True, "playerMenuCreated")
  else:
    pMenu.createGraphicElements()


def hidePlayerMenu():
  #Hide player menu:
  formVars.set(False, "playerMenuCreated")
  formVars.set("LIST", "status")
  formVars.get("formMenu").delGraphics()

  formVars.set(formVars.get("buddyList"), "formMenu")
  sel = formVars.get("formMenu").getGraphicElement("MENU_SELECTOR_RIGHT")
  if sel:
    sel.visible = True
  globalVars.set(None, "message")


def playerInfoCallback(pResponse, pError):
  #Visualizzo le informazioni del giocatore:
  if pError:
    waitMessage(globalVars, formVars, pError[1][1], False, 10)
    return

  response = functions.analyzeServerString(pResponse)
  if len(response) > 0:
    graph = formGraphics.get("PLAYER_INFO")
    if not graph:
      return
    posX = 5
    posY = 5
    tHeight = functions.textHeight(globalVars.get("fonts").get("fontMenu"), "I")
    elementImage = eval("globalVars.get(\"images\").get(\"element" + response[9].title() + "Image\")")
    graph.image.blit(elementImage, 0, 0, elementImage.width, elementImage.height, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), globalVars.get("messages").GM_NAME + " "), posY + 0 * tHeight, True)
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), globalVars.get("messages").GM_NAME + " ") + elementImage.width, posY + 0 * tHeight, response[0])
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), globalVars.get("messages").GM_STATUS + " "), posY + 1 * tHeight, eval("globalVars.get(\"messages\").GM_STATUS_" + response[1][:1]))
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), globalVars.get("messages").GM_LANG + " "), posY + 2 * tHeight, response[2])
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), globalVars.get("messages").GM_SYSTEM + " "), posY + 3 * tHeight, response[7])
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), globalVars.get("messages").GM_VERSION + " "), posY + 4 * tHeight, response[8])
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), globalVars.get("messages").GM_PLAY + " "), posY + 5 * tHeight, response[3])
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, 60 - functions.textWidth(globalVars.get("fonts").get("fontMenu"), response[4]), posY + 7 * tHeight, str(response[4]))
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, 60 * 2 - functions.textWidth(globalVars.get("fonts").get("fontMenu"), response[6]), posY + 7 * tHeight, str(response[6]))
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, 60 * 3 - functions.textWidth(globalVars.get("fonts").get("fontMenu"), response[5]), posY + 7 * tHeight, str(response[5]))
    if formVars.get("buddyList").getSelected().data.status != "O":
      globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), globalVars.get("messages").GM_NOWIN + " "), posY + 8 * tHeight, formVars.get("buddyList").getSelected().data.cityDescription)


def removeFromBuddyListCallback(pResponse, pError):
  #Rimuovo l'utente alla buddy list:
  if pError:
    waitMessage(globalVars, formVars, pError[1][1], False, 10)
    return

  response = functions.analyzeServerString(pResponse)
  #Tolgo l'utente dalla buddylist
  formVars.get("formMenu").getGraphicElement("MENU_SELECTOR_LEFT").visible = True
  hideWaitMessage(globalVars, formVars)
  if response[0] == "REMOVE":
    formVars.get("buddyList").elements.remove(formVars.get("buddyList").getElement(response[1]))
    formVars.get("buddyList").firstVisible = None
    formVars.get("buddyList").lastVisible = None
    formVars.get("buddyList").selectFirstElement()
    formVars.get("buddyList").createGraphicElements()
    hidePlayerMenu()


def enterLocationCallback(pResponse, pError):
  """Change city"""
  if pError:
    waitMessage(globalVars, formVars, pError[1][1], False, 10)
    return

  response = functions.analyzeServerString(pResponse)
  if response[0] == "OK":
    formVars.remove("elements", False)
    globalVars.get("net").changeStatus("N")
    globalVars.set(int(response[1]), "newCity")
    globalVars.set(int(response[2]), "newLocation")
    globalVars.set(["RESTORE"], "formParams")
    globalVars.set("mdlGame", "formName")
    globalVars.set("YES", "breakLoop")


def button_down(pbuttons):
  #Gestione tasti form di gioco:
  if formVars.get("status") == "PLAYER_INFO":
    #Nascondo le informazioni del giocatore:
    globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingSound")
    globalVars.get("playingSound").start()
    delGraphic(formGraphics, "PLAYER_INFO")
    formVars.set(formVars.get("playerMenu"), "formMenu")
    formVars.get("formMenu").createGraphicElements()
    formVars.set("PLAYER_MENU", "status")
    return True
