#    Triple Triad PSP
#    Copyright (C) 2006, 2007 Sakya
#    sakya_tg@yahoo.it
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
import psp2d
from core import graphicElement, dataStore, animation, functions, buttons
from formsFunction import *

formGraphics = dataStore()
formVars = dataStore()
formVars.set(formGraphics, "formGraphics")
globalVars = None

"""Form Credits"""
def init(pGlobalVars, pParams):
  global formVars, globalVars, formGraphics

  formGraphics = dataStore()
  formVars = dataStore()
  formVars.set(formGraphics, "formGraphics")
  globalVars = pGlobalVars

  formVars.set(0, "data")
  lang = globalVars.get("userData").LANG
  theme = globalVars.get("userData").THEME

  formVars.set(psp2d.Image('themes/' + globalVars.get("userData").THEME + '/backgroundcredits.png'), "bkgImage")
  formVars.set(0, "bkgImagePosX")
  formVars.set(0, "bkgImagePosY")

  #Versione:
  graph = graphicElement()
  graph.name = "VERSION"
  graph.font = globalVars.get("fonts").get("fontMenu")
  graph.text = "Vers. " + globalVars.get("version")
  graph.posX = 480 - functions.textWidth(globalVars.get("fonts").get("fontMenu"), graph.text) - 5
  graph.posY = 1
  formGraphics.set(graph)

  #Credits:
  graph = graphicElement()
  graph.name = "CREDITS"
  graph.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_credits.png')
  graph.bufferImage = psp2d.Image(graph.image)
  graph.posX = -300
  graph.posY = 20
  anim = animation()
  anim.name = "CREDITS"
  anim.data = [20, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)

  posX = 5
  posY = 10
  tHeight = functions.textHeight(globalVars.get("fonts").get("fontMenu"), "I")
  globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 0 * (tHeight + 2), "Triple Triad Team:")
  globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 1 * (tHeight + 2), "Coding:")
  globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), "Coding:") + 10, posY + 1 * (tHeight + 2), "Sakya")
  globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 2 * (tHeight + 2), "Server side:")
  globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), "Server side:") + 10, posY + 2 * (tHeight + 2), "Zero-One")
  globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 3 * (tHeight + 2), "Graphics:")
  globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), "Graphics:") + 10, posY + 3 * (tHeight + 2), "Peoplechamp")
  globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), "Graphics:") + 10, posY + 4 * (tHeight + 2), "Nedra")
  globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), "Graphics:") + 10, posY + 5 * (tHeight + 2), "Leviadragon")
  globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), "Graphics:") + 10, posY + 6 * (tHeight + 2), "Sephzero")

  globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 8 * (tHeight + 2), "http://www.psp-ita.com/tt")

  globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 10 * (tHeight + 2), "Triple Triad PSP is not licensed")
  globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 11 * (tHeight + 2), "or endorsed by Sony Computer")
  globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 12 * (tHeight + 2), "Entertainments or Square Enix.")


def button_down(pbuttons):
  graph = formGraphics.get("CREDITS")
  if formVars.get("data") == 1:
    #Animazione di uscita:
    anim = animation()
    anim.name = "CREDITS"
    anim.priority = -100
    anim.exclusive = True
    anim.data = [-graph.image.width, graph.posY, 99]
    anim.code = functions.moveFromTo
    graph.animation = anim

    #Passo al main menu
    graph = graphicElement()
    graph.name = "BACK_TO_MAIN"
    anim = animation()
    anim.name = graph.name
    anim.priority = -200
    def code(globalVars, formVars, target):
      globalVars.set("mdlMainMenu", "formName")
      globalVars.set(["CREDITS"], "formParams")
      globalVars.set("YES", "breakLoop")
      target.name = "DEL_" + target.name
    anim.code = code
    graph.animation = anim
    formGraphics.set(graph)
  else:
    #Animazione di uscita:
    anim = animation()
    anim.name = "CREDITS"
    anim.exclusive = True
    anim.data = [-350, graph.posY, 99]
    anim.code = functions.moveFromTo
    graph.animation = anim

    #Cambio il testo e rientro:
    graph = graphicElement()
    graph.name = "CHANGE_TEXT"
    anim = animation()
    anim.name = graph.name
    anim.priority = -200
    def code(globalVars, formVars, target):
      graph = formVars.get("formGraphics").get("CREDITS")
      graph.image = psp2d.Image(graph.bufferImage)
      posX = 5
      posY = 10
      tHeight = functions.textHeight(globalVars.get("fonts").get("fontMenu"), "I")
      globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 0 * (tHeight + 2), "Triple Triad Team wants to thank:")
      globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 1 * (tHeight + 2), "-PSP-ita's users and admins for support")
      globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 2 * (tHeight + 2), "-Fraca7 for the Python porting and for")
      globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 3 * (tHeight + 2), " his help.")
      globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 4 * (tHeight + 2), "-Crackiron, Hydra, Guigiz, Kej@, dawid999 for")
      globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 5 * (tHeight + 2), " translations")
      globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 6 * (tHeight + 2), "-Lacrie255 for help with graphics and")
      globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 7 * (tHeight + 2), " cards")
      globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 10 * (tHeight + 2), "Triple Triad PSP is not licensed")
      globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 11 * (tHeight + 2), "or endorsed by Sony Computer")
      globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 12 * (tHeight + 2), "Entertainments or Square Enix.")
      formVars.set(1, "data")

      anim = animation()
      anim.name = "CREDITS"
      anim.exclusive = True
      anim.data = [20, graph.posY, 99]
      anim.code = functions.moveFromTo
      graph.animation = anim

      target.name = "DEL_" + target.name
    anim.code = code
    graph.animation = anim
    formGraphics.set(graph)

  return True