#    Triple Triad PSP
#    Copyright (C) 2006, 2007 Sakya
#    sakya_tg@yahoo.it
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
from pickle import loads, dumps
import psp2d, pspsnd, pspnet, pspos
from core import graphicElement, dataStore, animation, functions, menu, menuElement, toolbar, buttons, city, helpItem, TTplayer, card
from formsFunction import *

class invite(object):
  def __init__(self):
    self.ID = None
    self.fromUserID = None
    self.fromUserName = None
    self.cityID = None
    self.locationID = None
    self.time = None
    self.toUserID = None
    self.toUserName = None
    self.expires = None
    self.roomID = None
    self.rules = None

"""Form Game"""
formGraphics = dataStore()
formVars = dataStore()
formVars.set(formGraphics, "formGraphics")

def init(pGlobalVars, pParams):
  global formVars, globalVars, formGraphics

  formGraphics = dataStore()
  formVars = dataStore()
  formVars.set(formGraphics, "formGraphics")
  globalVars = pGlobalVars

  #Controllo se sto tornando da un'altra form:
  restoreForm = False
  if pParams[0] == "RESTORE":
    restoreForm = True
    pType = globalVars.get("gameType")
    pPlayer = globalVars.get("player")
  else:
    pType = pParams[0]
    pPlayer = pParams[1]

  #Scarico background di default:
  globalVars.get("images").remove("defaultBkgImage")

  formVars.set("NORMAL", "listType")
  formVars.set([], "playerList")
  formVars.set(None, "playerListMenu")
  formVars.set(False, "menuCreated")

  #Operazioni di sola inizializzazione:
  if not restoreForm:
    #Aumento la velocita' del processore:
    pspos.setclock(300)
    pspos.setbus(150)

    globalVars.get("fonts").set(psp2d.Font('themes/' + globalVars.get("userData").THEME + '/font_servermsg.png'), "fontServerMsg")
    formVars.set(False, "downloadData")
    #Variabili globali (utili anche per le forms seguenti):
    globalVars.set(["LIGHT", "EARTH", "ICE", "WIND", "POISON", "FIRE", "WATER", "HOLY"], "elements")
    globalVars.set(pPlayer, "player")
    globalVars.set([], "buddyList")
    globalVars.set([], "blackList")
    globalVars.set(None, "newCity")
    globalVars.set(None, "newLocation")
    globalVars.set(pType, "gameType")
    globalVars.set([], "shopCards")
    globalVars.set([], "shopCardsIndex")
    globalVars.set([], "playerCards")
    globalVars.set([], "playerCardsIndex")
    globalVars.set([], "locationList")
    globalVars.set(psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_status_n.png'), "iconNormal")
    globalVars.set(psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_status_p.png'), "iconPlaying")
    globalVars.set(psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_status_m.png'), "iconMessaging")
    globalVars.set(psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_status_o.png'), "iconOffline")
    globalVars.set(psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_status_w.png'), "iconWorldMap")
    globalVars.set(psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_status_d.png'), "iconDeck")
    globalVars.set(psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_status_s.png'), "iconShopping")

    globalVars.set(psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_userinfo.png'), "iconUserInfo")
    globalVars.set(psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_status_d.png'), "iconChallenge")
    globalVars.set(psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_custommatch.png'), "iconCustom")

  #Toolbar menu:
  tMenu = menu(formGraphics, globalVars, formVars)
  tMenu.name = "TOOLBARMENU"
  tMenu.background_image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_bg_toolbarmenu.png')
  formVars.set(tMenu, "toolbarMenu")

  #Invites menu:
  tMenu = menu(formGraphics, globalVars, formVars)
  tMenu.name = "INVITESMENU"
  tMenu.graphicPriority = 200
  tMenu.background_image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_invite_menu.png')
  tMenu.data = []
  tMenu.menuWidth = 130
  tMenu.menuHeight = 100
  tMenu.posX = 2
  tMenu.posY = 60
  tMenu.menuAlignment = "LEFT"
  tMenu.menuVAlignment = "CENTER"
  tMenu.selector = "RIGHT"
  def code(globalVars, formVars, menu, element):
    hideInvitesMenu()
  tMenu.trigger_cancel = code
  formVars.set(tMenu, "invitesMenu")

  formVars.set(pspsnd.Sound("themes/" + globalVars.get("userData").THEME + "/gm_newmessage.wav"), "messageSound")
  formVars.set(globalVars.get("fonts").get("fontMenu"), "fontNormal")
  formVars.set(globalVars.get("fonts").get("fontMenuSel"), "fontBuddy")

  #Lista giocatori:
  createPlayerListMenu()
  formVars.set(formVars.get("playerListMenu").name, "status")

  #Shout menu:
  tMenu = menu(formGraphics, globalVars, formVars)
  tMenu.name = "SHOUTMENU"
  formVars.set(tMenu, "shoutMenu")

  #Player menu:
  tMenu = menu(formGraphics, globalVars, formVars)
  tMenu.name = "PLAYERMENU"
  tMenu.background_image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_bg_playermenu.png')
  tMenu.menuWidth = 200
  tMenu.menuHeight = 110
  tMenu.posX = formVars.get("playerListMenu").posX - tMenu.menuWidth - 2
  tMenu.menuAlignment = "RIGHT"
  tMenu.menuVAlignment = "CENTER"
  tMenu.selector = "LEFT"
  formVars.set(tMenu, "playerMenu")

  #Toolbar:
  createToolbar()

  #Messaggi:
  formGraphics.set(createMessagesGE(globalVars, formVars))

  #Help:
  setHelp()

  formVars.set(None, "oldServerMessages")

  #Operazioni di sola inizializzazione:
  if not restoreForm:
    #Chiedo la mia buddy list e blackList:
    globalVars.get("net").myBuddyList(myBuddyListCallback)
    globalVars.get("net").myBlackList(myBlackListCallback)

    #Chiedo le carte dello shop:
    globalVars.get("net").getAllCards(getAllCardsCallback)
    #Chiedo le mie carte:
    globalVars.get("net").getMyCards(getMyCardsCallback)
    #Chiedo il mio deck:
    globalVars.get("net").getMyDeck(getMyDeckCallback)
    #Chiedo i miei guil:
    globalVars.get("net").myMoney(myMoneyCallback)
    #Lista citta':
    globalVars.get("net").cityList(cityListCallback)
    #Lista location:
    globalVars.get("net").allLocationList(allLocationListCallback)

    waitMessage(globalVars, formVars, globalVars.get("messages").GM_DOWNLOADING + " [0%]")
    formGraphics.get("WAIT").data = [False, False]

  #Timer per controllare la connessione wifi:
  graph = graphicElement()
  graph.name = "CHECKAPCTL"
  anim = animation()
  def code(globalVars, formVars, target):
    if not target.data \
    or globalVars.get("currentFPSTime") - target.data >= 10:
      if target.visible:
        #Controllo lo switch:
        if not globalVars.get("net").wlanSwitchState():
          waitMessage(globalVars, formVars, globalVars.get("messages").WLAN_ERROR, False, 5)
        else:
          #Controllo la connessione:
          state = globalVars.get("net").getAPCTLState()
          def netCallback(state):
            if state == -1:
              waitMessage(globalVars, formVars, globalVars.get("messages").CONNECTED, False)
              formVars.get("formGraphics").get("CHECKAPCTL").visible = True
          if state != 4:
            #Tento la riconnessione:
            waitMessage(globalVars, formVars, globalVars.get("messages").GM_RECONNECTING, True)
            globalVars.get("net").connect(netCallback)
            target.visible = False
        target.data = globalVars.get("currentFPSTime")
  anim.name = graph.name
  anim.lockKeyboard = False
  anim.code = code
  graph.animation = anim
  globalVars.get("commonGraphics").set(graph)

  #Timer per mantenere la connessione:
  graph = graphicElement()
  graph.name = "REFRESH"
  graph.data = globalVars.get("currentFPSTime") + 60
  anim = animation()
  def code(globalVars, formVars, target):
    if not target.data \
    or globalVars.get("currentFPSTime") - target.data >= 120:
      globalVars.get("net").keepAlive()
      target.data = globalVars.get("currentFPSTime")
  anim.name = graph.name
  anim.lockKeyboard = False
  anim.code = code
  graph.animation = anim
  globalVars.get("commonGraphics").set(graph)

  #Messaggi generali del server:
  graph = graphicElement()
  graph.name = "SERVER_MESSAGES"
  graph.priority = -10
  graph.image = psp2d.Image(290, 150)
  graph.image.clear(psp2d.Color(0,0,0,80))
  graph.posX = -graph.image.width
  graph.posY = 80
  anim = animation()
  anim.name = graph.name
  anim.lockKeyboard = False
  anim.data = [5, graph.posY]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)
  
  #Se sono in restore rifaccio partire i timers:
  if restoreForm:
    waitMessage(globalVars, formVars, globalVars.get("messages").GM_WAIT)
    if globalVars.get("newCity"):
      changeLocation(globalVars.get("newCity"), globalVars.get("newLocation"), pNet=True)
      globalVars.set(None, "newCity")
      globalVars.set(None, "newLocation")
    initTimers()
  #Imposto lo sfondo:
  setBackground()


def setBackground():
  """Sets background image"""
  try:
    formVars.set(psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gb_' + str(globalVars.get("player").city).zfill(2)  + '_' + str(globalVars.get("player").location).zfill(2) + '.png'), "bkgImage")
    formVars.set('themes/' + globalVars.get("userData").THEME + '/gb_' + str(globalVars.get("player").city).zfill(2)  + '_' + str(globalVars.get("player").location).zfill(2) + '.png', "bkgImageName")
  except:
    formVars.set(psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gb_00_00.png'), "bkgImage")
    formVars.set('themes/' + globalVars.get("userData").THEME + '/gb_00_00.png', "bkgImageName")
  formVars.set(0, "bkgImagePosX")
  formVars.set(0, "bkgImagePosY")


def cityListCallback(pResponse, pError):
  """Loads city list"""
  if pError:
    if "TIMEOUT" in pError[1][1].upper():
      globalVars.get("net").cityList(cityListCallback)
    else:
      waitMessage(globalVars, formVars, pError[1][1], False, 10)
    return

  response = functions.analyzeServerString(pResponse)
  cityList = []
  for c in response:
    sub = c.split("||")
    if len(sub) >= 7:
      tCity = city()
      tCity.cityID = int(sub[0])
      tCity.region = sub[1]
      tCity.name = sub[2]
      tCity.description = sub[3]
      tCity.posX = int(sub[4])
      tCity.posY = int(sub[5])
      tCity.rules = sub[6]
      cityList.append(tCity)
  globalVars.set(cityList, "cityList")


def allLocationListCallback(pResponse, pError):
  """Loads complete location list"""
  if pError:
    if "TIMEOUT" in pError[1][1].upper():
      globalVars.get("net").allLocationList(allLocationListCallback)
    else:
      waitMessage(globalVars, formVars, pError[1][1], False, 10)
    return

  response = functions.analyzeServerString(pResponse)

  locationList = []
  for c in response:
    sub = c.split("||")
    if len(sub) >= 5:
      loc = city()
      loc.cityID = int(sub[0])
      loc.locationID = int(sub[1])
      loc.name = sub[2]
      loc.description = sub[3]
      loc.rules = sub[4]
      locationList.append(loc)
  globalVars.set(locationList, "locationList")
  updateWaitMessage(globalVars, formVars, globalVars.get("messages").GM_DOWNLOADING + " [100%]")
  endDownloadingData()


def playerListCallback(pResponse, pError):
  """Load the player list from the server response"""
  formGraphics.get("TIMER").visible = True
  if pError:
    waitMessage(globalVars, formVars, pError[1][1], False, 10)
    return

  response = functions.analyzeServerString(pResponse)
  playerList = []
  for p in response:
    cp = p.split("||")
    if len(cp) >= 3:
      tPlayer = TTplayer()
      tPlayer.name = cp[0]
      tPlayer.status = cp[1]
      if len(tPlayer.status) == 0:
        tPlayer.status = "N"
      tPlayer.ID = cp[2]
      tPlayer.cardSet = cardSet()
      playerList.append(tPlayer)
  formVars.set(playerList, "playerList")
  updatePlayerList()


def myBuddyListCallback(pResponse, pError):
  """Load the complete player buddylist"""
  if pError:
    if "TIMEOUT" in pError[1][1].upper():
      globalVars.get("net").myBuddyList(myBuddyListCallback)
    else:
      waitMessage(globalVars, formVars, pError[1][1], False, 10)
    return

  response = functions.analyzeServerString(pResponse)
  buddyList = []
  for p in response:
    buddyList.append(p.split("||")[0])
  globalVars.set(buddyList, "buddyList")
  graph = formGraphics.get("WAIT")
  graph.data[0] = True
  updateWaitMessage(globalVars, formVars, globalVars.get("messages").GM_DOWNLOADING + " [10%]")


def myBlackListCallback(pResponse, pError):
  """Load the complete player black list"""
  if pError:
    if "TIMEOUT" in pError[1][1].upper():
      globalVars.get("net").myBlackList(myBlackListCallback)
    else:
      waitMessage(globalVars, formVars, pError[1][1], False, 10)
    return

  response = functions.analyzeServerString(pResponse)
  blackList = []
  for p in response:
    blackList.append(p.split("||")[0])
  globalVars.set(blackList, "blackList")
  graph = formGraphics.get("WAIT")
  graph.data[1] = True
  updateWaitMessage(globalVars, formVars, globalVars.get("messages").GM_DOWNLOADING + " [20%]")


def initTimers():
  """After lists are loaded"""
  #Timer per lista giocatori:
  graph = graphicElement()
  graph.name = "TIMER"
  anim = animation()
  def code(globalVars, formVars, target):
    if not target.data \
    or globalVars.get("currentFPSTime") - target.data >= 5:
      if target.visible:
        globalVars.get("net").playerList(globalVars.get("player").city, globalVars.get("player").location, playerListCallback)
        target.visible = False
      target.data = globalVars.get("currentFPSTime")
  anim.name = graph.name
  anim.lockKeyboard = False
  anim.code = code
  graph.animation = anim
  formGraphics.set(graph)

  #Timer per inviti:
  graph = graphicElement()
  graph.name = "TIMER_INVITES"
  graph.data = globalVars.get("currentFPSTime")
  anim = animation()
  def code(globalVars, formVars, target):
    if not target.data \
    or globalVars.get("currentFPSTime") - target.data >= 5:
      if target.visible:
        globalVars.get("net").getInvites(getInvitesCallback)
        target.visible = False
      target.data = globalVars.get("currentFPSTime")
  anim.name = graph.name
  anim.lockKeyboard = False
  anim.code = code
  graph.animation = anim
  formGraphics.set(graph)

  #Timer per nuovi messaggi:
  graph = graphicElement()
  graph.name = "MYMESSAGES"
  graph.data = globalVars.get("currentFPSTime")
  anim = animation()
  def code(globalVars, formVars, target):
    if not target.data \
    or globalVars.get("currentFPSTime") - target.data >= 10:
      if target.visible:
        globalVars.get("net").myMessages(myMessagesCallback)
        target.visible = False
      target.data = globalVars.get("currentFPSTime")
  anim.name = graph.name
  anim.lockKeyboard = False
  anim.code = code
  graph.animation = anim
  formGraphics.set(graph)

  #Timer per messaggi location:
  graph = graphicElement()
  graph.name = "TIMER_LOCATIONMSG"
  graph.data = globalVars.get("currentFPSTime") - 5
  anim = animation()
  def code(globalVars, formVars, target):
    if not target.data \
    or globalVars.get("currentFPSTime") - target.data >= 10:
      if target.visible:
        globalVars.get("net").locationMessages(globalVars.get("player").location, locationMessagesCallback)
        target.visible = False
      target.data = globalVars.get("currentFPSTime")
  anim.name = graph.name
  anim.lockKeyboard = False
  anim.code = code
  graph.animation = anim
  formGraphics.set(graph)


def updatePlayerList():
  """Udpate player list"""
  functions.waitSafeMenu(formVars.get("playerListMenu"))

  tMenu = formVars.get("playerListMenu")
  sel = tMenu.selected
  firstV = tMenu.firstVisible
  lastV = tMenu.lastVisible
  tMenu.creating = True
  tMenu.elements = []
  tMenu.selected = None
  tMenu.firstVisible = None
  tMenu.lastVisible = None
  for player in formVars.get("playerList"):
    #Filtro giocatori senza nome (non dovrebbe succedere):
    if len(player.name) == 0:
      continue
    if tMenu.getElement(player.name):
      continue

    #Controllo il tipo di lista:
    if player.name in globalVars.get("blackList"):
      continue
    elif formVars.get("listType") == "BUDDY" and player.name not in globalVars.get("buddyList"):
      continue
    elif formVars.get("listType") == "FREE" and player.status != "N":
      continue

    tElement = menuElement()
    tElement.data = player
    tElement.icon = getStatusIcon(globalVars, player.status)
    tElement.text = player.name
    tElement.value = player.name
    #Font:
    buddy = False
    if tElement.value in globalVars.get("buddyList"):
      tElement.font = globalVars.get("fonts").get("fontBuddy")
    else:
      tElement.font = globalVars.get("fonts").get("fontNormal")

    if tElement.value == sel:
      tMenu.selected = sel
    if firstV and tElement.value == firstV.value:
      tMenu.firstVisible = tElement
    if lastV and tElement.value == lastV.value:
      tMenu.lastVisible = tElement
    #Azione su pressione tasto x:
    def code(globalVars, formVars, menu, element):
      if element.value not in globalVars.get("blackList"):
        globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
        globalVars.get("playingSound").start()
        showPlayerMenu()

    tElement.trigger_select = code
    tMenu.elements.append(tElement)

  if not tMenu.selected and len(tMenu.elements) > 0:
    if tMenu.firstVisible:
      tMenu.selected = tMenu.firstVisible.value
    else:
      tMenu.selectFirstElement()

  if not formVars.get("menuCreated"):
    formVars.set(True, "menuCreated")
    hideWaitMessage(globalVars, formVars)
    tMenu.createGraphicElements("RIGHT")
    formVars.set(formVars.get("playerListMenu"), "formMenu")
  else:
    tMenu.createGraphicElements()

  #Aggiorno a video:
  if formVars.get("status") != tMenu.name:
    sel = tMenu.getGraphicElement("MENU_SELECTOR_RIGHT")
    if sel:
      sel.visible = False
  else:
    if len(tMenu.elements) > 0:
      tMenu.getGraphicElement("MENU_SELECTOR_RIGHT").visible = True
  tMenu.creating = False


def createPlayerListMenu():
  #Creo il menu della llista dei giocatori:
  pList = menu(formGraphics, globalVars, formVars)
  pList.background_image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_bg_playerlist.png')
  pList.name = "PLAYERLIST"
  pList.posX = 310
  pList.posY = 28
  pList.menuWidth = 168
  pList.menuHeight = 218
  pList.menuAlignment = "LEFT"
  pList.menuVAlignment = "CENTER"
  pList.selector = "RIGHT"
  formVars.set(pList, "playerListMenu")
  formVars.set(pList, "formMenu")


def showPlayerMenu():
  #Cambio stato alla form:
  formVars.set(formVars.get("playerMenu").name, "status")

  #Salvo gli oggetti grafici del menu:
  tMenu = formVars.get("playerListMenu")
  if formVars.get("formMenu").name != "PLAYERMENU":
    tMenu.getGraphicElement("MENU_SELECTOR_RIGHT").visible = False

  posY = tMenu.getGraphicElement("MENU_SELECTOR_RIGHT").posY
  tMenu.getGraphicElement("MENU_SELECTOR_RIGHT").visible = False

  tMenu = formVars.get("playerMenu")
  tMenu.clear()
  tMenu.background_image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_bg_playermenu.png')
  tMenu.menuWidth = 200
  tMenu.menuHeight = 110
  tMenu.posX = formVars.get("playerListMenu").posX - tMenu.menuWidth - 2
  tMenu.menuAlignment = "RIGHT"
  tMenu.menuVAlignment = "CENTER"
  tMenu.selector = "LEFT"

  #Cambio menu:
  graph = formGraphics.get("MESSAGES")
  if posY + tMenu.menuHeight > graph.posY - 2:
    posY = graph.posY - tMenu.menuHeight - 2
  tMenu.posY = posY

  tMenu.elements = []
  #Elementi menu giocatore:
  tElement = menuElement()
  tElement.text = globalVars.get("messages").GM_INFO
  tElement.helpText = globalVars.get("messages").GM_INFOH
  tElement.icon = globalVars.get("iconUserInfo")
  tElement.value = "INFO"
  def code(globalVars, formVars, menu, element):
    formVars.set("PLAYER_INFO", "status")
    formVars.get("formMenu").delGraphics()
    formVars.set(None, "formMenu")
    #Informazioni sul giocatore:
    globalVars.set(None, "message")
    graph = graphicElement()
    graph.name = "PLAYER_INFO"
    graph.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_bg_playerinfo.png')
    posX = 5
    posY = 2
    tHeight = functions.textHeight(globalVars.get("fonts").get("fontMenuSel"), "I")
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 0 * tHeight, globalVars.get("messages").GM_NAME)
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 1 * tHeight, globalVars.get("messages").GM_STATUS)
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 2 * tHeight, globalVars.get("messages").GM_LANG)
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 3 * tHeight, globalVars.get("messages").GM_SYSTEM)
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 4 * tHeight, globalVars.get("messages").GM_VERSION)
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 5 * tHeight, globalVars.get("messages").GM_PLAY)
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, 60 - functions.textWidth(globalVars.get("fonts").get("fontMenuSel"), globalVars.get("messages").GM_WIN), posY + 6 * tHeight, globalVars.get("messages").GM_WIN)
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, 60 * 2 - functions.textWidth(globalVars.get("fonts").get("fontMenuSel"), globalVars.get("messages").GM_DRAW), posY + 6 * tHeight, globalVars.get("messages").GM_DRAW)
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, 60 * 3 - functions.textWidth(globalVars.get("fonts").get("fontMenuSel"), globalVars.get("messages").GM_LOSE), posY + 6 * tHeight, globalVars.get("messages").GM_LOSE)

    tX = formVars.get("playerMenu").posX + formVars.get("playerMenu").menuWidth - graph.image.width
    tY = formVars.get("playerMenu").posY + formVars.get("playerMenu").menuHeight - graph.image.height
    graph.posX = -graph.image.width
    graph.posY = tY
    anim = animation()
    anim.name = graph.name
    anim.data = [tX, tY, 99]
    anim.code = functions.moveFromTo
    graph.animation = anim
    menu.formGraphics.set(graph)
    globalVars.get("net").playerInfo(formVars.get("playerListMenu").getSelected().data.name, playerInfoCallback)

  tElement.trigger_select = code
  tMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").GM_MESSAGE
  tElement.helpText = globalVars.get("messages").GM_MESSAGEH
  tElement.icon = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_replymessage.png')
  tElement.value = "SEND_MSG"
  def code(globalVars, formVars, menu, element):
    #Scrivo un nuovo messaggio:
    globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingsound")
    globalVars.get("playingsound").start()
    globalVars.get("net").changeStatus("M")
    globalVars.set("mdlNewMessage", "formName")
    globalVars.set([formVars.get("playerListMenu").getSelected().data.name, "NEW_MSG", "mdlGame", ["RESTORE"]], "formParams")
    globalVars.set("YES", "breakLoop")
    preExitForm()
  tElement.trigger_select = code
  tMenu.elements.append(tElement)

  #Controllo se e' gia' nella lista:
  if formVars.get("playerListMenu").selected not in globalVars.get("buddyList"):
    tElement = menuElement()
    tElement.text = globalVars.get("messages").GM_ADDBUDDY
    tElement.icon = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_addbuddy.png')
    tElement.helpText = globalVars.get("messages").GM_ADDBUDDYH
    tElement.value = "ADDBUDDY"
    def code(globalVars, formVars, menu, element):
      #Aggiungo un utente alla buddy list:
      globalVars.get("net").addToBuddyList(formVars.get("playerListMenu").getSelected().data.name, addToBuddyListCallback)
      #Nascondo il selector:
      menu.getGraphicElement("MENU_SELECTOR_LEFT").visible = False
      #Messaggio di attesa:
      waitMessage(globalVars, formVars, globalVars.get("messages").GM_WAIT)

    tElement.trigger_select = code
    tMenu.elements.append(tElement)
    tElement = menuElement()
    tElement.text = globalVars.get("messages").GM_ADDBLACK
    tElement.icon = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_addblack.png')
    tElement.helpText = globalVars.get("messages").GM_ADDBLACKH
    tElement.value = "ADDBLACK"
    def code(globalVars, formVars, menu, element):
      #Aggiungo un utente alla black list:
      globalVars.get("net").addToBlackList(formVars.get("playerListMenu").getSelected().data.name, addToBlackListCallback)
      #Nascondo il selector:
      menu.getGraphicElement("MENU_SELECTOR_LEFT").visible = False
      #Messaggio di attesa:
      waitMessage(globalVars, formVars, globalVars.get("messages").GM_WAIT)

    tElement.trigger_select = code
    tMenu.elements.append(tElement)
  else:
    tElement = menuElement()
    tElement.text = globalVars.get("messages").GM_DELBUDDY
    tElement.icon = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_delbuddy.png')
    tElement.helpText = globalVars.get("messages").GM_DELBUDDYH
    tElement.value = "DELBUDDY"
    def code(globalVars, formVars, menu, element):
      #Rimuovo un utente dalla buddy list:
      globalVars.get("net").removeFromBuddyList(formVars.get("playerListMenu").getSelected().data.name, removeFromBuddyListCallback)
      #Nascondo il selector:
      menu.getGraphicElement("MENU_SELECTOR_LEFT").visible = False
      #Messaggio di attesa:
      waitMessage(globalVars, formVars, globalVars.get("messages").GM_WAIT)

    tElement.trigger_select = code
    tMenu.elements.append(tElement)

  if formVars.get("playerListMenu").getSelected().data.status[0] == "N":
    tElement = menuElement()
    tElement.text = globalVars.get("messages").GM_CHALLENGE
    tElement.icon = globalVars.get("iconChallenge")
    tElement.helpText = globalVars.get("messages").GM_CHALLENGEH
    tElement.value = "CHALLENGE"

    def code(globalVars, formVars, menu, element):
      #Controllo le carte:
      totCards = len(globalVars.get("playerCardsIndex"))
      for card in globalVars.get("player").deck:
        if card:
          totCards += 1
      if totCards < 5:
        waitMessage(globalVars, formVars, globalVars.get("messages").GM_NOTENOUGHCARDS, False, 3)
        return
      #Chiedo conferma della sfida:
      graph = graphicElement()
      graph.name = "CONFIRM"
      graph.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_confirmch_title.png')
      text = globalVars.get("messages").GM_CONFIRMCHALLENGE + " " + menu.formVars.get("playerListMenu").selected + "?"
      globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, (graph.image.width - functions.textWidth(globalVars.get("fonts").get("fontMenuSel"), text)) / 2, 2, text)
      graph.posX = menu.posX - 1
      graph.posY = menu.posY
      menu.formGraphics.set(graph)

      globalVars.set(globalVars.get("sounds").get("menuSelectSound") , "playingSound")
      globalVars.get("playingSound").start()

      tMenu = formVars.get("formMenu")
      tMenu.delGraphics()
      tMenu = confirm(globalVars, formVars, formGraphics, tMenu.menuWidth, tMenu.menuHeight - graph.image.height, tMenu.posX, tMenu.posY + graph.image.height + 1)
      tMenu.name = "CONFIRMCHALLENGE"
      tMenu.background_image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_bg_playermenu.png')
      def code(globalVars, formVars, menu, element):
        #Chiudo il menu:
        globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingsound")
        globalVars.get("playingsound").start()
        delGraphic(formGraphics, "CONFIRM")
        menu.delGraphics()
        showPlayerMenu()
      tMenu.elements[1].trigger_select = code
      tMenu.trigger_cancel = code
      def code(globalVars, formVars, menu, element):
        #Lancio la sfida:
        globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingsound")
        globalVars.get("playingsound").start()
        globalVars.get("net").sendInvite(formVars.get("playerListMenu").getSelected().data.ID, None, None)
        delGraphic(formGraphics, "CONFIRM")
        menu.delGraphics()
        hidePlayerMenu()
      tMenu.elements[0].trigger_select = code

      formVars.set(tMenu, "formMenu")
      tMenu.createGraphicElements()
    tElement.trigger_select = code
    tMenu.elements.append(tElement)

    #Custom match:
    for tCity in globalVars.get("cityList"):
      if tCity.cityID == globalVars.get("player").city:
        break
    if "CUSTOM_MATCH" in tCity.rules:
      tElement = menuElement()
      tElement.text = globalVars.get("messages").GM_CUSTOMMATCH
      tElement.icon = globalVars.get("iconCustom")
      tElement.helpText = globalVars.get("messages").GM_CUSTOMMATCHH
      tElement.value = "CUSTOMMATCH"

      def code(globalVars, formVars, menu, element):
        #Chiedo le regole della sfida:
        globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingsound")
        globalVars.get("playingsound").start()
        showCustomMatchMenu()
      tElement.trigger_select = code
      tMenu.elements.append(tElement)
  tMenu.selectFirstElement()

  #Chiudo il menu con cerchio:
  def code(globalVars, formVars, menu, element):
    globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingsound")
    globalVars.get("playingsound").start()
    hidePlayerMenu()
  tMenu.trigger_cancel = code

  tElement = menuElement()
  tElement.text = globalVars.get("messages").GM_CLOSE
  tElement.helpText = globalVars.get("messages").GM_CLOSEH
  tElement.icon = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_logout.png')
  tElement.value = "CLOSE"
  tElement.trigger_select = code
  tMenu.elements.append(tElement)

  if formVars.get("formMenu").name != "PLAYERMENU":
    formVars.set(tMenu, "formMenu")
    tMenu.createGraphicElements("LEFT")
  else:
    formVars.set(tMenu, "formMenu")
    tMenu.createGraphicElements()


def showCustomMatchMenu():
  """Ask rules for custom match"""
  custMatch = menu(formGraphics, globalVars, formVars)
  custMatch.name = "CUSTOMMATCH"
  custMatch.background_image = formVars.get("playerMenu").background_image
  custMatch.menuWidth = formVars.get("playerMenu").menuWidth
  custMatch.menuHeight = formVars.get("playerMenu").menuHeight
  custMatch.posX = formVars.get("playerMenu").posX
  custMatch.posY = formVars.get("playerMenu").posY
  custMatch.menuAlignment = formVars.get("playerMenu").menuAlignment
  custMatch.menuVAlignment = formVars.get("playerMenu").menuVAlignment
  custMatch.selector = formVars.get("playerMenu").selector
  def code(globalVars, formVars, menu, element):
    globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingsound")
    globalVars.get("playingsound").start()
    hideCustomMatchMenu()
  custMatch.trigger_cancel = code

  tElement = menuElement()
  tElement.text = globalVars.get("messages").GM_CHALLENGE
  tElement.helpText = globalVars.get("messages").GM_CHALLENGEH
  tElement.icon = globalVars.get("iconChallenge")
  tElement.value = "CHALLENGE"
  def code(globalVars, formVars, menu, element):
    """Challenge custom match"""
    globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingsound")
    globalVars.get("playingsound").start()
    #Controllo elementi e regole:
    rules = ""
    elements = ""
    for tE in menu.elements[1:]:
      if tE.value.split("|")[0] in globalVars.get("elements"):
        #Elementi:
        if int(tE.value.split("|")[1]) > 0:
          elements += tE.value.replace("|", "//n//") + "||"
      else:
        #Regole:
        if tE.value.split("|")[1] == "YES":
          rules += tE.value.split("|")[0] + "||"
    rules = rules[:-2]
    elements = elements[:-2]
    #Elementi:
    globalVars.get("net").sendInvite(formVars.get("playerListMenu").getSelected().data.ID, rules, elements)
    hideCustomMatchMenu()
    hidePlayerMenu()
  tElement.trigger_select = code
  custMatch.elements.append(tElement)

  yes = menuElement()
  yes.text = globalVars.get("messages").NO
  yes.value = "NO"
  no = menuElement()
  no.text = globalVars.get("messages").YES
  no.value = "YES"

  tElement = menuElement()
  tElement.text = globalVars.get("messages").SAME_RULE
  tElement.helpText = globalVars.get("messages").SAME_RULEH
  tElement.value = "SAME|YES"
  tElement.subMenu.append(yes)
  tElement.subMenu.append(no)
  custMatch.elements.append(tElement)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").SAMEWALL_RULE
  tElement.helpText = globalVars.get("messages").SAMEWALL_RULEH
  tElement.value = "SAMEWALL|YES"
  tElement.subMenu.append(yes)
  tElement.subMenu.append(no)
  custMatch.elements.append(tElement)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").PLUS_RULE
  tElement.helpText = globalVars.get("messages").PLUS_RULEH
  tElement.value = "PLUS|YES"
  tElement.subMenu.append(yes)
  tElement.subMenu.append(no)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").COMBO_RULE
  tElement.helpText = globalVars.get("messages").COMBO_RULEH
  tElement.value = "COMBO|YES"
  tElement.subMenu.append(yes)
  tElement.subMenu.append(no)
  custMatch.elements.append(tElement)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").ELEMENTAL_RULE
  tElement.helpText = globalVars.get("messages").ELEMENTAL_RULEH
  tElement.value = "ELEM|YES"
  tElement.subMenu.append(yes)
  tElement.subMenu.append(no)
  def code(globalVars, formVars, menu, element):
    #Rendo visibili/invisibili i valori deglielementi:
    if element.value.split("|")[1] == "NO":
      #Tolgo gli elementi:
      for m in menu.data:
        menu.elements.remove(m)
    elif element.value.split("|")[1] == "YES":
      #Aggiungo gli elementi:
      for m in menu.data:
        menu.elements.insert(5, m)
    menu.lastVisible = None
    menu.createGraphicElements()
  tElement.trigger_changeSubMenu = code

  custMatch.elements.append(tElement)

  #Numero degli elementi:
  custMatch.data = []
  for ele in globalVars.get("elements"):
    tElement = menuElement()
    tElement.text = eval("globalVars.get(\"messages\").ELEMENT_" + ele)
    tElement.helpText = eval("globalVars.get(\"messages\").ELEMENT_" + ele + "H")
    tElement.value = ele + "|0"
    for i in xrange(0,10):
      tSubElement = menuElement()
      tSubElement.text = str(i)
      tSubElement.value = str(i)
      tElement.subMenu.append(tSubElement)
    def code(globalVars, formVars, menu, element):
      #Controllo il totale degli elementi:
      tot = 0
      for m in menu.data:
        if m is not element:
          tot += int(m.value.split("|")[1])
      if tot + int(element.value.split("|")[1]) > 9:
        element.value = element.value.split("|")[0] + "|" + str(9 - tot)
        menu.selected = element.value
    tElement.trigger_changeSubMenu = code
    custMatch.elements.append(tElement)
    custMatch.data.insert(0, tElement)
  tElement = menuElement()
  tElement.text = globalVars.get("messages").OPEN_RULE
  tElement.helpText = globalVars.get("messages").OPEN_RULEH
  tElement.value = "OPEN|YES"
  tElement.subMenu.append(yes)
  tElement.subMenu.append(no)
  custMatch.elements.append(tElement)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").SUDDENDEATH_RULE
  tElement.helpText = globalVars.get("messages").SUDDENDEATH_RULEH
  tElement.value = "SUDDEN|YES"
  tElement.subMenu.append(yes)
  tElement.subMenu.append(no)
  custMatch.elements.append(tElement)
  formVars.get("formMenu").hideGraphics()
  formVars.set(custMatch, "formMenu")
  custMatch.selectFirstElement()
  custMatch.createGraphicElements()


def hideCustomMatchMenu():
  """Hide custom match menu"""
  formVars.get("formMenu").delGraphics()
  formVars.set(formVars.get("playerMenu"), "formMenu")
  formVars.get("formMenu").showGraphics()
  formVars.get("formMenu").createGraphicElements()


def hidePlayerMenu():
  #Hide player menu:
  formVars.set(formVars.get("playerListMenu").name, "status")
  formVars.get("playerMenu").delGraphics()
  formVars.get("playerMenu").clear()

  formVars.set(formVars.get("playerListMenu"), "formMenu")
  sel = formVars.get("formMenu").getGraphicElement("MENU_SELECTOR_RIGHT")
  if sel:
    sel.visible = True
  globalVars.set(None, "message")


def playerInfoCallback(pResponse, pError):
  #Visualizzo le informazioni del giocatore:
  if pError:
    waitMessage(globalVars, formVars, pError[1][1], False, 10)
    return

  response = functions.analyzeServerString(pResponse)
  if len(response) > 0:
    graph = formGraphics.get("PLAYER_INFO")
    if not graph:
      return
    posX = 5
    posY = 2
    tHeight = functions.textHeight(globalVars.get("fonts").get("fontMenu"), "I")
    elementImage = eval("globalVars.get(\"images\").get(\"element" + response[9].title() + "Image\")")
    graph.image.blit(elementImage, 0, 0, elementImage.width, elementImage.height, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), globalVars.get("messages").GM_NAME + " "), posY + 0 * tHeight, True)
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), globalVars.get("messages").GM_NAME + " ") + elementImage.width, posY + 0 * tHeight, response[0])
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), globalVars.get("messages").GM_STATUS + " "), posY + 1 * tHeight, eval("globalVars.get(\"messages\").GM_STATUS_" + response[1][:1]))
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), globalVars.get("messages").GM_LANG + " "), posY + 2 * tHeight, response[2])
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), globalVars.get("messages").GM_SYSTEM + " "), posY + 3 * tHeight, response[7])
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), globalVars.get("messages").GM_VERSION + " "), posY + 4 * tHeight, response[8])
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), globalVars.get("messages").GM_PLAY + " "), posY + 5 * tHeight, response[3])
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, 60 - functions.textWidth(globalVars.get("fonts").get("fontMenu"), response[4]), posY + 7 * tHeight, str(response[4]))
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, 60 * 2 - functions.textWidth(globalVars.get("fonts").get("fontMenu"), response[6]), posY + 7 * tHeight, str(response[6]))
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, 60 * 3 - functions.textWidth(globalVars.get("fonts").get("fontMenu"), response[5]), posY + 7 * tHeight, str(response[5]))


def hidePlayerInfo():
  """Hide layer info"""
  delGraphic(formGraphics, "PLAYER_INFO")
  formVars.set(formVars.get("playerMenu"), "formMenu")
  formVars.get("playerMenu").createGraphicElements()
  formVars.set(formVars.get("playerMenu").name ,"status")


def addToBuddyListCallback(pResponse, pError):
  #Aggiungo l'utente alla buddy list:
  if pError:
    waitMessage(globalVars, formVars, pError[1][1], False, 10)
    return

  response = functions.analyzeServerString(pResponse)
  #Cancello il messaggio:
  formVars.get("formMenu").getGraphicElement("MENU_SELECTOR_LEFT").visible = True
  hideWaitMessage(globalVars, formVars)
  if response[0] == "ADD":
    globalVars.get("buddyList").append(response[1])
    formGraphics.get("TIMER").data = None
    showPlayerMenu()


def removeFromBuddyListCallback(pResponse, pError):
  #Rimuovo l'utente alla buddy list:
  if pError:
    waitMessage(globalVars, formVars, pError[1][1], False, 10)
    return

  response = functions.analyzeServerString(pResponse)
  #Cancello il messaggio:
  formVars.get("formMenu").getGraphicElement("MENU_SELECTOR_LEFT").visible = True
  hideWaitMessage(globalVars, formVars)
  if response[0] == "REMOVE":
    globalVars.get("buddyList").remove(response[1])
    formGraphics.get("TIMER").data = None
    showPlayerMenu()


def addToBlackListCallback(pResponse, pError):
  #Aggiungo l'utente alla black list:
  if pError:
    waitMessage(globalVars, formVars, pError[1][1], False, 10)
    return

  response = functions.analyzeServerString(pResponse)
  #Cancello il messaggio:
  formVars.get("formMenu").getGraphicElement("MENU_SELECTOR_LEFT").visible = True
  hideWaitMessage(globalVars, formVars)
  if response[0] == "ADD":
    globalVars.get("blackList").append(response[1])
    formGraphics.get("TIMER").data = None
    hidePlayerMenu()


def myMessagesCallback(pResponse, pError):
  """Check for new messages"""
  formGraphics.get("MYMESSAGES").visible = True
  if pError:
    waitMessage(globalVars, formVars, pError[1][1], False, 10)
    return

  response = functions.analyzeServerString(pResponse)
  #Aggiorno la descrizione della toolbar:
  if len(response) < 2:
    response = ["0","0"]

  if len(response) >= 2:
    if len(response[0]) == 0:
      response[0] = "0"
    if len(response[1]) == 0:
      response[1] = "0"
    if formVars.get("formToolbar").data != response:
      if int(response[0]) > int(formVars.get("formToolbar").data[0]):
        if not globalVars.get("messageShown"):
          waitMessage(globalVars, formVars, globalVars.get("messages").GM_NEWMESSAGE.replace("XXX", str(response[0])), False, 5)
        globalVars.set(formVars.get("messageSound"), "playingSound")
        globalVars.get("playingSound").start()
      formVars.get("formToolbar").data = response
      element = formVars.get("formToolbar").getElement("MESSAGES")
      if int(response[0]) + int(response[1]) > 0:
        element.text = globalVars.get("messages").GM_T_MESSAGES + " (" + str(response[0]) + "/" + str(response[1] + ")")
      else:
        element.text = globalVars.get("messages").GM_T_MESSAGES
      formVars.get("formToolbar").createGraphicElements(formGraphics)


def locationMessagesCallback(pResponse, pError):
  """Location messages"""
  formGraphics.get("TIMER_LOCATIONMSG").visible = True
  if pError:
    waitMessage(globalVars, formVars, pError[1][1], False, 10)
    return

  response = functions.analyzeServerString(pResponse)
  messages = []
  for numMsg, p in enumerate(response):
    cp = p.split("||")
    if cp[0] == "CUST":
      #Controllo se e' uno shout standard:
      try:
        msg = cp[1].split(":")[0] + ": " + eval("globalVars.get(\"messages\").STDSHOUTMSG_" + cp[1].split(":")[1].strip().replace(" ", "_"))
      except AttributeError:
        msg = cp[1]
    else:
      try:
        msg = eval("globalVars.get(\"messages\").GM_SRVMSG_" + cp[0])
      except AttributeError:
        msg = cp[0]
    params = cp[1].split("//n//")
    for i, param in enumerate(params):
      msg = msg.replace("PARAM" + str(i + 1), param)
    messages.append(msg)

  #Scrivo a video i messaggi (se sono cambiati):
  graph = formGraphics.get("SERVER_MESSAGES")
  graph.image = psp2d.Image(290, 150)
  graph.image.clear(psp2d.Color(0,0,0,80))
  if formVars.get("oldServerMessages") != None and formVars.get("oldServerMessages") != messages:
    #Tolgo i messaggi vecchi:
    for oldM in formVars.get("oldServerMessages")[:]:
      try:
        messages.remove(oldM)
      except ValueError:
        formVars.get("oldServerMessages").remove(oldM)
    posX = 2
    posY = 2
    tHeight = functions.textHeight(globalVars.get("fonts").get("fontServerMsg"), "I")
    messages.reverse()
    for i, msg in enumerate(messages):
      globalVars.get("fonts").get("fontServerMsg").drawText(graph.image, posX, graph.image.height - (posY + (i + 1) * tHeight), msg)
  elif not formVars.get("oldServerMessages"):
    formVars.set(messages, "oldServerMessages")


def logoutCallback(pResponse, pError):
  #Logout from server:
  if pError:
    waitMessage(globalVars, formVars, pError[1][1], False, 10)
    return

  response = functions.analyzeServerString(pResponse)

  #Svuoto le richieste al server:
  globalVars.get("net").requests = []

  #Cancello gli elementi grafici comuni:
  delGraphic(globalVars.get("commonGraphics"), "CHECKAPCTL")
  delGraphic(globalVars.get("commonGraphics"), "REFRESH")

  #Cancello variabili globali:
  globalVars.remove("elements")
  globalVars.remove("cityList")
  globalVars.remove("player")
  globalVars.remove("buddyList")
  globalVars.remove("blackList")
  globalVars.remove("newCity")
  globalVars.remove("newLocation")
  globalVars.remove("gameType")
  globalVars.remove("shopCards")
  globalVars.remove("shopCardsIndex")
  globalVars.remove("playerCards")
  globalVars.remove("playerCardsIndex")
  globalVars.remove("iconNormal")
  globalVars.remove("iconPlaying")
  globalVars.remove("iconMessaging")
  globalVars.remove("iconOffline")
  globalVars.remove("iconWorldMap")
  globalVars.remove("iconDeck")
  globalVars.remove("iconShopping")

  #Torno al menu di login:
  globalVars.get("images").set(psp2d.Image('themes/' + globalVars.get("userData").THEME + '/background.png'), "defaultBkgImage")
  globalVars.get("fonts").remove("fontServerMsg")
  formVars.remove("fontBuddy", pClear=False)
  formVars.remove("fontNormal", pClear=False)

  globalVars.set("mdlLogin", "formName")
  globalVars.set("YES", "breakLoop")

  #Decremento la velocita' del processore:
  pspos.setclock(266)
  pspos.setbus(133)


def createToolbar():
  """Create toolbar menu"""
  tool = toolbar(globalVars, formVars)
  tool.background_image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_bg_toolbar.png')
  tool.width = 480
  tool.height = 22
  tool.posX = 0
  tool.posY = 0
  tool.data = [0,0]

  #Elementi Toolbar:
  tElement = menuElement()
  tElement.text = globalVars.get("messages").GM_T_SERVER
  tElement.helpText = globalVars.get("messages").GM_T_SERVERH
  tElement.icon = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_server.png')
  tElement.value = "SERVER"
  def code(globalVars, formVars, menu, element):
    #Menu server:
    showServerMenu()
  tElement.trigger_select = code
  tool.elements.append(tElement)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").GM_T_MOVE
  tElement.helpText = globalVars.get("messages").GM_T_MOVEH
  tElement.icon = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_movement.png')
  tElement.value = "MOVE"
  def code(globalVars, formVars, menu, element):
    #Menu movement:
    showMovementMenu()
  tElement.trigger_select = code
  tool.elements.append(tElement)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").GM_T_LISTS
  tElement.helpText = globalVars.get("messages").GM_T_LISTSH
  tElement.icon = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_lists.png')
  tElement.value = "LISTS"
  def code(globalVars, formVars, menu, element):
    #Menu lists:
    showListsMenu()
  tElement.trigger_select = code
  tool.elements.append(tElement)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").GM_T_CARDS
  tElement.helpText = globalVars.get("messages").GM_T_CARDSH
  tElement.icon = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_mycards.png')
  tElement.value = "CARDSETS"
  def code(globalVars, formVars, menu, element):
    #Menu cards:
    showCardsMenu()
  tElement.trigger_select = code
  tool.elements.append(tElement)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").GM_T_MESSAGES
  tElement.helpText = globalVars.get("messages").GM_T_MESSAGESH
  tElement.icon = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_mymessages.png')
  tElement.value = "MESSAGES"
  tool.data = [0,0]
  def code(globalVars, formVars, menu, element):
    #Menu messages:
    showMessagesMenu()
  tElement.trigger_select = code
  tool.elements.append(tElement)

  tool.createGraphicElements(formGraphics)

  #Animazione di entrata:
  graph = formGraphics.get("TOOLBAR")
  graph.posY = -graph.image.height
  anim = animation()
  anim.name = graph.name
  anim.data = [tool.posX, 0, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim

  formVars.set(tool, "formToolbar")


def activateToolbar():
  """Activate toolbar menu"""
  #Attivo la toolbar:
  globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
  globalVars.get("playingSound").start()

  formVars.set(formVars.get("status"), "lastStatus")
  formVars.set("TOOLBAR", "status")
  tool = formVars.get("formToolbar")
  if formVars.get("formMenu"):
    backupMenu(globalVars, formVars)
  if tool.lastSelected:
    tool.selected = tool.lastSelected
  else:
    tool.selected = tool.elements[0].value
  tool.createGraphicElements(formGraphics)
  sel = tool.getSelected()
  sel.trigger_select(tool, globalVars, formVars, sel)


def deactivateToolbar():
  """Deactivate toolbar menu"""
  #Disattivo la toolbar:
  hideToolbarMenu()
  globalVars.set(formVars.get("formToolbar").cancelSound, "playingSound")
  globalVars.get("playingSound").start()
  formVars.set(formVars.get("lastStatus") ,"status")
  restoreMenu(globalVars, formVars)
  tool = formVars.get("formToolbar")
  tool.lastSelected = tool.selected
  tool.selected = None
  tool.current = None
  tool.createGraphicElements(formGraphics)


def initToolbarMenu(pWidth=140, pHeight=60):
  """Initialize the toolbar menu"""
  tool = formVars.get("formToolbar")
  tool.current = tool.selected
  tool.selected = None

  if formVars.get("formMenu"):
    backupMenu(globalVars, formVars)

  toolbarMenu = formVars.get("toolbarMenu")
  toolbarMenu.clear()
  toolbarMenu.name = "TOOLBARMENU"
  toolbarMenu.graphicPriority = 100
  if pWidth == 140 and pHeight == 60:
    toolbarMenu.background_image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_bg_toolbarmenu.png')
  elif pWidth == 140 and pHeight == 90:
    toolbarMenu.background_image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_bg_toolbarmenu3rows.png')


  toolbarMenu.elements = []
  toolbarMenu.menuWidth = pWidth
  toolbarMenu.menuHeight = pHeight
  toolbarMenu.menuAlignment = "LEFT"
  toolbarMenu.selector = "RIGHT"
  toolbarMenu.posY = tool.height + 2
  toolbarMenu.posX = tool.getElement(tool.current).posX
  if toolbarMenu.posX + toolbarMenu.menuWidth > 480:
    toolbarMenu.posX = 480 - toolbarMenu.menuWidth
  formVars.set("TOOLBARMENU" ,"status")
  return toolbarMenu


def showServerMenu():
  """Show game menu"""
  toolbarMenu = initToolbarMenu(140, 90)
  toolbarMenu.name = "SERVERMENU"
  tElement = menuElement()
  tElement.text = globalVars.get("messages").GM_T_INFOSERVER
  tElement.helpText = globalVars.get("messages").GM_T_INFOSERVERH
  tElement.icon = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_serverinfo.png')
  tElement.value = "INFO"
  def code(globalVars, formVars, menu, element):
    globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
    globalVars.get("playingSound").start()

    formVars.set("SERVER_INFO", "status")
    menu.delGraphics()
    formVars.set(None, "formMenu")

    #Informazioni sul server:
    graph = graphicElement()
    graph.name = "SERVER_INFO"
    graph.priority = 50
    graph.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_bg_serverinfo.png')
    posX = 5
    posY = 2
    tHeight = functions.textHeight(globalVars.get("fonts").get("fontMenuSel"), "I")
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 0 * tHeight, globalVars.get("messages").GM_SERVERNAME)
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 1 * tHeight, globalVars.get("messages").GM_SERVERDESC)
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 5 * tHeight, globalVars.get("messages").GM_SERVERREGISTERED)
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 6 * tHeight, globalVars.get("messages").GM_SERVERLOGGED)
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 7 * tHeight, globalVars.get("messages").GM_SERVERPLAYED)
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 8 * tHeight, globalVars.get("messages").GM_SERVERPLAYING)
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 9 * tHeight, globalVars.get("messages").GM_SERVERFREE)
    tX = formVars.get("toolbarMenu").posX
    tY = formVars.get("toolbarMenu").posY
    graph.posX = -graph.image.width
    graph.posY = tY
    anim = animation()
    anim.name = graph.name
    anim.data = [tX, tY, 99]
    anim.code = functions.moveFromTo
    graph.animation = anim
    menu.formGraphics.set(graph)
    globalVars.get("net").serverInfo(serverInfoCallback)
  tElement.trigger_select = code
  toolbarMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").GM_T_SERVERNEWS
  tElement.icon = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_servernews.png')
  tElement.helpText = globalVars.get("messages").GM_T_SERVERNEWSH
  tElement.value = "WODLRMAP"
  def code(globalVars, formVars, menu, element):
    globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
    globalVars.get("playingSound").start()
    #Aggiorno lo status:
    globalVars.get("net").changeStatus("M")
    #Passo alle news del server:
    hideToolbarMenu()
    deactivateToolbar()
    globalVars.set("mdlServerNews", "formName")
    globalVars.set("YES", "breakLoop")
    preExitForm()
  tElement.trigger_select = code
  toolbarMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").GM_T_LOGOUT
  tElement.helpText = globalVars.get("messages").GM_T_LOGOUTH
  tElement.icon = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_logout.png')
  tElement.value = "DISCONNECT"
  def code(globalVars, formVars, menu, element):
    globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingSound")
    globalVars.get("playingSound").start()
    menu.getGraphicElement("MENU_SELECTOR_RIGHT").visible = False
    waitMessage(globalVars, formVars, globalVars.get("messages").LOGGINGOUT)
    globalVars.get("net").logout(logoutCallback)
  tElement.trigger_select = code
  toolbarMenu.elements.append(tElement)

  def code(globalVars, formVars, menu, element):
    hideToolbarMenu()
  toolbarMenu.trigger_cancel = code

  toolbarMenu.selectFirstElement()
  formVars.set(toolbarMenu, "formMenu")
  toolbarMenu.createGraphicElements()


def areaInfoCallback(pResponse, pError):
  """Area info"""
  if pError:
    waitMessage(globalVars, formVars, pError[1][1], False, 10)
    return

  response = functions.analyzeServerString(pResponse)
  for l in response:
    cL = l.split("||")
    if int(cL[0]) == globalVars.get("player").location:
      loc = city()
      loc.cityID = int(cL[0])
      loc.name = cL[1]
      loc.description = cL[2]
      loc.rules = cL[3]
      loc.players = int(cL[4])
      info = formGraphics.get("AREA_INFO")
      if not info:
        return
      posX = 5
      posY = 2
      tHeight = functions.textHeight(globalVars.get("fonts").get("fontMenu"), "I")
      for tCity in globalVars.get("cityList"):
        if tCity.cityID == globalVars.get("player").city:
          break
      posX = 5
      posY = 2
      tHeight = functions.textHeight(globalVars.get("fonts").get("fontMenu"), "I")
      globalVars.get("fonts").get("fontMenu").drawText(info.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenuSel"), globalVars.get("messages").GM_REGION + " "), posY + 0 * tHeight, tCity.region)
      globalVars.get("fonts").get("fontMenu").drawText(info.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenuSel"), globalVars.get("messages").GM_NAME + " "), posY + 1 * tHeight, tCity.name)
      globalVars.get("fonts").get("fontMenu").drawText(info.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenuSel"), globalVars.get("messages").GM_LOCATION + " "), posY + 2 * tHeight, loc.name)
      #Regole citta':
      primaColonna = True
      numRiga = 3
      for i, riga in enumerate(tCity.rules.split("//n//")):
        if primaColonna:
          numRiga += 1
          globalVars.get("fonts").get("fontMenu").drawText(info.image, posX, posY + numRiga * tHeight, eval("globalVars.get(\"messages\").GM_" + riga))
        else:
          globalVars.get("fonts").get("fontMenu").drawText(info.image, info.image.width - posX - functions.textWidth(globalVars.get("fonts").get("fontMenu"), eval("globalVars.get(\"messages\").GM_" + riga)), posY + numRiga * tHeight, eval("globalVars.get(\"messages\").GM_" + riga))
        primaColonna = not primaColonna
      #Regole location:
      for i, riga in enumerate(loc.rules.split("//n//")):
        if len(riga) > 0:
          if riga.find("_") >= 0:
            testo = riga[riga.find("_") + 1:] + " x " + globalVars.get("cardSets")[0].elementals[globalVars.get("elements").index(riga[:riga.find("_")])]
            if primaColonna:
              numRiga += 1
              globalVars.get("fonts").get("fontMenu").drawText(info.image, posX, posY + numRiga * tHeight, testo)
            else:
              globalVars.get("fonts").get("fontMenu").drawText(info.image, info.image.width - posX - functions.textWidth(globalVars.get("fonts").get("fontMenu"), testo), posY + numRiga * tHeight, testo)
          else:
            if primaColonna:
              numRiga += 1
              globalVars.get("fonts").get("fontMenu").drawText(info.image, posX, posY + numRiga * tHeight, eval("globalVars.get(\"messages\").GM_" + riga))
            else:
              globalVars.get("fonts").get("fontMenu").drawText(info.image, info.image.width - posX - functions.textWidth(globalVars.get("fonts").get("fontMenu"), eval("globalVars.get(\"messages\").GM_" + riga)), posY + numRiga * tHeight, eval("globalVars.get(\"messages\").GM_" + riga))
          primaColonna = not primaColonna
      break


def hideAreaInfo():
  """Hide area info"""
  delGraphic(formGraphics, "AREA_INFO")
  formVars.set(formVars.get("toolbarMenu"),"formMenu")
  formVars.get("toolbarMenu").createGraphicElements()
  formVars.set("TOOLBARMENU", "status")


def serverInfoCallback(pResponse, pError):
  """Server info"""
  if pError:
    waitMessage(globalVars, formVars, pError[1][1], False, 10)
    return

  response = functions.analyzeServerString(pResponse)
  if len(response) >= 8:
    graph = formGraphics.get("SERVER_INFO")
    if not graph:
      return
    posX = 5
    posY = 2
    tHeight = functions.textHeight(globalVars.get("fonts").get("fontMenu"), "I")
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), globalVars.get("messages").GM_SERVERNAME + " "), posY + 0 * tHeight, response[1])
    #Descrizione:
    for i, riga in enumerate(response[2].split("//n//")):
      if i > 2:
        break
      globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + (2 + i) * tHeight, riga)
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, graph.image.width - functions.textWidth(globalVars.get("fonts").get("fontMenu"), response[3]) - globalVars.get("themeOptions").MENU_BORDERWIDTH, posY + 5 * tHeight, response[3])
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, graph.image.width - functions.textWidth(globalVars.get("fonts").get("fontMenu"), response[4]) - globalVars.get("themeOptions").MENU_BORDERWIDTH, posY + 6 * tHeight, response[4])
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, graph.image.width - functions.textWidth(globalVars.get("fonts").get("fontMenu"), response[5]) - globalVars.get("themeOptions").MENU_BORDERWIDTH, posY + 7 * tHeight, response[5])
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, graph.image.width - functions.textWidth(globalVars.get("fonts").get("fontMenu"), response[6]) - globalVars.get("themeOptions").MENU_BORDERWIDTH, posY + 8 * tHeight, response[6])
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, graph.image.width - functions.textWidth(globalVars.get("fonts").get("fontMenu"), response[7]) - globalVars.get("themeOptions").MENU_BORDERWIDTH, posY + 9 * tHeight, response[7])


def hideServerInfo():
  """Hide server info"""
  delGraphic(formGraphics, "SERVER_INFO")
  formVars.set(formVars.get("toolbarMenu"), "formMenu")
  formVars.get("toolbarMenu").createGraphicElements()
  formVars.set("TOOLBARMENU", "status")


def showMovementMenu():
  """Show movement menu"""
  toolbarMenu = initToolbarMenu(140, 60)
  toolbarMenu.name = "MOVEMENTMENU"
  tElement = menuElement()
  tElement.text = globalVars.get("messages").GM_T_LOCATIONINFO
  tElement.helpText = globalVars.get("messages").GM_T_LOCATIONINFOH
  tElement.icon = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_areainfo.png')
  tElement.value = "LOCATIONINFO"
  def code(globalVars, formVars, menu, element):
    globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
    globalVars.get("playingSound").start()
    formVars.set("AREA_INFO" ,"status")
    formVars.get("formMenu").delGraphics()
    formVars.set(None, "formMenu")

    graph = graphicElement()
    graph.name = "AREA_INFO"
    graph.priority = 100
    graph.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_bg_arearinfo.png')
    posX = 5
    posY = 2
    tHeight = functions.textHeight(globalVars.get("fonts").get("fontMenuSel"), "I")
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 0 * tHeight, globalVars.get("messages").GM_REGION)
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 1 * tHeight, globalVars.get("messages").GM_CITY)
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 2 * tHeight, globalVars.get("messages").GM_LOCATION)
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 3 * tHeight, globalVars.get("messages").GM_RULES)

    tX = formVars.get("toolbarMenu").posX - 40
    tY = formVars.get("toolbarMenu").posY
    graph.posX = -graph.image.width
    graph.posY = tY
    anim = animation()
    anim.name = graph.name
    anim.data = [tX, tY, 99]
    anim.code = functions.moveFromTo
    graph.animation = anim
    menu.formGraphics.set(graph)
    globalVars.get("net").locationList(globalVars.get("player").city, areaInfoCallback)
  tElement.trigger_select = code
  toolbarMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").GM_T_WORLDMAP
  tElement.icon = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_worldmap.png')
  tElement.helpText = globalVars.get("messages").GM_T_WORLDMAPH
  tElement.value = "WODLRMAP"
  def code(globalVars, formVars, menu, element):
    globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
    globalVars.get("playingSound").start()
    #Aggiorno lo status:
    globalVars.get("net").changeStatus("W")
    #Passo alla worldmap:
    hideToolbarMenu()
    deactivateToolbar()
    globalVars.set("mdlGameMap", "formName")
    globalVars.set("YES", "breakLoop")
    preExitForm()
  tElement.trigger_select = code
  toolbarMenu.elements.append(tElement)

  def code(globalVars, formVars, menu, element):
    hideToolbarMenu()
  toolbarMenu.trigger_cancel = code

  toolbarMenu.selectFirstElement()
  formVars.set(toolbarMenu, "formMenu")
  toolbarMenu.createGraphicElements()


def showListsMenu():
  """Show lists menu"""
  toolbarMenu = initToolbarMenu(140, 90)
  toolbarMenu.name = "LISTMENU"

  tElement = menuElement()
  tElement.text = globalVars.get("messages").GM_MYBUDDY
  tElement.helpText = globalVars.get("messages").GM_MYBUDDYH
  tElement.icon = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_buddy.png')
  tElement.value = "MYBUDDY"
  def code(globalVars, formVars, menu, element):
    #Passo alla buddylist:
    globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
    globalVars.get("playingSound").start()
    hideToolbarMenu()
    deactivateToolbar()
    #Aggiorno lo status:
    globalVars.get("net").changeStatus("M")
    globalVars.set("mdlBuddyList", "formName")
    globalVars.set("YES", "breakLoop")
    preExitForm()
  tElement.trigger_select = code
  toolbarMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").GM_MYBLACK
  tElement.helpText = globalVars.get("messages").GM_MYBLACKH
  tElement.icon = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_black.png')
  tElement.value = "MYBLACKLIST"
  def code(globalVars, formVars, menu, element):
    #Passo alla blacklist:
    globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
    globalVars.get("playingSound").start()
    hideToolbarMenu()
    deactivateToolbar()
    #Aggiorno lo status:
    globalVars.get("net").changeStatus("M")
    globalVars.set("mdlBlackList", "formName")
    globalVars.set("YES", "breakLoop")
    preExitForm()
  tElement.trigger_select = code
  toolbarMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").GM_TOPLIST
  tElement.helpText = globalVars.get("messages").GM_TOPLISTH
  tElement.icon = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_top50.png')
  tElement.value = "TOPLIST"
  def code(globalVars, formVars, menu, element):
    #Passo alla toplist:
    globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
    globalVars.get("playingSound").start()
    hideToolbarMenu()
    deactivateToolbar()
    #Aggiorno lo status:
    globalVars.get("net").changeStatus("M")
    globalVars.set("mdlTopList", "formName")
    globalVars.set(["WORLD"], "formParams")
    globalVars.set("YES", "breakLoop")
    preExitForm()
  tElement.trigger_select = code
  toolbarMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").GM_TOPLISTLOC
  tElement.helpText = globalVars.get("messages").GM_TOPLISTLOCH
  tElement.icon = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_top50loc.png')
  tElement.value = "TOPLISTLOC"
  def code(globalVars, formVars, menu, element):
    #Passo alla toplist della location:
    globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
    globalVars.get("playingSound").start()
    hideToolbarMenu()
    deactivateToolbar()
    #Aggiorno lo status:
    globalVars.get("net").changeStatus("M")
    globalVars.set("mdlTopList", "formName")
    globalVars.set(["LOCATION"], "formParams")
    globalVars.set("YES", "breakLoop")
    preExitForm()
  tElement.trigger_select = code
  toolbarMenu.elements.append(tElement)

  def code(globalVars, formVars, menu, element):
    hideToolbarMenu()
  toolbarMenu.trigger_cancel = code

  toolbarMenu.selectFirstElement()
  formVars.set(toolbarMenu, "formMenu")
  toolbarMenu.createGraphicElements()


def showCardsMenu():
  """Show cards menu"""
  toolbarMenu = initToolbarMenu(140, 60)
  toolbarMenu.name = "CARDSMENU"

  tElement = menuElement()
  tElement.text = globalVars.get("messages").GM_MYCARDS
  tElement.helpText = globalVars.get("messages").GM_MYCARDSH
  tElement.icon = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_status_s.png')
  tElement.value = "MYCARDS"
  def code(globalVars, formVars, menu, element):
    #Passo al deck:
    globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
    globalVars.get("playingSound").start()
    hideToolbarMenu()
    deactivateToolbar()
    #Aggiorno lo status:
    globalVars.get("net").changeStatus("D")
    globalVars.set("mdlMyCards", "formName")
    globalVars.set("YES", "breakLoop")
    preExitForm()
  tElement.trigger_select = code
  toolbarMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").GM_SHOP
  tElement.helpText = globalVars.get("messages").GM_SHOPH
  tElement.icon = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_shop.png')
  tElement.value = "SHOP"

  def code(globalVars, formVars, menu, element):
    #Passo allo shop:
    globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
    globalVars.get("playingSound").start()
    hideToolbarMenu()
    deactivateToolbar()
    #Aggiorno lo status:
    globalVars.get("net").changeStatus("S")
    globalVars.set("mdlShop", "formName")
    globalVars.set("YES", "breakLoop")
    preExitForm()
  tElement.trigger_select = code
  toolbarMenu.elements.append(tElement)

  def code(globalVars, formVars, menu, element):
    hideToolbarMenu()
  toolbarMenu.trigger_cancel = code

  toolbarMenu.selectFirstElement()
  formVars.set(toolbarMenu, "formMenu")
  toolbarMenu.createGraphicElements()


def showMessagesMenu():
  """Show message menu"""
  toolbarMenu = initToolbarMenu(140, 60)
  toolbarMenu.name = "MESSAGEMENU"
  toolbarMenu.menuAlignment = "RIGHT"
  toolbarMenu.selector = "LEFT"
  tElement = menuElement()
  tElement.text = globalVars.get("messages").GM_T_MYMESSAGE
  tElement.helpText = globalVars.get("messages").GM_T_MYMESSAGEH
  tElement.icon = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_mymessages.png')
  tElement.value = "MYMESSAGES"
  def code(globalVars, formVars, menu, element):
    #Passo ai messaggi:
    globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
    globalVars.get("playingSound").start()
    hideToolbarMenu()
    deactivateToolbar()
    #Aggiorno lo status:
    globalVars.get("net").changeStatus("M")
    globalVars.set("mdlMessages", "formName")
    globalVars.set("YES", "breakLoop")
    preExitForm()
  tElement.trigger_select = code
  toolbarMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").GM_T_SHOUT
  tElement.helpText = globalVars.get("messages").GM_T_SHOUTH
  tElement.icon = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_message.png')
  tElement.value = "SHOUT"
  def code(globalVars, formVars, menu, element):
    globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
    globalVars.get("playingSound").start()
    hideToolbarMenu()
    deactivateToolbar()
    showShoutMenu()
  tElement.trigger_select = code
  toolbarMenu.elements.append(tElement)

  def code(globalVars, formVars, menu, element):
    hideToolbarMenu()
  toolbarMenu.trigger_cancel = code

  toolbarMenu.selectFirstElement()
  formVars.set(toolbarMenu, "formMenu")
  toolbarMenu.createGraphicElements()


def hideToolbarMenu():
  """Hide toolbar menu"""
  tool = formVars.get("formToolbar")
  if tool.current:
    tool.selected = tool.current
  tool.current = None
  formVars.set(None, "formMenu")
  formVars.get("toolbarMenu").delGraphics()
  formVars.get("toolbarMenu").clear()
  sel = formVars.get("toolbarMenu").getSelected()
  if sel:
    globalVars.set(sel.helpText, "message")
  else:
    globalVars.set(None, "message")
  formVars.set("TOOLBAR", "status")


def getAllCardsCallback(pResponse, pError):
  """Loads cards for the shop"""
  if pError:
    waitMessage(globalVars, formVars, pError[1][1], False, 10)
    return

  response = functions.analyzeServerString(pResponse)
  shopCards = []
  shopCardsIndex = []
  for c in response:
    cp = c.split("||")
    if len(cp) >= 12:
      #Abbino il cardset:
      tCardset = None
      tCardsetName = functions.decodeCardSetID(int(cp[1]))
      for cardSet in globalVars.get("cardSets"):
        if cardSet.name.upper() == tCardsetName.upper():
          tCardset = cardSet
          break
      tCard = card(tCardset)
      tCard.ID = int(cp[0])
      tCard.cardSetName = tCardsetName
      tCard.level = int(cp[2])
      tCard.name = cp[3]
      tCard.imageP1 = tCard.path + "/images/" + cp[4].replace(".", ".p1.")
      tCard.imageP2 = tCard.path + "/images/" + cp[4].replace(".", ".p2.")
      if cp[5] == "A":
        cp[5] = 10
      tCard.left = int(cp[5])
      if cp[6] == "A":
        cp[6] = 10
      tCard.right = int(cp[6])
      if cp[7] == "A":
        cp[7] = 10
      tCard.top = int(cp[7])
      if cp[8] == "A":
        cp[8] = 10
      tCard.bottom = int(cp[8])
      if cp[9] != "None":
        tCard.elemental = int(cp[9])
        tCard.elementalString = tCard.cardSet.elementals[int(cp[9])]
      tCard.buyPrice = int(cp[10])
      tCard.sellPrice = int(cp[11])
      shopCards.append(tCard)
      shopCardsIndex.append(tCard.ID)
  globalVars.set(shopCards, "shopCards")
  globalVars.set(shopCardsIndex, "shopCardsIndex")
  updateWaitMessage(globalVars, formVars, globalVars.get("messages").GM_DOWNLOADING + " [40%]")


def getMyCardsCallback(pResponse, pError):
  """Loads my cards"""
  if pError:
    if "TIMEOUT" in pError[1][1].upper():
      #Ripeto la richiesta:
      globalVars.get("net").getAllCards(getAllCardsCallback)
    else:
      waitMessage(globalVars, formVars, pError[1][1], False, 10)
    return

  response = functions.analyzeServerString(pResponse)
  #globalVars.get("player").cardSet = cardSet()
  for c in response:
    if len(c):
      #Controllo se l'ho gia':
      if int(c) in globalVars.get("playerCardsIndex"):
        tCard = globalVars.get("playerCards")[globalVars.get("playerCardsIndex").index(int(c))]
        tCard.count += 1
      else:
        #Cerco la carta nel catalogo:
        if int(c) in globalVars.get("shopCardsIndex"):
          tCard = globalVars.get("shopCards")[globalVars.get("shopCardsIndex").index(int(c))].copy()
          tCard.count = 1
          globalVars.get("playerCards").append(tCard)
          globalVars.get("playerCardsIndex").append(tCard.ID)
        else:
          globalVars.get("logFile").log("ERROR: Card not found in catalog: " + c)
  updateWaitMessage(globalVars, formVars, globalVars.get("messages").GM_DOWNLOADING + " [60%]")


def getMyDeckCallback(pResponse, pError):
  """Loads my deck cards"""
  if pError:
    if "TIMEOUT" in pError[1][1].upper():
      #Ripeto la richiesta:
      globalVars.get("net").getMyDeck(getMyDeckCallback)
    else:
      waitMessage(globalVars, formVars, pError[1][1], False, 10)
    return

  response = functions.analyzeServerString(pResponse)
  globalVars.get("player").deck = [None] * 5
  for i, c in enumerate(response):
    #Cerco la carta nel catalogo:
    if int(c) in globalVars.get("shopCardsIndex"):
      tCard = globalVars.get("shopCards")[globalVars.get("shopCardsIndex").index(int(c))].copy()
      globalVars.get("player").deck[i] = tCard
    else:
      globalVars.get("logFile").log("ERROR: Card not found in catalog: " + c)
  updateWaitMessage(globalVars, formVars, globalVars.get("messages").GM_DOWNLOADING + " [70%]")


def endDownloadingData():
  """Hide wait message when all the data have benne downloaded"""
  initTimers()
  #hideWaitMessage(globalVars, formVars)


def myMoneyCallback(pResponse, pError):
  """My money"""
  if pError:
    waitMessage(globalVars, formVars, pError[1][1], False, 10)
    return

  response = functions.analyzeServerString(pResponse)
  if len(response) > 0:
    globalVars.get("player").guil = int(response[0])
  updateWaitMessage(globalVars, formVars, globalVars.get("messages").GM_DOWNLOADING + " [80%]")


def getInvitesCallback(pResponse, pError):
  """Check invites"""
  formGraphics.get("TIMER_INVITES").visible = True
  if pError:
    waitMessage(globalVars, formVars, pError[1][1], False, 10)
    return

  response = functions.analyzeServerString(pResponse)
  accettato = None
  listaID = []
  globalVars.get("player").invites = []
  for inv in response:
    cInv = inv.split("||")
    if len(cInv) >= 11 and int(cInv[9]) > 0:
      tInv = invite()
      tInv.ID = int(cInv[0])
      tInv.fromUserID = int(cInv[2])
      tInv.fromUserName = cInv[3]
      tInv.cityID = int(cInv[4])
      tInv.locationID = int(cInv[5])
      tInv.time = cInv[6]
      tInv.toUserID = int(cInv[7])
      tInv.toUserName = cInv[8]
      tInv.expires = int(cInv[9])
      tInv.roomID = int(cInv[10])

      #Filtro gli utenti in blacklist:
      if tInv.fromUserName in globalVars.get("blackList"):
        continue
      #Filtro i non buddy (se devo)
      elif formVars.get("listType") == "BUDDY" and tInv.fromUserName not in globalVars.get("buddyList"):
        continue

      regole_1 = ""
      regole_2 = ""
      #Controllo se e' custom:
      if len(cInv) > 11:
        #Leggo le regole:
        regole_1 = ""
        regole_2 = ""
        for i in xrange(11, len(cInv)):
          #Controllo se sono elementi o una regola:
          if "//n//" in cInv[i]:
            regole_2 += cInv[i].replace("//n//", "_") + "//n//"
          else:
            regole_1 += cInv[i] + "//n//"
        #Tolgo l'ultimo separatore:
        if regole_1[-5:] == "//n//":
          regole_1 = regole_1[:-5]
      else:
        #Cerco citta' e location:
        for city in globalVars.get("cityList"):
          if city.cityID == tInv.cityID:
            regole_1 = city.rules
            break

        for city in globalVars.get("locationList"):
          if city.cityID == tInv.cityID \
          and city.locationID == tInv.locationID:
            regole_2 = city.rules
            break
      #Regole:
      tInv.rules = []
      for rule in regole_1.split("//n//"):
        tInv.rules.append(rule)
      for rule in regole_2.split("//n//"):
        tInv.rules.append(rule)

      if tInv.expires > 0:
        globalVars.get("player").invites.append(tInv)
        listaID.append((tInv.ID, tInv.fromUserName))
      #Controllo se e' stato accettato:
      if cInv[1] == "1":
        accettato = tInv

  #Se un invito e' stato accettato:
  if accettato:
    gotoRoom(accettato)
  else:
    showInvitesMenu(listaID)


def showInvitesMenu(pListaID=None):
  #Visualizzo il menu degli inviti:
  functions.waitSafeMenu(formVars.get("invitesMenu"))

  tList = formVars.get("invitesMenu")
  tList.creating = True
  tList.elements = []
  sel = tList.selected
  firstV = tList.firstVisible
  lastV = tList.lastVisible
  tList.selected = None
  tList.firstVisible = None
  tList.lastVisible = None
  for tInv in globalVars.get("player").invites:
    tElement = menuElement()
    tElement.data = tInv
    #Controllo se e' mio oppure no:
    if tInv.fromUserName == globalVars.get("player").name:
      tElement.font = globalVars.get("fonts").get("fontMenu")
      tElement.text = tInv.toUserName
      tElement.icon = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_outinvite.png')
      tElement.value = str(tInv.ID)
    else:
      tElement.font = globalVars.get("fonts").get("fontMenuSel")
      tElement.text = tInv.fromUserName
      tElement.icon = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_ininvite.png')
      tElement.value = str(tInv.ID)
    def code(globalVars, formVars, menu, element):
      invito = formVars.get("invitesMenu").getSelected().data
      #Controllo se e' mio:
      if invito.fromUserName != globalVars.get("player").name:
        #Controllo se ho abbastanza carte:
        totCards = len(globalVars.get("playerCardsIndex"))
        for card in globalVars.get("player").deck:
          if card:
            totCards += 1
        if totCards < 5:
          waitMessage(globalVars, formVars, globalVars.get("messages").GM_NOTENOUGHCARDS, False, 3)
          return
        #Chiedo conferma:
        title = menu.formGraphics.get("INVITETITLE")
        title.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_invite_title.png')
        title.image.blit(globalVars.get("images").get("buttonLeftTrigger"), 0, 0, globalVars.get("images").get("buttonLeftTrigger").width, globalVars.get("images").get("buttonLeftTrigger").height, 0, 0, True)
        globalVars.get("fonts").get("fontMenu").drawText(title.image, (title.image.width - functions.textWidth(globalVars.get("fonts").get("fontMenu"), globalVars.get("messages").GM_INV_ACCEPT)) / 2, 3, globalVars.get("messages").GM_INV_ACCEPT)

        menu.delGraphics()
        tMenu = confirm(globalVars, formVars, formGraphics, menu.menuWidth, menu.menuHeight, menu.posX, menu.posY)
        tMenu.name = "CONFIRMINVITE"
        tMenu.background_image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_invite_menu.png')
        def code(globalVars, formVars, menu, element):
          #Chiudo il menu:
          globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingSound")
          globalVars.get("playingSound").start()
          delGraphic(formGraphics, "INVITETITLE")
          menu.delGraphics()
          showInvitesMenu()
        tMenu.elements[1].trigger_select = code
        tMenu.trigger_cancel = code
        def code(globalVars, formVars, menu, element):
          #Accetto l'invito
          globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
          globalVars.get("playingSound").start()
          waitMessage(globalVars, formVars, globalVars.get("messages").GM_WAIT)
          menu.getGraphicElement("MENU_SELECTOR_LEFT").visible = False
          globalVars.get("net").acceptInvite(invito.ID, acceptInviteCallback)
        tMenu.elements[0].trigger_select = code
        formVars.set(tMenu, "formMenu")
        tMenu.createGraphicElements()
        #Aggiorno le informazioni sulle regole:
        updateRuleInfo()

    tElement.trigger_select = code

    def code(globalVars, formVars, menu, element):
      #Aggiorno le informazioni di un invito:
      graph = formGraphics.get("INVITEINFO")
      graph.priority = 100
      graph.image = psp2d.Image(graph.data)
      posX = 5
      posY = 5
      tHeight = functions.textHeight(globalVars.get("fonts").get("fontMenu"), "I")
      if element.data.fromUserName == globalVars.get("player").name:
        globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 0 * tHeight, globalVars.get("messages").GM_INV_TO)
        globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenuSel"), globalVars.get("messages").GM_INV_TO), posY + 0 * tHeight, element.data.toUserName)
      else:
        globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 0 * tHeight, globalVars.get("messages").GM_INV_FROM)
        globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenuSel"), globalVars.get("messages").GM_INV_FROM), posY + 0 * tHeight, element.data.fromUserName)
      globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 1 * tHeight, globalVars.get("messages").GM_INV_CITY)
      globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 2 * tHeight, globalVars.get("messages").GM_INV_TIME)
      globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 3 * tHeight, globalVars.get("messages").GM_INV_EXPIRES)
      #Cerco la descrizione della citta':
      dsc = ""
      for tCity in globalVars.get("cityList"):
        if tCity.cityID == element.data.cityID:
          dsc = tCity.name
          break
      globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenuSel"), globalVars.get("messages").GM_INV_CITY), posY + 1 * tHeight, dsc)
      globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenuSel"), globalVars.get("messages").GM_INV_TIME), posY + 2 * tHeight, functions.formatDateTime(element.data.time, True))
      globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenuSel"), globalVars.get("messages").GM_INV_EXPIRES), posY + 3 * tHeight, str(element.data.expires) + " " + globalVars.get("messages").GM_INV_SECS)

    tElement.trigger_enter = code
    tList.elements.append(tElement)

    if tElement.value == sel:
      tList.selected = sel
    if firstV and tElement.value == firstV.value:
      tList.firstVisible = tElement
    if lastV and tElement.value == lastV.value:
      tList.lastVisible = tElement

  if not tList.selected and len(tList.elements) > 0:
    if tList.firstVisible:
      tList.selected = tList.firstVisible.value
    else:
      tList.selectFirstElement()

  #Se ci sono inviti visualizzo la finestra:
  if len(globalVars.get("player").invites) > 0 and formVars.get("menuCreated"):
    #Controllo se ci sono nuovi inviti:
    show = False
    if not pListaID:
      show = True
    else:
      for el in tList.elements:
        tInv = el.data
        if (tInv.ID, tInv.fromUserName) not in tList.data \
        and tInv.fromUserName != globalVars.get("player").name:
          show = True
      tList.data = pListaID

    if show:
      #Titolo
      title = graphicElement()
      title.name = "INVITETITLE"
      title.priority = 200
      title.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_invite_title.png')
      title.image.blit(globalVars.get("images").get("buttonLeftTrigger"), 0, 0, globalVars.get("images").get("buttonLeftTrigger").width, globalVars.get("images").get("buttonLeftTrigger").height, 0, 0, True)
      globalVars.get("fonts").get("fontMenu").drawText(title.image, (title.image.width - functions.textWidth(globalVars.get("fonts").get("fontMenu"), globalVars.get("messages").GM_INVITES)) / 2, 3, globalVars.get("messages").GM_INVITES)
      title.posX = 2
      title.posY = tList.posY - title.image.height - 2

      #Riquadro informazioni:
      graph = formGraphics.get("INVITEINFO")
      if not graph:
        graph = graphicElement()
        graph.name = "INVITEINFO"
        graph.priority = 200
      graph.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_invite_info.png')
      graph.data = psp2d.Image(graph.image)
      graph.posX = 2
      graph.posY = tList.posY + tList.menuHeight + 2

      if formVars.get("status") == "TOOLBAR":
        formVars.get("formToolbar").lastSelected = formVars.get("formToolbar").selected
        formVars.get("formToolbar").selected = None
      if not formVars.get("formMenu") or formVars.get("formMenu") != tList and formVars.get("formMenu").name != "CONFIRMINVITE":
        #Se sono nel menu shout lo chiudo (sarebbe troppo!)
        if formVars.get("status") == "SHOUTMENU":
          hideShoutMenu()
        elif formVars.get("status") == "PLAYER_INFO":
          hidePlayerInfo()
        elif formVars.get("status") == "SERVER_INFO":
          hideServerInfo()
        elif formVars.get("status") == "AREA_INFO":
          hideAreaInfo()

        backupMenu(globalVars, formVars)
        tList.selectFirstElement()
        tList.createGraphicElements("LEFT")
        #Animo la finestra titolo ed info:
        anim = animation()
        anim.name = graph.name
        anim.data = [graph.posX, graph.posY, 99]
        graph.posX = graph.posX - 480
        anim.code = functions.moveFromTo
        graph.animation = anim
        anim = animation()
        anim.name = title.name
        anim.data = [title.posX, title.posY, 99]
        title.posX = title.posX - 480
        anim.code = functions.moveFromTo
        title.animation = anim
      else:
        tList.createGraphicElements()
      formVars.set(formVars.get("status"), "lastStatus")
      formVars.set(tList.name, "status")
      formGraphics.set(title)
      formGraphics.set(graph)
      formVars.set(tList, "formMenu")
    elif formVars.get("formMenu") == tList:
      tList.createGraphicElements()
  elif len(globalVars.get("player").invites) == 0 and formVars.get("status") == tList.name:
    tList.createGraphicElements()
    updateRuleInfo()

  #Aggiorno le info dell'invito (se e' visualizzato):
  if tList.selected and formGraphics.get("INVITEINFO") and formVars.get("formMenu").name != "CONFIRMINVITE":
    tList.getSelected().trigger_enter(globalVars, formVars, tList, tList.getSelected())

  #Se non ci sono inviti nascondo il menu (se e' visualizzato)
  if len(globalVars.get("player").invites) == 0 \
  and formVars.get("status") == tList.name:
    hideInvitesMenu()
  tList.creating = False


def hideInvitesMenu():
  #Nascondo il menu inviti:
  delGraphic(formGraphics, "INVITETITLE")
  delGraphic(formGraphics, "INVITEINFO")
  if formVars.get("lastStatus") in ["TOOLBAR", "TOOLBARMENU"]:
    formVars.get("formToolbar").selected = formVars.get("formToolbar").lastSelected
    formVars.get("formToolbar").lastSelected = None
    formVars.get("formMenu").delGraphics()
    if formVars.get("lastStatus") == "TOOLBARMENU":
      restoreMenu(globalVars, formVars)
    else:
      formVars.set(None, "formMenu")
    formVars.set(formVars.get("lastStatus"), "status")
    formVars.set(None, "lastStatus")
  elif formVars.get("lastStatus") in ["PLAYER_INFO", "SERVER_INFO", "AREA_INFO"]:
    formVars.set(formVars.get("lastStatus"), "status")
    formVars.set(None, "lastStatus")
    formVars.get("formMenu").delGraphics()
    formVars.set(None, "formMenu")
  else:
    formVars.get("formMenu").delGraphics()
    restoreMenu(globalVars, formVars)


def updateRuleInfo():
  """Update invite's rule info"""
  inv = None
  sel = formVars.get("invitesMenu").getSelected()
  if sel:
    inv = sel.data
  graph = formGraphics.get("INVITEINFO")
  graph.priority = 100
  graph.image = psp2d.Image(graph.data)
  posX = 5
  posY = 5

  #Controllo di avere l'invito:
  if inv:
    tHeight = functions.textHeight(globalVars.get("fonts").get("fontMenu"), "I")
    for i, riga in enumerate(inv.rules):
      if len(riga):
        if riga.find("_") != -1 and riga[:riga.find("_")] in globalVars.get("elements"):
          #Elemento:
          testo = riga[riga.find("_") + 1:] + " x " + globalVars.get("cardSets")[0].elementals[globalVars.get("elements").index(riga[:riga.find("_")])]
        else:
          #Regola:
          testo = eval("globalVars.get(\"messages\").GM_" + riga)
        if i < 4:
          globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + i * tHeight, testo)
        else:
          globalVars.get("fonts").get("fontMenu").drawText(graph.image, graph.image.width - posX - functions.textWidth(globalVars.get("fonts").get("fontMenu"), testo), posY + (i - 4) * tHeight, testo)


def showShoutMenu():
  """Show shout menu"""
  formVars.set(formVars.get("status"), "lastStatus")
  formVars.set("SHOUTMENU", "status")
  if formVars.get("formMenu"):
    backupMenu(globalVars, formVars)

  #Shout menu:
  shoutMenu = formVars.get("shoutMenu")
  shoutMenu.name = "SHOUTMENU"
  shoutMenu.graphicPriority = 10
  shoutMenu.background_image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_shout_menu.png')
  shoutMenu.data = []
  shoutMenu.menuWidth = 290
  shoutMenu.menuHeight = 145
  shoutMenu.posX = 2
  shoutMenu.posY = 60
  shoutMenu.menuAlignment = "LEFT"
  shoutMenu.menuVAlignment = "CENTER"
  shoutMenu.selector = "RIGHT"
  def code(globalVars, formVars, menu, element):
    hideShoutMenu()
  shoutMenu.trigger_cancel = code

  def code(globalVars, formVars, menu, element):
    """Shout"""
    globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
    globalVars.get("playingSound").start()
    globalVars.get("net").shout(element.value)
    hideShoutMenu()

  #Custom messages:
  for shout in globalVars.get("userData").customMsg.SHOUTMSG:
    tElement = menuElement()
    tElement.text = shout
    tElement.value = shout
    tElement.trigger_select = code
    shoutMenu.elements.append(tElement)

  #Standard messages:
  numMsg = 0
  while True:
    numMsg += 1
    try:
      msg = eval("globalVars.get(\"messages\").STDSHOUTMSG_" + str(numMsg).zfill(2))
    except AttributeError:
      break
    tElement = menuElement()
    tElement.text = msg
    tElement.value = str(numMsg).zfill(2)
    tElement.trigger_select = code
    shoutMenu.elements.append(tElement)

  #Titolo
  title = graphicElement()
  title.name = "SHOUTTITLE"
  title.priority = 100
  title.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_shout_title.png')
  globalVars.get("fonts").get("fontMenuSel").drawText(title.image, (title.image.width - functions.textWidth(globalVars.get("fonts").get("fontMenuSel"), globalVars.get("messages").GM_T_SHOUT_TITLE)) / 2, 3, globalVars.get("messages").GM_T_SHOUT_TITLE)
  title.posX = shoutMenu.posX
  title.posY = shoutMenu.posY - title.image.height - 2
  anim = animation()
  anim.name = title.name
  anim.data = [title.posX, title.posY, 99]
  title.posX = title.posX - 480
  anim.code = functions.moveFromTo
  title.animation = anim
  formGraphics.set(title)

  shoutMenu.oldSelected = None
  shoutMenu.firstVisible = None
  shoutMenu.lastVisible = None
  shoutMenu.selectFirstElement()
  formVars.set(shoutMenu, "formMenu")
  shoutMenu.createGraphicElements("LEFT")


def hideShoutMenu():
  """Hide shout menu"""
  delGraphic(formGraphics, "SHOUTTITLE")
  restoreMenu(globalVars, formVars)
  formVars.set(formVars.get("lastStatus"), "status")
  formVars.get("shoutMenu").delGraphics()
  formVars.get("shoutMenu").clear()


def acceptInviteCallback(pResponse, pError):
  #Invito accettato:
  if pError:
    waitMessage(globalVars, formVars, pError[1][1], False, 10)
    return

  response = functions.analyzeServerString(pResponse)
  hideWaitMessage(globalVars, formVars)

  if response[0] == "OK":
    #Nascondo il menu:
    hideInvitesMenu()
    tInv = formVars.get("invitesMenu").getSelected().data
    tInv.roomID = response[1]
    gotoRoom(tInv)
  else:
    #Errore:
    waitMessage(globalVars, formVars, globalVars.get("messages").GM_INV_ERR_ACCEPT)


def gotoRoom(pInvite):
  #Inizio la partita:
  status =   formVars.get("status")
  if status == "SHOUTMENU":
    hideShoutMenu()
  elif status == "PLAYER_INFO":
    hidePlayerInfo()
  elif status == "SERVER_INFO":
    hideServerInfo()
  elif status == "AREA_INFO":
    hideAreaInfo()
  elif status == "INVITESMENU":
    hideInvitesMenu()
  elif status == "PLAYERMENU":
    hidePlayerMenu()

  #Controllo se mi devo spostare:
  if globalVars.get("player").city != pInvite.cityID:
    changeLocation(pInvite.cityID, pInvite.locationID, pNet=True)

  #Aggiorno lo stato:
  globalVars.get("net").changeStatus("P")

  #Chiedo il deck:
  globalVars.set("mdlMyCards", "formName")
  globalVars.set(["START-MULTI", pInvite.roomID, pInvite.fromUserName,  pInvite.fromUserID, pInvite.toUserID, pInvite.toUserName], "formParams")
  globalVars.set("YES", "breakLoop")
  preExitForm()


def backupFunction():
  """Pre backup function"""
  if formVars.get("formMenu"):
    formVars.get("formMenu").delGraphics()
  delGraphic(formGraphics, "TOOLBAR")


def restoreFunction():
  """Restore function"""
  #Controllo se devo cambiare location:
  if globalVars.get("newCity"):
    changeLocation(globalVars.get("newCity"), globalVars.get("newLocation"), pNet=True)
    globalVars.set(None, "newCity")
    globalVars.set(None, "newLocation")
  initTimers()


def enableTimers():
  #Attivo i timers:
  formGraphics.get("TIMER").data = None
  formGraphics.get("TIMER").visible = True
  formGraphics.get("TIMER_INVITES").data = None
  formGraphics.get("TIMER_INVITES").visible = True
  formGraphics.get("MYMESSAGES").data = None
  formGraphics.get("MYMESSAGES").visible = True
  formGraphics.get("TIMER_LOCATIONMSG").data = None
  formGraphics.get("TIMER_LOCATIONMSG").visible = True


def changeLocation(pCityID, pLocationID, pNet):
  """Change  city/location"""
  globalVars.get("net").changeStatus("N")
  globalVars.get("player").city = pCityID
  globalVars.get("player").location = pLocationID
  if pNet:
    globalVars.get("net").enterLocation(globalVars.get("player").city, globalVars.get("player").location)
  #setBackground()
  #hideToolbarMenu()
  #deactivateToolbar()
  #hidePlayerMenu()
  #formVars.get("playerListMenu").elements = []
  #formVars.set(False, "menuCreated")
  #waitMessage(globalVars, formVars, globalVars.get("messages").GM_WAIT)
  #formVars.get("playerListMenu").delGraphics()
  #Azzero i messaggi server:
  #formVars.set(None, "oldServerMessages")


def setHelp():
  """Set form help"""
  formHelp = helpItem(formGraphics, globalVars, formVars)
  formHelp.images = [globalVars.get("images").get("buttonStart"), globalVars.get("images").get("buttonSelect"), globalVars.get("images").get("buttonLeftTrigger"), globalVars.get("images").get("buttonSquare")]
  formHelp.rows = [globalVars.get("messages").GH_START, globalVars.get("messages").GH_SELECT, globalVars.get("messages").GH_LEFT, globalVars.get("messages").MH_SQUARE]
  formHelp.preShowFunc = showHelp
  formHelp.postHideFunc = hideHelp
  formVars.set(formHelp, "helpItem")


def showHelp():
  """Show Help"""
  if formVars.get("formMenu"):
    formVars.get("formMenu").hideSelectors()
    return True


def hideHelp():
  """Hide Help"""
  if formVars.get("formMenu"):
    formVars.get("formMenu").showSelectors()
    return True


def changeStatus(pNewStatus):
  """Change the form status"""
  if formVars.get("status") != "HELP":
    formVars.set(pNewStatus, "status")
  else:
    formVars.get("helpItem").data[0] = pNewStatus


def preExitForm():
  """Pre exit form function."""
  formVars.remove("fontNormal", pClear=False)
  formVars.remove("fontBuddy", pClear=False)


def button_down(pbuttons):
  #Gestione tasti form di gioco:
  if buttons.start in pbuttons \
  and formVars.get("status") not in ["PLAYER_INFO", formVars.get("invitesMenu").name, formVars.get("shoutMenu").name, "CONFIRMCHALLENGE"]:
    if formVars.get("status") not in ["TOOLBAR", "TOOLBARMENU"]:
      hidePlayerMenu()
      activateToolbar()
    else:
      hideToolbarMenu()
      deactivateToolbar()
    return True
  elif buttons.left_trigger in pbuttons and formVars.get("status") != formVars.get("invitesMenu").name:
    #Visualizzo il menu inviti:
    showInvitesMenu()
    return True
  else:
    if formVars.get("status") == formVars.get("playerListMenu").name:
      if buttons.select in pbuttons:
        #Cambio tipo di lista:
        tType = ["NORMAL", "BUDDY", "FREE"]
        try:
          formVars.set(tType[tType.index(formVars.get("listType")) + 1], "listType")
        except:
          formVars.set(tType[0], "listType")
        formGraphics.get("TIMER").data = None
        waitMessage(globalVars, formVars, eval("globalVars.get(\"messages\").GM_" + formVars.get("listType") + "_LIST"), False, 3)
        return True
    elif formVars.get("status") == "PLAYER_INFO":
      #Nascondo le informazioni del giocatore:
      globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingSound")
      globalVars.get("playingSound").start()
      hidePlayerInfo()
      return True
    elif formVars.get("status") == "SERVER_INFO":
      #Nascondo le informazioni del server:
      globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingSound")
      globalVars.get("playingSound").start()
      hideServerInfo()
      return True
    elif formVars.get("status") == "AREA_INFO":
      #Nascondo le informazioni dell'area:
      globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingSound")
      globalVars.get("playingSound").start()
      hideAreaInfo()
      return True
    elif formVars.get("status") == formVars.get("invitesMenu").name:
      if buttons.left_trigger in pbuttons:
        hideInvitesMenu()
        return True
    elif formVars.get("status") == "SHOUTMENU":
      if buttons.left_trigger in pbuttons:
        hideShoutMenu()
        return True
    elif formVars.get("status") == "TOOLBARMENU":
      if buttons.right in pbuttons:
        hideToolbarMenu()
        formVars.get("formToolbar").selectNext()
        formVars.get("formToolbar").createGraphicElements(formGraphics)
        sel = formVars.get("formToolbar").getSelected()
        sel.trigger_select(globalVars, formVars, formVars.get("formToolbar"), sel)
        return True
      elif buttons.left in pbuttons:
        hideToolbarMenu()
        formVars.get("formToolbar").selectPrevious()
        formVars.get("formToolbar").createGraphicElements(formGraphics)
        sel = formVars.get("formToolbar").getSelected()
        sel.trigger_select(globalVars, formVars, formVars.get("formToolbar"), sel)
        return True
    elif formVars.get("status") == "TOOLBAR":
      if buttons.circle in pbuttons:
        hideToolbarMenu()
        deactivateToolbar()
        return True

