#    Triple Triad PSP
#    Copyright (C) 2006, 2007 Sakya
#    sakya_tg@yahoo.it
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
import psp2d, pspsnd, pspnet
from core import graphicElement, dataStore, animation, functions, menu, menuElement, buttons, deck, cardSet, TTplayer, vKeyboard
from formsFunction import *

formGraphics = dataStore()
formVars = dataStore()
formVars.set(formGraphics, "formGraphics")
globalVars = None

"""Form login"""
def init(pGlobalVars, pParams):
  global formVars, globalVars, formGraphics

  formGraphics = dataStore()
  formVars = dataStore()
  formVars.set(formGraphics, "formGraphics")
  globalVars = pGlobalVars

  formVars.set(globalVars.get("images").get("defaultBkgImage"), "bkgImage")
  formVars.set(0, "bkgImagePosX")
  formVars.set(0, "bkgImagePosY")

  globalVars.set(None, "oldMenu")

  #Carico icone degli elementi:
  globalVars.get("images").set(psp2d.Image('themes/' + globalVars.get("userData").THEME + '/element_lightning.png'), "elementLightImage")
  globalVars.get("images").set(psp2d.Image('themes/' + globalVars.get("userData").THEME + '/element_earth.png'), "elementEarthImage")
  globalVars.get("images").set(psp2d.Image('themes/' + globalVars.get("userData").THEME + '/element_ice.png'), "elementIceImage")
  globalVars.get("images").set(psp2d.Image('themes/' + globalVars.get("userData").THEME + '/element_wind.png'), "elementWindImage")
  globalVars.get("images").set(psp2d.Image('themes/' + globalVars.get("userData").THEME + '/element_poison.png'), "elementPoisonImage")
  globalVars.get("images").set(psp2d.Image('themes/' + globalVars.get("userData").THEME + '/element_fire.png'), "elementFireImage")
  globalVars.get("images").set(psp2d.Image('themes/' + globalVars.get("userData").THEME + '/element_water.png'), "elementWaterImage")
  globalVars.get("images").set(psp2d.Image('themes/' + globalVars.get("userData").THEME + '/element_holy.png'), "elementHolyImage")

  startMenu = menu(formGraphics, pGlobalVars, formVars)
  startMenu.name = "LOGINMENU"

  #Titolo:
  graph = graphicElement()
  graph.name = "TITLE"
  graph.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_generic_title.png')
  graph.posX = -440
  graph.posY = 8
  anim = animation()
  anim.name = "TITLE"
  anim.data = [20, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)

  graph = graphicElement()
  graph.name = "TITLET"
  graph.font = globalVars.get("fonts").get("fontTitle")
  graph.posY = 10
  graph.text = globalVars.get("messages").LOGIN
  graph.posX = -functions.textWidth(graph.font, graph.text)
  anim = animation()
  anim.name = "TITLE"
  anim.data = [(480 - functions.textWidth(graph.font, graph.text)) / 2, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").LOGIN
  tElement.helpText = globalVars.get("messages").LOGINH
  tElement.value = "LOGIN"
  def code(globalVars, formVars, menu, element):
    pwd = menu.getElement("PASSWORD").value
    user = menu.getElement("USERNAME").value
    if "//%//" in pwd \
    or "//n//" in pwd \
    or "||" in pwd:
      waitMessage(globalVars, formVars, globalVars.get("messages").INVALIDPASSWORD, False, 5)
      return
    if "//%//" in user \
    or "//n//" in user \
    or "||" in user:
      waitMessage(globalVars, formVars, globalVars.get("messages").INVALIDUSERNAME, False, 5)
      return
    #Nascondo il selector:
    sel = menu.getGraphicElement("MENU_SELECTOR_LEFT")
    if sel:
      sel.visible = False
    sel = menu.getGraphicElement("MENU_SELECTOR_RIGHT")
    if sel:
      sel.visible = False

    #Messaggio di attesa:
    waitMessage(globalVars, formVars, globalVars.get("messages").LOGGINGIN, True)

    #Tento la connessione:
    graph = graphicElement()
    graph.name = "TRY_LOGIN"
    anim = animation()
    anim.name = graph.name
    def code(globalVars, formVars, target):
      globalVars.get("net").login(globalVars.get("userData").LANG, globalVars.get("version"), formVars.get("formMenu").getElement("USERNAME").value.split("|")[1], formVars.get("formMenu").getElement("PASSWORD").value.split("|")[1], loginCallback)
      target.name = "DEL_" + target.name
    anim.code = code
    graph.animation = anim
    formGraphics.set(graph)
  tElement.trigger_select = code
  startMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").USERNAME + " " + globalVars.get("userData").USERNAME
  tElement.helpText = globalVars.get("messages").USERNAMEH
  tElement.value = "USERNAME|" + globalVars.get("userData").USERNAME
  def code(globalVars, formVars, menu, element):
    #Visualizzo la tastiera:
    graph = graphicElement()
    graph.name = "CHECK_USERNAME"
    graph.font = globalVars.get("fonts").get("fontMessage")
    graph.visible = False
    anim = animation()
    anim.lockKeyboard = False
    anim.name = graph.name
    def code(globalVars, formVars, target):
      if not formVars.get("formKeyboard"):
        if target.text:
          el = formVars.get("formMenu").getElement("USERNAME")
          el.value = el.value.split("|")[0] + "|" + target.text
          globalVars.get("userData").USERNAME = target.text
          el.text = globalVars.get("messages").USERNAME + " " + target.text
          formVars.get("formMenu").selected = el.value
          formVars.get("formMenu").createGraphicElements()
        target.name = "DEL_" + target.name
        #Visualizzo il selector:
        sel = formVars.get("formMenu").getGraphicElement("MENU_SELECTOR_LEFT")
        if sel:
          sel.visible = True
        sel = formVars.get("formMenu").getGraphicElement("MENU_SELECTOR_RIGHT")
        if sel:
          sel.visible = True
    anim.code = code
    graph.animation = anim
    formGraphics.set(graph)

    #Nascondo il selector:
    sel = menu.getGraphicElement("MENU_SELECTOR_LEFT")
    if sel:
      sel.visible = False
    sel = menu.getGraphicElement("MENU_SELECTOR_RIGHT")
    if sel:
      sel.visible = False
    virtualKeyboard = vKeyboard(globalVars, formVars, formGraphics)
    virtualKeyboard.maxLength = 15
    virtualKeyboard.posX = 480 / 2 - 164 / 2
    virtualKeyboard.posY = 270 / 2 - 164 / 2
    virtualKeyboard.text = element.value.split("|")[1]
    virtualKeyboard.returnGraphicElement = graph
    virtualKeyboard.createGraphicElement()
    formVars.set(virtualKeyboard, "formKeyboard")
  tElement.trigger_select = code
  startMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").PASSWORD + " "  + ''.rjust(len(globalVars.get("userData").PASSWORD), '*')
  tElement.helpText = globalVars.get("messages").PASSWORDH
  tElement.value = "PASSWORD|"  + globalVars.get("userData").PASSWORD
  def code(globalVars, formVars, menu, element):
    #Visualizzo la tastiera:
    graph = graphicElement()
    graph.name = "CHECK_PWD"
    graph.font = globalVars.get("fonts").get("fontMessage")
    graph.visible = False
    anim = animation()
    anim.lockKeyboard = False
    anim.name = graph.name
    def code(globalVars, formVars, target):
      if not formVars.get("formKeyboard"):
        if target.text:
          el = formVars.get("formMenu").getElement("PASSWORD")
          el.value = el.value.split("|")[0] + "|" + target.text
          el.text = globalVars.get("messages").PASSWORD + ''.rjust(len(target.text), '*')
          formVars.get("formMenu").selected = el.value
          formVars.get("formMenu").createGraphicElements()
        target.name = "DEL_" + target.name
        #Visualizzo il selector:
        sel = formVars.get("formMenu").getGraphicElement("MENU_SELECTOR_LEFT")
        if sel:
          sel.visible = True
        sel = formVars.get("formMenu").getGraphicElement("MENU_SELECTOR_RIGHT")
        if sel:
          sel.visible = True
    anim.code = code
    graph.animation = anim
    formGraphics.set(graph)

    #Nascondo il selector:
    sel = menu.getGraphicElement("MENU_SELECTOR_LEFT")
    if sel:
      sel.visible = False
    sel = menu.getGraphicElement("MENU_SELECTOR_RIGHT")
    if sel:
      sel.visible = False
    virtualKeyboard = vKeyboard(globalVars, formVars, formGraphics)
    virtualKeyboard.posX = 480 / 2 - 164 / 2
    virtualKeyboard.posY = 270 / 2 - 164 / 2
    virtualKeyboard.returnGraphicElement = graph
    virtualKeyboard.maskChar = "*"
    virtualKeyboard.createGraphicElement()
    formVars.set(virtualKeyboard, "formKeyboard")
  tElement.trigger_select = code
  startMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").REGISTER
  tElement.helpText = globalVars.get("messages").REGISTERH
  tElement.value = "REGISTER"
  tElement.font = psp2d.Font('themes/' + globalVars.get("userData").THEME + '/font_blue.png')
  def code(globalVars, formVars, menu, element):
    #Controllo i caratteri illegali nel username/password:
    pwd = menu.getElement("PASSWORD").value
    user = menu.getElement("USERNAME").value
    if "//%//" in pwd \
    or "//n//" in pwd \
    or "||" in pwd:
      waitMessage(globalVars, formVars, globalVars.get("messages").INVALIDPASSWORD, False, 5)
      return
    if "//%//" in user \
    or "//n//" in user \
    or "||" in user:
      waitMessage(globalVars, formVars, globalVars.get("messages").INVALIDUSERNAME, False, 5)
      return
    globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
    globalVars.get("playingSound").start()
    askElement()
  tElement.trigger_select =code
  startMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").SAVEPASSWORD
  tElement.helpText = globalVars.get("messages").SAVEPASSWORDH
  tElement.value = "SAVEPASSWORD|"
  tElement.value += globalVars.get("userData").SAVEPASSWORD
  tSubElement = menuElement()
  tSubElement.text = globalVars.get("messages").YES
  tSubElement.value = "YES"
  tElement.subMenu.append(tSubElement)
  tSubElement = menuElement()
  tSubElement.text = globalVars.get("messages").NO
  tSubElement.value = "NO"
  tElement.subMenu.append(tSubElement)
  startMenu.elements.append(tElement)

  def code(globalVars, formVars, menu, element):
    globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingSound")
    #Scarico immagini elementi:
    globalVars.get("images").remove("elementLightImage")
    globalVars.get("images").remove("elementEarthImage")
    globalVars.get("images").remove("elementIceImage")
    globalVars.get("images").remove("elementWindImage")
    globalVars.get("images").remove("elementPoisonImage")
    globalVars.get("images").remove("elementFireImage")
    globalVars.get("images").remove("elementWaterImage")
    globalVars.get("images").remove("elementHolyImage")

    #Torno al menu opzioni di connessione:
    globalVars.get("net").disconnect()
    globalVars.set("mdlNetOptions", "formName")
    globalVars.set("YES", "breakLoop")
  startMenu.trigger_cancel = code

  tElement = menuElement()
  tElement.text = globalVars.get("messages").BACK
  tElement.helpText = globalVars.get("messages").BACKH
  tElement.value = "BACK"
  tElement.trigger_select = code
  startMenu.elements.append(tElement)

  startMenu.background_image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_generic_menu.png')
  startMenu.posX = globalVars.get("themeOptions").MENU_X
  startMenu.posY = globalVars.get("themeOptions").MENU_Y
  startMenu.menuWidth = globalVars.get("themeOptions").MENU_W
  startMenu.menuHeight = globalVars.get("themeOptions").MENU_H
  startMenu.selected = startMenu.elements[0].value
  startMenu.menuAlignment = globalVars.get("themeOptions").MENU_ALIGN
  startMenu.menuVAlignment = globalVars.get("themeOptions").MENU_VALIGN

  formVars.set(startMenu, "formMenu")
  formVars.get("formMenu").createGraphicElements("BOTTOM")


def loginCallback(pResponse, pError):
  """Callback for login"""
  response = functions.analyzeServerString(pResponse)
  if pError:
    #Errore:
    waitMessage(globalVars, formVars, pError[1][1], False)
  else:
    if response[0] == "OK":
      #Login corretto:
      #Ingresso nel gioco:
      enterGame(response)
      hideWaitMessage(globalVars, formVars)
    elif response[0] == "MIN_VERSION":
      #Versione minima:
      waitMessage(globalVars, formVars, globalVars.get("messages").SERVERVERSION.replace("XX", response[1]), False, 5)
      sel = formVars.get("formMenu").getGraphicElement("MENU_SELECTOR_LEFT")
      if sel:
        sel.visible = True
      sel = formVars.get("formMenu").getGraphicElement("MENU_SELECTOR_RIGHT")
      if sel:
        sel.visible = True
    elif response[0] == "FULL":
      #Server pieno:
      waitMessage(globalVars, formVars, globalVars.get("messages").SERVERFULL, False, 5)
      sel = formVars.get("formMenu").getGraphicElement("MENU_SELECTOR_LEFT")
      if sel:
        sel.visible = True
      sel = formVars.get("formMenu").getGraphicElement("MENU_SELECTOR_RIGHT")
      if sel:
        sel.visible = True
    else:
      #Login errato:
      waitMessage(globalVars, formVars, globalVars.get("messages").WRONGLOGIN, False)
      sel = formVars.get("formMenu").getGraphicElement("MENU_SELECTOR_LEFT")
      if sel:
        sel.visible = True
      sel = formVars.get("formMenu").getGraphicElement("MENU_SELECTOR_RIGHT")
      if sel:
        sel.visible = True

def enterGame(pResponse):
  """Enter the game area"""
  #Salvo la password se devo:
  if formVars.get("oldMenu"):
    tMenu = formVars.get("oldMenu")
  else:
    tMenu = formVars.get("formMenu")
  globalVars.get("userData").USERNAME = tMenu.getElement("USERNAME").value.split("|")[1]
  globalVars.get("userData").SAVEPASSWORD = tMenu.getElement("SAVEPASSWORD").value.split("|")[1]
  if globalVars.get("userData").SAVEPASSWORD == "YES":
    globalVars.get("userData").PASSWORD = tMenu.getElement("PASSWORD").value.split("|")[1]
  else:
    globalVars.get("userData").PASSWORD = ""
  functions.saveOptions(globalVars.get("userData"))

  globalVars.get("net").session = pResponse[1]
  graph = graphicElement()
  graph.name = "GOTOGAME"
  graph.data = pResponse
  anim = animation()
  anim.name = graph.name
  anim.priority = -100
  def code(globalVars, formVars, target):
    target.name = "DEL_" + target.name
    tPlayer = TTplayer()
    tPlayer.name = tMenu.getElement("USERNAME").value.split("|")[1].strip()
    tPlayer.city = int(target.data[2])
    tPlayer.location = int(target.data[3])
    globalVars.set("mdlGame", "formName")
    globalVars.set(["MULTI-INFRA", tPlayer], "formParams")
    globalVars.set("YES", "breakLoop")
  anim.code = code
  graph.animation = anim
  formGraphics.set(graph)


def askElement():
  """Ask element for user during registration"""
  formVars.set(formVars.get("formMenu"), "oldMenu")

  graph = graphicElement()
  graph.name = "CONFIRM"
  text = globalVars.get("messages").ASK_ELEMENT
  graph.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/title_280_20.png')
  globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, (graph.image.width - functions.textWidth(globalVars.get("fonts").get("fontMenuSel"), text)) / 2, 2, text)

  graph.posX = formVars.get("formMenu").posX
  graph.posY = formVars.get("formMenu").posY - 1
  formGraphics.set(graph)

  formVars.get("formMenu").delGraphics()
  tMenu = menu(formGraphics, globalVars, formVars)
  tMenu.name = "ELEMENT"
  tMenu.posX = formVars.get("oldMenu").posX
  tMenu.posY = formVars.get("oldMenu").posY + graph.image.height + 1
  tMenu.menuWidth = formVars.get("oldMenu").menuWidth
  tMenu.menuHeight = formVars.get("oldMenu").menuHeight - graph.image.height
  tMenu.background_image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_askelement.png')
  formVars.set(tMenu, "formMenu")

  element = ["LIGHT", "EARTH", "ICE", "WIND", "POISON", "FIRE", "WATER", "HOLY"]
  for e in element:
    tElement = menuElement()
    tElement.text = eval("globalVars.get(\"messages\").ELEMENT_" + e)
    tElement.value = e
    tElement.icon = eval("globalVars.get(\"images\").get(\"element" + e.title() + "Image\")")
    def code(globalVars, formVars, menu, element):
      formVars.set(element.value, "element")
      registerUser()
    tElement.trigger_select = code
    formVars.get("formMenu").elements.append(tElement)
  def code(globalVars, formVars, menu, element):
    #Torno al menu login:
    globalVars.set(globalVars.get("sounds").get("menuCancelSound") , "playingsound")
    globalVars.get("playingSound").start()
    delGraphic(formGraphics, "CONFIRM")
    menu.delGraphics()
    formVars.set(formVars.get("oldMenu"), "formMenu")
    formVars.get("formMenu").createGraphicElements("BOTTOM")
  tMenu.trigger_cancel = code
  tMenu.selected = element[0]
  formVars.set(tMenu, "formMenu")
  formVars.get("formMenu").createGraphicElements("BOTTOM")


def registerUser():
  """Register a new user"""
  #Nuovo utente:
  graph = formGraphics.get("CONFIRM")
  text = globalVars.get("messages").ASK_REGISTER + " " + formVars.get("oldMenu").getElement("USERNAME").value.split("|")[1] + "?"
  graph.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/title_280_20.png')
  globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, (graph.image.width - functions.textWidth(globalVars.get("fonts").get("fontMenuSel"), text)) / 2, 2, text)

  formVars.get("formMenu").delGraphics()
  tMenu = confirm(globalVars, formVars, formGraphics, formVars.get("oldMenu").menuWidth, formVars.get("oldMenu").menuHeight - graph.image.height, formVars.get("oldMenu").posX, formVars.get("oldMenu").posY + graph.image.height + 1)
  tMenu.background_image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_askelement.png')
  formVars.set(tMenu, "formMenu")
  def code(globalVars, formVars, menu, element):
    #Torno al menu login:
    globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingSound")
    globalVars.get("playingSound").start()
    delGraphic(formGraphics, "CONFIRM")
    menu.delGraphics()
    formVars.set(formVars.get("oldMenu"), "formMenu")
    formVars.get("formMenu").createGraphicElements("BOTTOM")
  tMenu.trigger_cancel = code

  tElement = tMenu.elements[1]
  tElement.trigger_select = code

  tElement = tMenu.elements[0]
  def code(globalVars, formVars, menu, element):
    #Registro un nuovo utente:
    globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
    globalVars.get("playingSound").start()
    waitMessage(globalVars, formVars, globalVars.get("messages").REGISTERING, True)
    formVars.get("formMenu").hideSelectors()
    globalVars.get("net").registerUser(formVars.get("oldMenu").getElement("USERNAME").value.split("|")[1], formVars.get("oldMenu").getElement("PASSWORD").value.split("|")[1], formVars.get("element"), registerUserCallback)
  tElement.trigger_select = code
  formVars.set(tMenu, "formMenu")
  tMenu.createGraphicElements("BOTTOM")


def registerUserCallback(pResponse, pError):
  """Register a new user"""
  if pError:
    waitMessage(globalVars, formVars, pError[1][1], False)
    return

  response = functions.analyzeServerString(pResponse)
  if response[0] == "OK":
    waitMessage(globalVars, formVars, globalVars.get("messages").LOGGINGIN, True)
    globalVars.get("net").login(globalVars.get("userData").LANG, globalVars.get("version"), formVars.get("oldMenu").getElement("USERNAME").value.split("|")[1], formVars.get("oldMenu").getElement("PASSWORD").value.split("|")[1], loginCallback)
  elif response[0] == "OC":
    waitMessage(globalVars, formVars, globalVars.get("messages").USEROCCUPIED, False, 5)
  else:
    waitMessage(globalVars, formVars, globalVars.get("messages").ERRORREGISTER, False, 5)
  delGraphic(formGraphics, "CONFIRM")
  formVars.get("formMenu").delGraphics()
  formVars.set(formVars.get("oldMenu"), "formMenu")
  formVars.get("formMenu").createGraphicElements("BOTTOM")


def button_down(pbuttons):
  return False