#    Triple Triad PSP
#    Copyright (C) 2006, 2007 Sakya
#    sakya_tg@yahoo.it
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
import psp2d
from core import graphicElement, dataStore, animation, functions, menu, menuElement, buttons
from formsFunction import *

"""Form main menu"""
formGraphics = dataStore()
formVars = dataStore()
formVars.set(formGraphics, "formGraphics")
globalVars = None

def init(pGlobalVars, pParams):
  global formVars, globalVars, formGraphics

  formGraphics = dataStore()
  formVars = dataStore()
  formVars.set(formGraphics, "formGraphics")
  globalVars = pGlobalVars

  formVars.set(globalVars.get("images").get("defaultBkgImage"), "bkgImage")
  formVars.set(0, "bkgImagePosX")
  formVars.set(0, "bkgImagePosY")

  #Titolo:
  graph = graphicElement()
  graph.name = "TITLE"
  graph.image = psp2d.Image('themes/' + pGlobalVars.get("userData").THEME + '/formsbg/gm_generic_title.png')
  graph.posX = -440
  graph.posY = 8
  anim = animation()
  anim.name = "TITLE"
  anim.data = [20, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)

  graph = graphicElement()
  graph.name = "TITLET"
  graph.font = pGlobalVars.get("fonts").get("fontTitle")
  graph.posY = 10
  graph.text = pGlobalVars.get("messages").MAIN
  graph.posX = -functions.textWidth(graph.font, graph.text)
  anim = animation()
  anim.name = "TITLE"
  anim.data = [(480 - functions.textWidth(graph.font, graph.text)) / 2, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)

  tMainMenu = menu(formGraphics, pGlobalVars, formVars)
  tMainMenu.name = "MAINMENU"

  tElement = menuElement()
  tElement.text = pGlobalVars.get("messages").START
  tElement.helpText = pGlobalVars.get("messages").STARTH
  tElement.value = "START"
  def code(globalVars, formVars, menu, element):
    #Passo al menu start:
    globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
    globalVars.get("playingSound").start()
    globalVars.set("mdlStart", "formName")
    globalVars.set("YES", "breakLoop")
  tElement.trigger_select = code
  tMainMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = pGlobalVars.get("messages").MULTI
  tElement.helpText = pGlobalVars.get("messages").MULTIH
  tElement.font = psp2d.Font('themes/' + globalVars.get("userData").THEME + '/font_blue.png')
  tElement.value = "START-MULTI"
  def code(globalVars, formVars, menu, element):
    #Passo al gioco lultiplayer:
    globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
    globalVars.get("playingSound").start()
    globalVars.set("mdlNetOptions", "formName")
    globalVars.set("YES", "breakLoop")
  tElement.trigger_select = code
  tMainMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = pGlobalVars.get("messages").CARDSETS
  tElement.helpText = pGlobalVars.get("messages").CARDSETSH
  tElement.value = "CARDSETS"
  def code(globalVars, formVars, menu, element):
    #Passo al menu cardsets:
    globalVars.set("mdlManageCardSets", "formName")
    globalVars.set("YES", "breakLoop")
  tElement.trigger_select = code
  tMainMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = pGlobalVars.get("messages").OPTIONS
  tElement.helpText = pGlobalVars.get("messages").OPTIONSH
  tElement.value = "OPTIONS"
  def code(globalVars, formVars, menu, element):
    #Passo al menu opzioni:
    globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
    globalVars.get("playingSound").start()
    globalVars.set("mdlOptions", "formName")
    globalVars.set("YES", "breakLoop")
  tElement.trigger_select = code
  tMainMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = pGlobalVars.get("messages").HELPRULE
  tElement.helpText = pGlobalVars.get("messages").HELPRULEH
  tElement.value = "HELPRULES"
  def code(globalVars, formVars, menu, element):
    #Visualizzo l'help:
    globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
    globalVars.get("playingSound").start()
    globalVars.set("mdlHelpRules", "formName")
    globalVars.set("YES", "breakLoop")
  tElement.trigger_select = code
  tMainMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = pGlobalVars.get("messages").CREDITS
  tElement.helpText = pGlobalVars.get("messages").CREDITSH
  tElement.value = "CREDITS"
  def code(globalVars, formVars, menu, element):
    #Visualizzo i credits:
    globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
    globalVars.get("playingSound").start()
    globalVars.set("mdlCredits", "formName")
    globalVars.set("YES", "breakLoop")
  tElement.trigger_select = code

  tMainMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = pGlobalVars.get("messages").QUIT
  tElement.helpText = pGlobalVars.get("messages").QUITH
  tElement.value = "QUIT"
  def code(globalVars, formVars, menu, element):
    globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
    globalVars.get("playingSound").start()
    globalVars.set("YES", "breakLoop")
    globalVars.set("YES", "exitTTPSP")
  tElement.trigger_select = code

  tMainMenu.elements.append(tElement)

  tMainMenu.background_image = psp2d.Image('themes/' + pGlobalVars.get("userData").THEME + '/formsbg/gm_generic_menu.png')
  tMainMenu.menuAlignment = pGlobalVars.get("themeOptions").MENU_ALIGN
  tMainMenu.menuVAlignment = pGlobalVars.get("themeOptions").MENU_VALIGN
  tMainMenu.posX = pGlobalVars.get("themeOptions").MENU_X
  tMainMenu.posY = pGlobalVars.get("themeOptions").MENU_Y
  tMainMenu.menuWidth = pGlobalVars.get("themeOptions").MENU_W
  tMainMenu.menuHeight = pGlobalVars.get("themeOptions").MENU_H
  if pParams:
    tMainMenu.selected = pParams[0]
  else:
    tMainMenu.selected = "START"

  formMenu = tMainMenu
  formMenu.createGraphicElements("BOTTOM")
  formVars.set(formMenu, "formMenu")
  formVars.set(None, "formToolbar")


def button_down(pButtons):
  return False