#    Triple Triad PSP
#    Copyright (C) 2006, 2007 Sakya
#    sakya_tg@yahoo.it
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
import psp2d
from core import functions, animation, graphicElement, dataStore, menu, menuElement, buttons
from formsFunction import *


"""Form manageCardSets"""
formGraphics = dataStore()
formVars = dataStore()
formVars.set(formGraphics, "formGraphics")
globalVars = None

def init(pGlobalVars, pParams):
  global formVars, globalVars, formGraphics

  formGraphics = dataStore()
  formVars = dataStore()
  formVars.set(formGraphics, "formGraphics")
  globalVars = pGlobalVars

  formVars.set(globalVars.get("images").get("defaultBkgImage"), "bkgImage")
  formVars.set(0, "bkgImagePosX")
  formVars.set(0, "bkgImagePosY")

  formVars.set([], "cardSetsList")
  theme = globalVars.get("userData").THEME

  #Titolo:
  graph = graphicElement()
  graph.name = "TITLE"
  graph.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_generic_title.png')
  graph.posX = -440
  graph.posY = 8
  anim = animation()
  anim.name = "TITLE"
  anim.data = [20, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)

  graph = graphicElement()
  graph.name = "TITLET"
  graph.font = globalVars.get("fonts").get("fontTitle")
  graph.text = globalVars.get("messages").MANCARDSETS
  graph.posY = 10
  graph.posX = -functions.textWidth(graph.font, graph.text)
  anim = animation()
  anim.name = "TITLET"
  anim.data = [(480 - functions.textWidth(graph.font, graph.text)) / 2, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)

  #Menu cardsets:
  mancardMenu = menu(formGraphics, globalVars, formVars)
  mancardMenu.name = "MANAGECARDSMENU"

  for tCardSet in globalVars.get("cardSets"):
    tElement = menuElement()
    tElement.text = tCardSet.name
    tElement.value = "CARDSET_" + tCardSet.name
    tElement.helpText = tCardSet.shortDesc
    def code(globalVars, formVars, menu, element):
      #Passo al visualizzatore di mazzi:
      globalVars.set("mdlViewCardset", "formName")
      globalVars.set([menu.selected[8:]], "formParams")
      globalVars.set("YES", "breakLoop")
    tElement.trigger_select = code
    mancardMenu.elements.append(tElement)

  lang = globalVars.get("userData").LANG

  tElement = menuElement()
  tElement.text = globalVars.get("messages").MAIN
  tElement.helpText = globalVars.get("messages").MAINH
  tElement.value = "MAIN"
  def code(globalVars, formVars, menu, element):
    #Torno al main menu
    globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
    globalVars.get("playingSound").start()
    backPreviousForm()
  tElement.trigger_select = code
  mancardMenu.elements.append(tElement)

  def code(globalVars, formVars, menu, element):
    #Torno al menu principale:
    globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingSound")
    globalVars.get("playingSound").start()
    backPreviousForm()
  mancardMenu.trigger_cancel = code
  mancardMenu.background_image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_generic_menu.png')
  mancardMenu.menuAlignment = globalVars.get("themeOptions").MENU_ALIGN
  mancardMenu.menuVAlignment = globalVars.get("themeOptions").MENU_VALIGN
  mancardMenu.posX = globalVars.get("themeOptions").MENU_X
  mancardMenu.posY = globalVars.get("themeOptions").MENU_Y
  mancardMenu.menuWidth = globalVars.get("themeOptions").MENU_W
  mancardMenu.menuHeight = globalVars.get("themeOptions").MENU_H

  formVars.set(mancardMenu, "formMenu")
  if pParams:
    mancardMenu.selected = pParams[0]
  else:
    mancardMenu.selected = mancardMenu.elements[0].value
  mancardMenu.createGraphicElements("BOTTOM")


def backPreviousForm():
  #Torno al menu cardsets:
    globalVars.set("mdlMainMenu", "formName")
    globalVars.set(["CARDSETS"], "formParams")
    globalVars.set("YES", "breakLoop")


def button_down(pbuttons):
  return False
