#    Triple Triad PSP
#    Copyright (C) 2006, 2007 Sakya
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
import psp2d
from core import functions, animation, graphicElement, dataStore, menu, menuElement, buttons
from formsFunction import *

"""Form messages list"""
class message(object):
  """Class message"""
  def __init__(self):
    self.id = None
    self.status = None
    self.sender = None
    self.to = None
    self.dateTime = None
    self.header = None
    self.text = None

formGraphics = dataStore()
formVars = dataStore()
formVars.set(formGraphics, "formGraphics")
globalVars = None

def init(pGlobalVars, pParams):
  global formVars, globalVars, formGraphics

  formGraphics = dataStore()
  formVars = dataStore()
  formVars.set(formGraphics, "formGraphics")
  globalVars = pGlobalVars

  formVars.set(psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_bg_messages.png'), "bkgImage")
  formVars.set('themes/' + globalVars.get("userData").THEME + '/gm_bg_messages.png', "bkgImageName")
  formVars.set(0, "bkgImagePosX")
  formVars.set(0, "bkgImagePosY")

  formVars.set([], "messages")

  formVars.set(False, "menuCreated")

  formVars.set(psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_newmessage.png'), "iconNewMessage")
  formVars.set(psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_message.png'), "iconMessage")
  formVars.set(psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_delmessage.png'), "iconDelMessage")
  formVars.set(psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_userinfo.png'), "iconUserInfo")
  formVars.set(psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_replymessage.png'), "iconReply")


  #Carico icone degli elementi:
  formVars.set(globalVars.get("elements"), "elements")

  #Titolo:
  graph = graphicElement()
  graph.name = "TITLE"
  graph.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_bg_title.png')
  graph.posX = -476
  graph.posY = 2
  anim = animation()
  anim.name = graph.name
  anim.data = [2, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)

  graph = graphicElement()
  graph.name = "TITLET"
  graph.font = globalVars.get("fonts").get("fontTitle")
  graph.posY = 4
  graph.text = globalVars.get("messages").GM_MESSAGES_TITLE
  graph.posX = -functions.textWidth(graph.font, graph.text)
  anim = animation()
  anim.name = graph.name
  anim.data = [(480 - functions.textWidth(graph.font, graph.text)) / 2, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)

  #Testo di un messaggio:
  graph = graphicElement()
  graph.name = "MESSAGE"
  graph.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_msgmessage.png')
  graph.data = psp2d.Image(graph.image)
  graph.posX = -440
  graph.posY = 163
  anim = animation()
  anim.name = graph.name
  anim.data = [2, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)

  #Messaggi:
  formGraphics.set(createMessagesGE(globalVars, formVars))

  #Menu lista dei messaggi:
  messageList = menu(formGraphics, pGlobalVars, formVars)
  messageList.name = "MESSAGE_LIST"
  messageList.background_image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_bg_msglist.png')
  messageList.menuHeight = 110
  messageList.menuWidth = 324
  messageList.posX = 2
  messageList.posY = 41
  messageList.selector = "RIGHT"
  messageList.menuAlignment = "LEFT"
  def code(globalVars, formVars, menu, element):
    #Torno al gioco:
    globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingSound")
    globalVars.get("playingSound").start()
    globalVars.get("net").changeStatus("N")
    globalVars.set(["RESTORE"], "formParams")
    globalVars.set("mdlGame", "formName")
    globalVars.set("YES", "breakLoop")
  messageList.trigger_cancel = code
  formVars.set(messageList, "messageList")
  formVars.set(messageList, "formMenu")
  formVars.set("LIST", "status")

  #Menu di un messaggio:
  messageMenu = menu(formGraphics, pGlobalVars, formVars)
  messageMenu.name = "MESSAGEMENU"
  messageMenu.background_image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_bg_msgmenu.png')
  messageMenu.menuWidth = 150
  messageMenu.menuHeight = 120
  messageMenu.selector = "LEFT"
  messageMenu.menuAlignment = "RIGHT"
  messageMenu.posX = 480 - messageMenu.menuWidth - 2
  messageMenu.posY = 41
  formVars.set(messageMenu, "messageMenu")
  createMessageMenu()

  #Timer aggiornamento lista:
  graph = graphicElement()
  graph.name = "UPDATE"
  anim = animation()
  def code(globalVars, formVars, target):
    if not target.data \
    or globalVars.get("currentFPSTime") - target.data >= 30:
      if target.visible:
        globalVars.get("net").messageList(messageListCallback)
        target.visible = False
      target.data = globalVars.get("currentFPSTime")
  anim.name = graph.name
  anim.lockKeyboard = False
  anim.code = code
  graph.animation = anim
  formGraphics.set(graph)


def messageListCallback(pResponse, pError):
  """Update message list"""
  formGraphics.get("UPDATE").visible = True

  if pError:
    waitMessage(globalVars, formVars, pError[1][1], False, 10)
    return

  response = functions.analyzeServerString(pResponse)
  formVars.set([], "messages")
  for m in response:
    cm = m.split("||")
    if len(cm) >= 6:
      #Carico i messaggi:
      msg = message()
      msg.id = cm[0]
      msg.status = cm[1]
      msg.sender = cm[2]
      msg.dateTime = cm[3]
      msg.header = cm[4]
      msg.text = cm[5]
      formVars.get("messages").append(msg)
  createMessageList()


def createMessageList():
  """Create elements of message list menu"""
  functions.waitSafeMenu(formVars.get("messageList"))

  sel = formVars.get("messageList").selected
  firstV = formVars.get("messageList").firstVisible
  lastV = formVars.get("messageList").lastVisible
  formVars.get("messageList").creating = True
  formVars.get("messageList").selected = None
  formVars.get("messageList").firstVisible = None
  formVars.get("messageList").lastVisible = None
  formVars.get("messageList").elements = []
  for msg in formVars.get("messages"):
    tElement = menuElement()
    tElement.data = msg
    if msg.status == "0":
      tElement.icon = formVars.get("iconNewMessage")
    else:
      tElement.icon = formVars.get("iconMessage")
    tElement.value = msg.id
    tElement.text = msg.sender + ": \"" + msg.header + "\""
    def code(globalVars, formVars, menu, element):
      #Apro il menu del messaggio:
      globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
      globalVars.get("playingSound").start()
      showMessageMenu()
    tElement.trigger_select = code

    def code(globalVars, formVars, menu, element):
      #Aggiorno la finestra col messaggio:
      updateMessage()
    tElement.trigger_enter = code

    if tElement.value == sel:
      formVars.get("messageList").selected = sel
    if firstV and tElement.value == firstV.value:
      formVars.get("messageList").firstVisible = tElement
    if lastV and tElement.value == lastV.value:
      formVars.get("messageList").lastVisible = tElement

    formVars.get("messageList").elements.append(tElement)

  if not formVars.get("messageList").selected and len(formVars.get("messageList").elements) > 0:
    if formVars.get("messageList").firstVisible:
      formVars.get("messageList").selected = formVars.get("messageList").firstVisible.value
    else:
      formVars.get("messageList").selected = formVars.get("messageList").elements[0].value

  if not formVars.get("menuCreated"):
    formVars.set(True, "menuCreated")
    formVars.get("messageList").createGraphicElements("RIGHT")
  else:
    formVars.get("messageList").createGraphicElements()
  if formVars.get("status")== "LIST":
    updateMessage()
  formVars.get("messageList").creating = False


def updateMessage():
  """Update message text"""
  msg = formGraphics.get("MESSAGE")
  msg.image = psp2d.Image(msg.data)

  sel = formVars.get("messageList").getSelected()
  if sel:
    message = sel.data
    #Lo segno come letto dopo tre secondi:
    if message.status == "0":
      #Timer aggiornamento stato messaggio:
      graph = formGraphics.get("TIMER_READ")
      if not graph:
        graph = graphicElement()
        graph.name = "TIMER_READ"
      graph.data = globalVars.get("currentFPSTime")
      anim = animation()
      def code(globalVars, formVars, target):
        if not target.data \
        or globalVars.get("currentFPSTime") - target.data >= 3:
          if formVars.get("formMenu"):
            message = formVars.get("messageList").getSelected().data
            if message:
              globalVars.get("net").readMessage(message.id)
              formGraphics.get("UPDATE")
              target.name = "DEL_" + target.name
      anim.name = graph.name
      anim.lockKeyboard = False
      anim.code = code
      graph.animation = anim
      formGraphics.set(graph)
    posX = 5
    posY = 5
    tHeight = functions.textHeight(globalVars.get("fonts").get("fontMenuSel"), "I")
    globalVars.get("fonts").get("fontMenuSel").drawText(msg.image, posX, posY + 0 * tHeight, globalVars.get("messages").GM_FROM)
    tempX = functions.textWidth(globalVars.get("fonts").get("fontMenuSel"), globalVars.get("messages").GM_FROM)
    globalVars.get("fonts").get("fontMenu").drawText(msg.image, posX + tempX, posY + 0 * tHeight, message.sender)
    tDate = functions.formatDateTime(message.dateTime)
    globalVars.get("fonts").get("fontMenu").drawText(msg.image, msg.image.width - globalVars.get("themeOptions").MENU_BORDERWIDTH - functions.textWidth(globalVars.get("fonts").get("fontMenu"), tDate), posY + 0 * tHeight, tDate)
    globalVars.get("fonts").get("fontMenuSel").drawText(msg.image, msg.image.width - globalVars.get("themeOptions").MENU_BORDERWIDTH - functions.textWidth(globalVars.get("fonts").get("fontMenuSel"), tDate) - functions.textWidth(globalVars.get("fonts").get("fontMenuSel"), globalVars.get("messages").GM_DATE), posY + 0 * tHeight, globalVars.get("messages").GM_DATE)

    #Calcolo le righe del messaggio:
    righe = []
    riga = None
    tWidth = 0
    for p in message.text.split(" "):
      tWidth += functions.textWidth(globalVars.get("fonts").get("fontMenu"), p + " ")
      if tWidth >= msg.image.width - 10:
        righe.append(riga)
        tWidth = functions.textWidth(globalVars.get("fonts").get("fontMenu"), p)
        riga = p
      if not riga:
        riga = p
      else:
        riga += " " + p
    if riga:
      righe.append(riga)

    for i, riga in enumerate(righe):
      posX = 5
      posY = 5
      globalVars.get("fonts").get("fontMenu").drawText(msg.image, posX, posY + (i + 1) * tHeight, riga)


def createMessageMenu():
  """Create the message menu"""
  tElement = menuElement()
  tElement.text = globalVars.get("messages").GM_INFO
  tElement.helpText = globalVars.get("messages").GM_INFOH
  tElement.icon = formVars.get("iconUserInfo")
  tElement.value = "INFO"
  def code(globalVars, formVars, menu, element):
    formVars.set("PLAYER_INFO", "status")
    menu.delGraphics()
    formVars.set(None, "formMenu")

    #Informazioni sul giocatore:
    graph = graphicElement()
    graph.name = "PLAYER_INFO"
    graph.priority = 10
    graph.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_bg_playerinfo.png')

    posX = 5
    posY = 5
    tHeight = functions.textHeight(globalVars.get("fonts").get("fontMenu"), "I")
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 0 * tHeight, menu.globalVars.get("messages").GM_NAME)
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 1 * tHeight, menu.globalVars.get("messages").GM_STATUS)
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 2 * tHeight, menu.globalVars.get("messages").GM_LANG)
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 3 * tHeight, menu.globalVars.get("messages").GM_SYSTEM)
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 4 * tHeight, menu.globalVars.get("messages").GM_VERSION)
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 5 * tHeight, menu.globalVars.get("messages").GM_PLAY)
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, 60 - functions.textWidth(globalVars.get("fonts").get("fontMenuSel"), menu.globalVars.get("messages").GM_WIN), posY + 6 * tHeight, menu.globalVars.get("messages").GM_WIN)
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, 60 * 2 - functions.textWidth(globalVars.get("fonts").get("fontMenuSel"), menu.globalVars.get("messages").GM_DRAW), posY + 6 * tHeight, menu.globalVars.get("messages").GM_DRAW)
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, 60 * 3 - functions.textWidth(globalVars.get("fonts").get("fontMenuSel"), menu.globalVars.get("messages").GM_LOSE), posY + 6 * tHeight, menu.globalVars.get("messages").GM_LOSE)

    tX = 480 - 202
    tY = formVars.get("messageMenu").posY
    graph.posX = 480
    graph.posY = tY
    anim = animation()
    anim.name = graph.name
    anim.data = [tX, tY, 99]
    anim.code = functions.moveFromTo
    graph.animation = anim
    menu.formGraphics.set(graph)
    globalVars.get("net").playerInfo(formVars.get("messageList").getSelected().data.sender, playerInfoCallback)

  tElement.trigger_select = code
  formVars.get("messageMenu").elements.append(tElement)

  tElement = menuElement()
  tElement.value = "REPLY"
  tElement.text = globalVars.get("messages").GM_REPLY
  tElement.helpText = globalVars.get("messages").GM_REPLYH
  tElement.icon = formVars.get("iconReply")
  def code(globalVars, formVars, menu, element):
    #Scrivo un nuovo messaggio:
    globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
    globalVars.get("playingSound").start()
    if formVars.get("messageList").getSelected().data.header[:3] != "RE:":
      header = "RE:" + formVars.get("messageList").getSelected().data.header
    globalVars.get("net").readMessage(formVars.get("messageList").getSelected().data.id)
    hideMessageMenu()
    globalVars.set("mdlNewMessage", "formName")
    globalVars.set([formVars.get("messageList").getSelected().data.sender, formVars.get("messageList").getSelected().data.header, "mdlMessages", None], "formParams")
    globalVars.set("YES", "breakLoop")
  tElement.trigger_select = code
  formVars.get("messageMenu").elements.append(tElement)

  tElement = menuElement()
  tElement.value = "DELETE"
  tElement.text = globalVars.get("messages").GM_DELETE
  tElement.helpText = globalVars.get("messages").GM_DELETEH
  tElement.icon = formVars.get("iconDelMessage")
  def code(globalVars, formVars, menu, element):
    #Chiedo conferma della cancellazione:
    graph = graphicElement()
    graph.name = "CONFIRM"
    graph.data = [menu.menuWidth, 20, menu.globalVars.get("themeOptions").MENU_OUTERCOLOR, menu.globalVars.get("themeOptions").MENU_INNERCOLOR, menu.globalVars.get("themeOptions").MENU_CORNERCOLOR, menu.globalVars.get("themeOptions").MENU_BORDERWIDTH, menu.globalVars.get("themeOptions").MENU_ALPHA]
    graph.image = functions.drawRect(graph)
    text = menu.globalVars.get("messages").GM_CONFIRMDELETE
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, (graph.image.width - functions.textWidth(globalVars.get("fonts").get("fontMenuSel"), text)) / 2, 2, text)
    graph.posX = menu.posX - 1
    graph.posY = menu.posY
    menu.formGraphics.set(graph)

    globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
    globalVars.get("playingSound").start()
    menu.delGraphics()
    formVars.set(confirm(globalVars, formVars, formGraphics, menu.menuWidth, menu.menuHeight - graph.image.height, menu.posX, menu.posY + graph.image.height + 1), "formMenu")
    formVars.get("formMenu").background_image = psp2d.Image('themes/' + menu.globalVars.get("userData").THEME + '/formsbg/gm_confirm.png')
    def code(globalVars, formVars, menu, element):
      #Cancello il messaggio:
      globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
      globalVars.get("playingSound").start()
      globalVars.get("net").deleteMessage(formVars.get("messageList").getSelected().data.id)
      delGraphic(formGraphics, "CONFIRM")
      menu.formGraphics.get("UPDATE").data = None
      #Tolgo la riga dal menu:
      for m in formVars.get("messages"):
        if m.id == formVars.get("messageList").getSelected().data.id:
          formVars.get("messages").remove(m)
          break
      updateMessage()
      createMessageList()
      hideMessageMenu()
    formVars.get("formMenu").elements[0].trigger_select = code

    def code(globalVars, formVars, menu, element):
      #Chiudo il menu:
      globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingSound")
      globalVars.get("playingSound").start()
      delGraphic(formGraphics, "CONFIRM")
      menu.delGraphics()
      showMessageMenu()
    formVars.get("formMenu").elements[1].trigger_select = code
    formVars.get("formMenu").createGraphicElements()
    formVars.get("formMenu").trigger_cancel = code
  tElement.trigger_select = code

  formVars.get("messageMenu").elements.append(tElement)

  def code(globalVars, formVars, menu, element):
    #Chiudo il menu:
    globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingSound")
    globalVars.get("playingSound").start()
    hideMessageMenu()
  formVars.get("messageMenu").trigger_cancel = code


def showMessageMenu():
  """Show message menu"""
  sel = formVars.get("formMenu").getGraphicElement("MENU_SELECTOR_RIGHT")
  if sel:
    sel.visible = False
  sel = formVars.get("formMenu").getGraphicElement("MENU_SELECTOR_LEFT")
  if sel:
    sel.visible = False
  formVars.get("messageMenu").selected = "INFO"
  if formVars.get("status") == "LIST":
    formVars.get("messageMenu").createGraphicElements("RIGHT")
  else:
    formVars.get("messageMenu").createGraphicElements()
  formVars.set(formVars.get("messageMenu"), "formMenu")
  formVars.set("MESSAGEMENU", "status")


def hideMessageMenu():
  """Hide message menu"""
  formVars.set("LIST", "status")
  formVars.get("formMenu").delGraphics()
  formVars.set(formVars.get("messageList"), "formMenu")
  formVars.get("formMenu").getGraphicElement("MENU_SELECTOR_RIGHT").visible = True


def playerInfoCallback(pResponse, pError):
  #Visualizzo le informazioni del giocatore:
  if pError:
    waitMessage(globalVars, formVars, pError[1][1], False, 10)
    return

  response = functions.analyzeServerString(pResponse)
  if len(response) > 0:
    graph = formGraphics.get("PLAYER_INFO")
    posX = 5
    posY = 5
    tHeight = functions.textHeight(globalVars.get("fonts").get("fontMenu"), "I")
    elementImage = eval("globalVars.get(\"images\").get(\"element" + response[9].title() + "Image\")")
    graph.image.blit(elementImage, 0, 0, elementImage.width, elementImage.height, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), globalVars.get("messages").GM_NAME + " "), posY + 0 * tHeight, True)
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), globalVars.get("messages").GM_NAME + " ") + elementImage.width, posY + 0 * tHeight, response[0])
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), globalVars.get("messages").GM_STATUS + " "), posY + 1 * tHeight, eval("globalVars.get(\"messages\").GM_STATUS_" + response[1][:1]))
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), globalVars.get("messages").GM_LANG + " "), posY + 2 * tHeight, response[2])
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), globalVars.get("messages").GM_SYSTEM + " "), posY + 3 * tHeight, response[7])
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), globalVars.get("messages").GM_VERSION + " "), posY + 4 * tHeight, response[8])
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), globalVars.get("messages").GM_PLAY + " "), posY + 5 * tHeight, response[3])
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, 60 - functions.textWidth(globalVars.get("fonts").get("fontMenu"), response[4]), posY + 7 * tHeight, str(response[4]))
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, 60 * 2 - functions.textWidth(globalVars.get("fonts").get("fontMenu"), response[6]), posY + 7 * tHeight, str(response[6]))
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, 60 * 3 - functions.textWidth(globalVars.get("fonts").get("fontMenu"), response[5]), posY + 7 * tHeight, str(response[5]))


def button_down(pbuttons):
  #Gestione pressione tasti:
  if formVars.get("status") == "PLAYER_INFO":
    #Nascondo le informazioni del giocatore:
    globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingSound")
    globalVars.get("playingSound").start()
    delGraphic(formGraphics, "PLAYER_INFO")
    formVars.get("messageMenu").createGraphicElements("RIGHT")
    formVars.set(formVars.get("messageMenu"), "formMenu")
    formVars.set("PLAYER_MENU", "status")
    return True
