#    Triple Triad PSP
#    Copyright (C) 2006, 2007 Sakya
#    sakya_tg@yahoo.it
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
import psp2d
from core import functions, animation, graphicElement, dataStore, menu, menuElement, buttons, gameType, TTplayer, helpItem
from formsFunction import *

"""Form for manage my cards"""
formGraphics = dataStore()
formVars = dataStore()
formVars.set(formGraphics, "formGraphics")
globalVars = None

def init(pGlobalVars, pParams):
  global formVars, globalVars, formGraphics

  formGraphics = dataStore()
  formVars = dataStore()
  formVars.set(formGraphics, "formGraphics")
  globalVars = pGlobalVars

  #Mi salvo il tipo (per sapere se devo tornare alla form precedente
  #o se devo proseguire alla partita):
  formVars.set(None, "type")
  formVars.set(None, "roomID")
  formVars.set(None, "player1_ID")
  formVars.set(None, "player1_Name")
  formVars.set(None, "player2_ID")
  formVars.set(None, "player2_Name")
  if pParams and len(pParams) > 0:
    formVars.set(pParams[0], "type")
    formVars.set(pParams[1], "roomID")
    if globalVars.get("player").name == pParams[2]:
      formVars.set(pParams[3], "player1_ID")
      formVars.set(pParams[2], "player1_Name")
      formVars.set(pParams[4], "player2_ID")
      formVars.set(pParams[5], "player2_Name")
      opponentsName = pParams[5]
    else:
      formVars.set(pParams[4], "player1_ID")
      formVars.set(pParams[5], "player1_Name")
      formVars.set(pParams[3], "player2_ID")
      formVars.set(pParams[2], "player2_Name")
      opponentsName = pParams[2]
    #Chiedo le info dell'avversario:
    globalVars.get("net").playerInfo(opponentsName, playerInfoCallback)
    formVars.set(TTplayer(), "opponent")

  #Livello visualizzato:
  formVars.set(1, "levelShown")
  formVars.set("NAME", "order")

  formVars.set(psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_bg_mycards.png'), "bkgImage")
  formVars.set(globalVars.get("userData").THEME + '/gm_bg_mycards.png', "bkgImageName")
  formVars.set(0, "bkgImagePosX")
  formVars.set(0, "bkgImagePosY")

  formVars.set(False, "menuCreated")
  formVars.set(0, "currentSlot")
  formVars.set(0, "lastSlot")

  organizeCards()

  #Titolo:
  graph = graphicElement()
  graph.name = "TITLE"
  graph.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_mycards_title.png')
  graph.image.blit(globalVars.get("images").get("levelDown"), 0, 0, globalVars.get("images").get("levelDown").width, globalVars.get("images").get("levelDown").height, 0, 0, True)
  graph.image.blit(globalVars.get("images").get("levelUp"), 0, 0, globalVars.get("images").get("levelUp").width, globalVars.get("images").get("levelUp").height, graph.image.width - globalVars.get("images").get("levelUp").width, 0, True)
  graph.posX = -390
  graph.posY = 2
  anim = animation()
  anim.name = graph.name
  anim.data = [88, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)

  graph = graphicElement()
  graph.name = "TITLET"
  graph.font = globalVars.get("fonts").get("fontTitle")
  graph.posY = 4
  graph.text = graph.text = globalVars.get("messages").GM_MYCARDS_TITLE + " " + globalVars.get("messages").LEVEL + " " + str(formVars.get("levelShown"))
  graph.posX = -functions.textWidth(graph.font, graph.text)
  anim = animation()
  anim.name = graph.name
  anim.data = [(480 - functions.textWidth(graph.font, graph.text)) / 2 + 44, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)

  #Messaggi:
  formGraphics.set(createMessagesGE(globalVars, formVars))

  #Card info:
  graph = graphicElement()
  graph.name = "CARDINFO"
  graph.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_mycards_info.png')
  graph.imageBuffer = psp2d.Image(graph.image)
  graph.posX = 480
  graph.posY = 41
  anim = animation()
  anim.name = graph.name
  anim.data = [258, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)

  #Deck info:
  graph = graphicElement()
  graph.name = "DECKINFO"
  graph.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_mycards_dinfo.png')
  graph.imageBuffer = psp2d.Image(graph.image)
  graph.posX = 480
  graph.posY = 174
  anim = animation()
  anim.name = graph.name
  anim.data = [258, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)

  #Slot selector:
  graph = graphicElement()
  graph.name = "SLOT_SELECTOR"
  graph.priority = 100
  graph.visible = False
  graph.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/selector_right.png')
  graph.data = graph.image
  graph.posX = 0
  graph.posY = 0
  graph.visible = False
  anim = animation()
  anim.name = graph.name
  anim.lockKeyboard = False
  anim.data = [+0.5,0]
  anim.code = functions.selectorAnim
  graph.animation = anim
  formGraphics.set(graph)

  cardsMenu = menu(formGraphics, globalVars, formVars)
  cardsMenu.background_image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_mycards_menu.png')
  cardsMenu.name = "CARDLIST_" +  str(formVars.get("levelShown"))
  cardsMenu.posX = 88
  cardsMenu.posY = 41
  cardsMenu.menuWidth = 168
  cardsMenu.menuHeight = 193
  cardsMenu.menuAlignment = "LEFT"
  cardsMenu.menuVAlignment = "CENTER"
  cardsMenu.selector = "RIGHT"
  formVars.set(cardsMenu, "cardsMenu")

  showCardsMenu()
  createDeck()
  setHelp()


def organizeCards():
  """Organize player cards for menu"""
  #Divido le carte per livello:
  formVars.set([[] for i in xrange(0,11)], "playerCardsByLevel")
  for card in globalVars.get("playerCards"):
    formVars.get("playerCardsByLevel")[card.level].append(card)


def playerInfoCallback(pResponse, pError):
  """Opponent's info callback"""
  if pError:
    waitMessage(globalVars, formVars, pError[1][1], False, 10)
    return

  response = functions.analyzeServerString(pResponse)
  if len(response) >= 10:
    player = analyzePlayerInfo(response)
    formVars.set(player, "opponent")


def showPlayerInfo():
  """Show opponent's info"""
  formVars.set("PLAYERINFO", "status")
  formVars.get("formMenu").hideSelectors()

  #Sposto le informazioni sulla carta:
  graph = formGraphics.get("CARDINFO")
  anim = animation()
  anim.name = graph.name
  anim.data = [480, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim

  player = formVars.get("opponent")
  graph = drawPlayerInfo(globalVars, player, "gm_mycards_info.png")

  tX = formGraphics.get("CARDINFO").posX
  tY = formGraphics.get("CARDINFO").posY
  graph.posX = 480
  graph.posY = tY
  anim = animation()
  anim.name = graph.name
  anim.data = [tX, tY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)


def hidePlayerInfo():
  """Hide opponent's info"""
  formVars.get("formMenu").showSelectors()
  formVars.set("MENU", "status")
  #Sposto le informazioni sull'avversario:
  graph = formGraphics.get("PLAYER_INFO")
  anim = animation()
  anim.name = graph.name
  anim.data = [480, graph.posY, 99]
  anim.code = functions.moveFromToAndDelete
  graph.animation = anim
  #Sposto le informazioni sulla carta:
  graph = formGraphics.get("CARDINFO")
  anim = animation()
  anim.name = graph.name
  anim.data = [258, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim


def showCardsMenu():
  """Show player cards"""
  formVars.set("MENU", "status")

  #Controllo ordinamento:
  if formVars.get("order") == "CARDSET":
    tCards = [[card.cardSetName, card.name, card] for card in formVars.get("playerCardsByLevel")[formVars.get("levelShown")]]
  elif formVars.get("order") == "NAME":
    tCards = [[card.name, card.name, card] for card in formVars.get("playerCardsByLevel")[formVars.get("levelShown")]]
  tCards.sort()

  pList = formVars.get("cardsMenu")
  if formVars.get("formMenu") \
  and formVars.get("formMenu").name != "CARDLIST_" +  str(formVars.get("levelShown")):
    pList.delGraphics()
  pList.clear()
  pList.background_image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_mycards_menu.png')
  pList.name = "CARDLIST_" +  str(formVars.get("levelShown"))
  pList.posX = 88
  pList.posY = 41
  pList.menuWidth = 168
  pList.menuHeight = 193
  pList.menuAlignment = "LEFT"
  pList.menuVAlignment = "CENTER"
  pList.selector = "RIGHT"
  for card in tCards:
    card = card[2]
    tElement = menuElement()
    tElement.text = card.name
    tElement.value = str(card.ID)
    tElement.data = card
    def code(globalVars, formVars, menu, element):
      #Aggiorno le info della carta:
      updateCardInfo()
    tElement.trigger_enter = code
    pList.elements.append(tElement)
    def code(globalVars, formVars, menu, element):
      #Seleziono la carta:
      formVars.set("POSITIONING", "status")
      formVars.set(formVars.get("currentSlot"), "lastSlot")
      selectSlot()
    tElement.trigger_select = code
  def code(globalVars, formVars, menu, element):
    if formVars.get("type") == "START-MULTI":
      enterGame()
    else:
      #Torno al gioco:
      globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingSound")
      globalVars.get("playingSound").start()
      globalVars.get("net").changeStatus("N")
      globalVars.set(["RESTORE"], "formParams")
      globalVars.set("mdlGame", "formName")
      globalVars.set("YES", "breakLoop")
  pList.trigger_cancel = code

  if len(pList.elements) > 0:
    pList.selected = pList.elements[0].value

  if not formVars.get("menuCreated"):
    pList.createGraphicElements("BOTTOM")
    formVars.set(True, "menuCreated")
  else:
    pList.createGraphicElements()
  formVars.set(pList, "formMenu")
  updateCardInfo()


def waitOpponentsDeckCallback(pResponse, pError):
  """Attesa mazzo avversario"""
  if pError:
    waitMessage(globalVars, formVars, pError[1][1], False, 10)
    return

  response = functions.analyzeServerString(pResponse)
  if response[0] == "OK":
    #Avvio la partita:
    gType = gameType()
    gType.type = "MULTI"
    gType.roomID = formVars.get("roomID")
    gType.player1_ID = formVars.get("player1_ID")
    gType.player1_Name = formVars.get("player1_Name")
    gType.player2_ID = formVars.get("player2_ID")
    gType.player2_Name = formVars.get("player2_Name")
    globalVars.set("mdlTripleTriad", "formName")
    globalVars.set([gType], "formParams")
    globalVars.set("YES", "breakLoop")
  elif response[0] == "KO":
    #E' andata male, torno alla form di gioco:
    globalVars.get("net").changeStatus("N")
    globalVars.set(["RESTORE"], "formParams")
    globalVars.set("mdlGame", "formName")
    globalVars.set("YES", "breakLoop")
  else:
    formGraphics.get("WAITOPPONENTS").visible = True


def enterGame():
  #Controllo che il mazzo abbia cinque carte:
  for deckCard in globalVars.get("player").deck:
    if not deckCard:
      waitMessage(globalVars, formVars, globalVars.get("messages").GM_INVALIDDECK, False, 5, 88)
      return

  #Timer per uscire dopo xx secondi:
  def hideFunction():
    doLockKeyboard(globalVars, formVars)
  addTimeoutRestore(globalVars, formVars, globalVars.get("userData").TIMEOUT_DECK, globalVars.get("messages").GM_WAITOPPONENTS, pHideFunction=hideFunction)

  #Confermo il mio mazzo:
  globalVars.get("net").confirmDeck(formVars.get("roomID"), None)

  #Aspetto l'altro giocatore:
  waitMessage(globalVars, formVars, globalVars.get("messages").GM_WAITOPPONENTS, pToX=88)
  sel = formVars.get("formMenu").getGraphicElement("MENU_SELECTOR_RIGHT")
  if sel:
    sel.visible = False

  graph = graphicElement()
  graph.name = "WAITOPPONENTS"
  anim = animation()
  def code(globalVars, formVars, target):
    if not target.data \
    or globalVars.get("currentFPSTime") - target.data >= 2:
      if target.visible == True:
        globalVars.get("net").waitOpponentsDeck(formVars.get("roomID"), waitOpponentsDeckCallback)
        target.visible = False
      target.data = globalVars.get("currentFPSTime")
  anim.name = graph.name
  anim.lockKeyboard = False
  anim.code = code
  graph.animation = anim
  formGraphics.set(graph)


def selectSlot():
  """Select first slot"""
  if formVars.get("formMenu"):
    mGraph = formVars.get("formMenu").getGraphicElement("MENU_SELECTOR_RIGHT")
    mGraph.visible = False

  if formVars.get("lastSlot") != formVars.get("currentSlot"):
    deselectSlot(formVars.get("lastSlot"))

  #Sposto la manina:
  graph = formGraphics.get("SLOT_SELECTOR")
  #delGraphic(formGraphics, "SLOT_SELECTOR")
  #formGraphics.set(graph)
  if formVars.get("formMenu"):
    graph.posX = mGraph.posX
    graph.posY = mGraph.posY
  graph.visible = True
  anim = animation()
  anim.name = graph.name
  anim.front = True
  anim.exclusive = True
  slot = formGraphics.get(str(formVars.get("currentSlot")))
  toY = slot.posY + 37
  anim.data = [80, toY]
  anim.code = functions.moveFromTo
  graph.animation = anim

  #Sposto la carta:
  anim = animation()
  anim.name = slot.name
  anim.data = [slot.posX + 10, slot.posY]
  anim.code = functions.moveFromTo
  slot.animation = anim
  if slot.data:
    globalVars.set(slot.data.stringValue(), "message")

  #Riattivo l'animazione standard:
  graph = graphicElement()
  graph.name = "CHANGE_SELECTOR_ANIM"
  anim = animation()
  anim.name = graph.name
  anim.priority = -200
  def code(globalVars, formVars, target):
    graph = formGraphics.get("SLOT_SELECTOR")
    anim = animation()
    anim.name = graph.name
    anim.lockKeyboard = False
    anim.data = [+0.5,0]
    anim.code = functions.selectorAnim
    graph.animation = anim
    target.name = "DEL_" + target.name
  anim.code = code
  graph.animation = anim
  formGraphics.set(graph)
  formVars.set(None, "formMenu")


def deselectSlot(pSlot):
  """Deselect last slot"""
  #Deselezioni la carta:
  slot = formGraphics.get(str(pSlot))
  anim = animation()
  anim.name = slot.name
  anim.data = [slot.posX - 10, slot.posY]
  anim.code = functions.moveFromTo
  slot.animation = anim


def updateCardInfo():
  """Update card Info"""
  graph = formGraphics.get("CARDINFO")
  graph.image = psp2d.Image(graph.imageBuffer)

  sel = formVars.get("formMenu").getSelected()
  if sel:
    card = sel.data

    posX = 80
    posY = 5
    tHeight = functions.textHeight(globalVars.get("fonts").get("fontMenu"), "I")
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 0 * tHeight, card.cardSetName)
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 1 * tHeight, globalVars.get("messages").LEVEL)
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 2 * tHeight, globalVars.get("messages").TOP)
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 3 * tHeight, globalVars.get("messages").RIGHT)
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 4 * tHeight, globalVars.get("messages").BOTTOM)
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 5 * tHeight, globalVars.get("messages").LEFT)
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 6 * tHeight, globalVars.get("messages").ELEMENTAL)

    zero = functions.textWidth(globalVars.get("fonts").get("fontMenu"), "0")
    posX = 215
    posY = 5
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(card.level)) - (zero - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(card.level))) / 2, posY + 1 * tHeight, str(card.level))
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(card.top)) - (zero - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(card.top))) / 2, posY + 2 * tHeight, str(card.top))
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(card.right)) - (zero - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(card.right))) / 2, posY + 3 * tHeight, str(card.right))
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(card.bottom)) - (zero - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(card.bottom))) / 2, posY + 4 * tHeight, str(card.bottom))
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(card.left)) - (zero - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(card.left))) / 2, posY + 5 * tHeight, str(card.left))
    if card.elementalString:
      globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(card.elementalString)), posY + 6 * tHeight, str(card.elementalString))
    else:
      globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX - functions.textWidth(globalVars.get("fonts").get("fontMenu"), "-") - (zero - functions.textWidth(globalVars.get("fonts").get("fontMenu"), "-")) / 2, posY + 6 * tHeight, "-")
    tStr = globalVars.get("messages").GM_YOUHAVE + " " + str(card.count) + " " + globalVars.get("messages").GM_THISCARD
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX - functions.textWidth(globalVars.get("fonts").get("fontMenu"), tStr), posY + 7 * tHeight, tStr)

    #Immagine carta:
    cardImage = card.writeValues(psp2d.Image(card.imageP1))
    graph.image.blit(cardImage, 0, 0, cardImage.width, cardImage.height, 5, 5)
  updateDeckInfo()


def updateDeckInfo():
  """Update deck info"""
  graph = formGraphics.get("DECKINFO")
  graph.image = psp2d.Image(graph.imageBuffer)
  sel = formVars.get("formMenu").getSelected()
  if sel:
    card = sel.data
  else:
    card = None

  #Valore carta:
  posX = 5
  posY = 5
  tHeight = functions.textHeight(globalVars.get("fonts").get("fontMenu"), "I")
  globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 0 * tHeight, globalVars.get("messages").GM_CARDPOWER)
  globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 1 * tHeight, globalVars.get("messages").GM_DECKPOWER)
  #Valore mazzo:
  deckVal = 0
  totTop = 0.0
  totRight = 0.0
  totBottom = 0.0
  totLeft = 0.0
  for tCard in globalVars.get("player").deck:
    if tCard:
      deckVal += tCard.value()
      totTop += tCard.top
      totRight += tCard.right
      totBottom += tCard.bottom
      totLeft += tCard.left

  zero = functions.textWidth(globalVars.get("fonts").get("fontMenu"), "0")
  posX = 120
  posY = 5
  if card:
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(card.value())) - (zero - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(card.value()))) / 2, posY + 0 * tHeight, str(card.value()))
  globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(deckVal)) - (zero - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(deckVal))) / 2, posY + 1 * tHeight, str(deckVal))

  #Grafico mazzo:
  grafico = graph.image
  posX = 160
  posY = 3
  borderColor = psp2d.Color(0,0,0, 255)
  crossColor = psp2d.Color(255,255,255, 255)
  graphColor = psp2d.Color(255,0,0, 255)
  functions.drawLine(grafico, crossColor, posX + 26, posY + 1, posX + 26, posY + 51)
  functions.drawLine(grafico, crossColor, posX + 1, posY + 26, posX + 51, posY + 26)

  functions.drawLine(grafico, borderColor, posX + 26, posY + 1, posX + 51, posY + 26)
  functions.drawLine(grafico, borderColor, posX + 51, posY + 26, posX + 26, posY + 51)
  functions.drawLine(grafico, borderColor, posX + 26, posY + 51, posX + 1, posY + 26)
  functions.drawLine(grafico, borderColor, posX + 1, posY + 26, posX + 26, posY + 1)

  #Grafico:
  maxValue = 10 * len(globalVars.get("player").deck)
  topY = int(51 / 2 - 26 * (totTop / maxValue))
  rightX = int(51 / 2 + 26 * (totRight / maxValue))
  bottomY = int(51 / 2 + 26 * (totBottom/ maxValue))
  leftX = int(51  / 2 - 26 * (totLeft / maxValue))
  functions.drawLine(grafico, graphColor, posX + 26, posY + topY, posX + rightX, posY + 26)
  functions.drawLine(grafico, graphColor, posX + rightX, posY + 26, posX + 26, posY + bottomY)
  functions.drawLine(grafico, graphColor, posX + 26, posY + bottomY, posX + leftX, posY + 26)
  functions.drawLine(grafico, graphColor, posX + leftX, posY + 26, posX + 26, posY + topY)


def createDeck():
  """Create deck graphic elements"""
  for i, card in enumerate(globalVars.get("player").deck):
    graph = graphicElement()
    graph.name = str(i)
    graph.data = card
    if card:
      graph.image = card.writeValues(psp2d.Image(card.imageP1))
    graph.posX = 2
    graph.posY = -100
    graph.priority = i
    anim = animation()
    anim.name = "MOVECARD_" + str(i)
    anim.data = [graph.posX, 3 + 43 * i]
    anim.priority = 99 - i
    anim.code = functions.moveFromTo
    graph.animation = anim
    formGraphics.set(graph)


def updateTitle():
  """Update form title"""
  graph = formGraphics.get("TITLET")
  graph.image = None
  graph.text = globalVars.get("messages").GM_MYCARDS_TITLE + " " + globalVars.get("messages").LEVEL + " " + str(formVars.get("levelShown"))
  graph.posX = (480 - functions.textWidth(graph.font, graph.text)) / 2 + 44


def addToDeckCallback(pResponse, pError):
  """Drop a card in the deck"""
  if pError:
    waitMessage(globalVars, formVars, pError[1][1], False, 10, 88)
    return

  formGraphics.get("SLOT_SELECTOR").visible = True
  response = functions.analyzeServerString(pResponse)
  if len(response) >= 1:
    if response[0] == "OK":
      hideWaitMessage(globalVars, formVars)
      #Posiziono la carta:
      slot = formGraphics.get(str(formVars.get("currentSlot")))
      card = slot.data
      if card:
        #Aggiungo la carta tolta a quelle libere:
        if card.ID in globalVars.get("playerCardsIndex"):
          tCard = globalVars.get("playerCards")[globalVars.get("playerCardsIndex").index(card.ID)]
          tCard.count += 1
        else:
          card.count = 1
          globalVars.get("playerCards").append(card)
          globalVars.get("playerCardsIndex").append(card.ID)
          formVars.get("playerCardsByLevel")[card.level].append(card)

      card = formVars.get("cardsMenu").getSelected().data
      slot.data = card
      slot.image = card.writeValues(psp2d.Image(card.imageP1))
      #Tolgo la carta da quelle libere:
      if card.ID in globalVars.get("playerCardsIndex"):
        tCard = globalVars.get("playerCards")[globalVars.get("playerCardsIndex").index(card.ID)]
        tCard.count -= 1
        if tCard.count == 0:
          globalVars.get("playerCards").remove(tCard)
          globalVars.get("playerCardsIndex").remove(tCard.ID)
          formVars.get("playerCardsByLevel")[tCard.level].remove(tCard)

      #Aggiungo la carta al deck:
      globalVars.get("player").deck[formVars.get("currentSlot")] = card

      #Torno al menu:
      graph = graphicElement()
      graph.name = "MOVE_SELECTOR"
      anim = animation()
      anim.name = graph.name
      anim.priority = 100
      anim.exclusive = True
      def code(globalVars, formVars, target):
        showCardsMenu()
        sel = formVars.get("cardsMenu").getGraphicElement("MENU_SELECTOR_RIGHT")
        if sel:
          sel.visible = False
        deselectSlot(formVars.get("currentSlot"))
        graph = formGraphics.get("SLOT_SELECTOR")

        anim = animation()
        anim.priority = 100
        anim.exclusive = True
        anim.name = graph.name
        anim.data = [int(sel.posX), int(sel.posY), 99]
        anim.code = functions.moveFromTo
        graph.animation = anim
        target.name = "DEL_" + target.name
      anim.code = code
      graph.animation = anim
      formGraphics.set(graph)

      graph = graphicElement()
      graph.name = "BACK_TO_MENU"
      anim = animation()
      anim.name = graph.name
      anim.priority = 90
      def code(globalVars, formVars, target):
        formVars.set("MENU", "status")
        graph = formGraphics.get("SLOT_SELECTOR")
        graph.visible = False
        formVars.set(formVars.get("cardsMenu"), "formMenu")
        sel = formVars.get("formMenu").getGraphicElement("MENU_SELECTOR_RIGHT")
        if sel:
          sel.visible = True
        target.name = "DEL_" + target.name
      anim.code = code
      graph.animation = anim
      formGraphics.set(graph)
    else:
      waitMessage(globalVars, formVars, globalVars.get("messages").GM_CANTADDTODECK, False, 5, 88)
      formGraphics.get("SLOT_SELECTOR").visible = True
  else:
    hideWaitMessage(globalVars, formVars)


def showHelp():
  """Show Help"""
  if formVars.get("formMenu"):
    formVars.get("formMenu").hideSelectors()
    return True


def hideHelp():
  """Hide Help"""
  if formVars.get("formMenu") and formVars.get("status") == "MENU":
    formVars.get("formMenu").showSelectors()
    return True


def setHelp():
  """Set form help"""
  if formVars.get("type") == "START-MULTI":
    formHelp = helpItem(formGraphics, globalVars, formVars)
    formHelp.images = [globalVars.get("images").get("buttonStart"), globalVars.get("images").get("buttonTriangle"), globalVars.get("images").get("buttonSquare")]
    formHelp.rows = [globalVars.get("messages").GH_CONFIRMDECK, globalVars.get("messages").GH_OPPONENTINFODECK, globalVars.get("messages").MH_SQUARE]
    formHelp.preShowFunc = showHelp
    formHelp.postHideFunc = hideHelp
    formVars.set(formHelp, "helpItem")


def button_down(pbuttons):
  #Gestione tasti form mycards:
  if buttons.start in pbuttons and formVars.get("type") == "START-MULTI" and formVars.get("formMenu") == formVars.get("cardsMenu"):
    enterGame()
    return True
  if formVars.get("status") == "MENU" and formVars.get("formMenu") == formVars.get("cardsMenu"):
    if buttons.left_trigger in pbuttons:
      #Cambio livello
      if formVars.get("levelShown") > 1:
        formVars.set(formVars.get("levelShown") - 1, "levelShown")
        showCardsMenu()
        updateTitle()
      return True
    elif buttons.right_trigger in pbuttons:
      #Cambio livello
      if formVars.get("levelShown") < 10:
        formVars.set(formVars.get("levelShown") + 1, "levelShown")
        showCardsMenu()
        updateTitle()
      return True
    elif buttons.select in pbuttons:
      #Cambio ordinamento:
      order = ["CARDSET", "NAME"]
      try:
        formVars.set(order[order.index(formVars.get("order")) + 1], "order")
      except:
        formVars.set(order[0], "order")
      waitMessage(globalVars, formVars, eval("globalVars.get(\"messages\").GM_ORDER_" + formVars.get("order")), False, 5, 88)
      showCardsMenu()
      return True
    elif buttons.triangle in pbuttons and formVars.get("type") == "START-MULTI":
      #Visualizzo le informazioni dell'avversario:
      showPlayerInfo()
      return True
  elif formVars.get("status") == "PLAYERINFO":
    #Nascondo le informaioni dell'avversario:
    hidePlayerInfo()
    return True
  elif formVars.get("status") == "POSITIONING":
    if buttons.cross in pbuttons:
      #Metto una carta nel deck:
      globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
      globalVars.get("playingSound").start()
      formGraphics.get("SLOT_SELECTOR").visible = False
      waitMessage(globalVars, formVars, globalVars.get("messages").GM_WAIT, pToX=88)
      globalVars.get("net").addToDeck(formVars.get("cardsMenu").getSelected().data.ID, formVars.get("currentSlot"), addToDeckCallback)
      return True
    elif buttons.circle in pbuttons:
      #Torno al menu:
      globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingSound")
      globalVars.get("playingSound").start()
      formVars.set("MENU", "status")
      deselectSlot(formVars.get("currentSlot"))
      graph = formGraphics.get("SLOT_SELECTOR")
      graph.visible = False
      formVars.set(formVars.get("cardsMenu"), "formMenu")
      formVars.get("formMenu").getGraphicElement("MENU_SELECTOR_RIGHT").visible = True
      return True
    elif buttons.down in pbuttons:
      #Seleziono il prossimo slot:
      formVars.set(formVars.get("currentSlot"), "lastSlot")
      if formVars.get("currentSlot") == 4:
        formVars.set(0, "currentSlot")
      else:
        formVars.set(formVars.get("currentSlot") + 1, "currentSlot")
      selectSlot()
      return True
    elif buttons.up in pbuttons:
      #Seleziono il prossimo slot:
      formVars.set(formVars.get("currentSlot"), "lastSlot")
      if formVars.get("currentSlot") == 0:
        formVars.set(4, "currentSlot")
      else:
        formVars.set(formVars.get("currentSlot") - 1, "currentSlot")
      selectSlot()
      return True
