#    Triple Triad PSP
#    Copyright (C) 2006, 2007 Sakya
#    sakya_tg@yahoo.it
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
import psp2d, pspsnd, pspnet
from core import graphicElement, dataStore, animation, functions, menu, menuElement, buttons, deck, cardSet
from formsFunction import *

formGraphics = dataStore()
formVars = dataStore()
formVars.set(formGraphics, "formGraphics")
globalVars = None

"""Form net options"""
def init(pGlobalVars, pParams):
  global formVars, globalVars, formGraphics

  formGraphics = dataStore()
  formVars = dataStore()
  formVars.set(formGraphics, "formGraphics")
  globalVars = pGlobalVars

  formVars.set(globalVars.get("images").get("defaultBkgImage"), "bkgImage")
  formVars.set(0, "bkgImagePosX")
  formVars.set(0, "bkgImagePosY")

  #Attivo il modulo net:
  globalVars.get("net").startServer()

  startMenu = menu(formGraphics, pGlobalVars, formVars)
  startMenu.name = "NETOPTIONS"

  #Titolo:
  graph = graphicElement()
  graph.name = "TITLE"
  graph.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_generic_title.png')
  graph.posX = -440
  graph.posY = 8
  anim = animation()
  anim.name = "TITLE"
  anim.data = [20, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)

  graph = graphicElement()
  graph.name = "TITLET"
  graph.font = globalVars.get("fonts").get("fontTitle")
  graph.posY = 10
  graph.text = globalVars.get("messages").NETOPTIONS
  graph.posX = -functions.textWidth(graph.font, graph.text)
  anim = animation()
  anim.name = "TITLE"
  anim.data = [(480 - functions.textWidth(graph.font, graph.text)) / 2, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").CONNECT
  tElement.helpText = globalVars.get("messages").CONNECTH
  tElement.value = "CONNECT"
  def code(globalVars, formVars, menu, element):
    #Controllo se il wlan e' acceso:
    if not pspnet.wlanSwitchState():
      waitMessage(globalVars, formVars, globalVars.get("messages").WLAN_ERROR, False, 5)
    else:
      #Nascondo il selector:
      sel = menu.getGraphicElement("MENU_SELECTOR_LEFT")
      if sel:
        sel.visible = False
      sel = menu.getGraphicElement("MENU_SELECTOR_RIGHT")
      if sel:
        sel.visible = False

      #Messaggio di attesa:
      waitMessage(globalVars, formVars, globalVars.get("messages").CONNECTING, True)

      #Tento la connessione:
      graph = graphicElement()
      graph.name = "TRY_CONNECT"
      graph.font = globalVars.get("fonts").get("fontMessage")
      graph.posY = 230
      graph.text = globalVars.get("messages").CONNECTING
      graph.posX = -functions.textWidth(graph.font, graph.text)
      anim = animation()
      anim.name = graph.name
      def code(globalVars, formVars, target):
        target.name = "DEL_" + target.name
        globalVars.get("net").connect(int(formVars.get("formMenu").elements[1].value.split("|")[1]), netCallback)
      anim.code = code
      graph.animation = anim
      formGraphics.set(graph)
  tElement.trigger_select = code
  startMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").CONNECTION
  tElement.helpText = globalVars.get("messages").CONNECTIONH
  if len(globalVars.get("userData").CONNECTION) > 0:
    tElement.value = "CONNECTION|" + globalVars.get("userData").CONNECTION
  else:
    tElement.value = "CONNECTION|0"
  for i, conn in enumerate(pspnet.enumConfigs()):
    tSubElement = menuElement()
    tSubElement.text = conn[1]
    tSubElement.value = str(conn[0])
    tElement.subMenu.append(tSubElement)
  startMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").SERVER
  tElement.helpText = globalVars.get("messages").SERVERH
  tElement.value = None
  for i, server in enumerate(globalVars.get("userData").serverList.LIST):
    tSubElement = menuElement()
    tSubElement.text = server[0]
    tSubElement.value = server[1]
    if tSubElement.value == globalVars.get("userData").SERVER:
      tElement.value = "SERVER|" + tSubElement.value
    tElement.subMenu.append(tSubElement)
  if tElement.value == None:
    tElement.value = "SERVER|" + tElement.subMenu[0].value
  startMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").BACK
  tElement.helpText = globalVars.get("messages").BACKH
  def code(globalVars, formVars, menu, element):
    #Disattivo la rete:
    globalVars.get("net").killServer()

    #Torno al menu start:
    globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingSound")
    globalVars.get("playingSound").start()
    globalVars.set("mdlStart", "formName")
    globalVars.set(["STARTMULTI|INFRA"], "formParams")
    globalVars.set("YES", "breakLoop")
  tElement.trigger_select = code
  startMenu.trigger_cancel = code
  tElement.value = "BACK"
  startMenu.elements.append(tElement)

  startMenu.background_image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_generic_menu.png')
  startMenu.posX = globalVars.get("themeOptions").MENU_X
  startMenu.posY = globalVars.get("themeOptions").MENU_Y
  startMenu.menuWidth = globalVars.get("themeOptions").MENU_W
  startMenu.menuHeight = globalVars.get("themeOptions").MENU_H
  startMenu.selected = startMenu.elements[0].value
  startMenu.menuAlignment = globalVars.get("themeOptions").MENU_ALIGN
  startMenu.menuVAlignment = globalVars.get("themeOptions").MENU_VALIGN

  formVars.set(startMenu, "formMenu")
  startMenu.createGraphicElements("BOTTOM")


def netCallback(state):
  #Callback per connessione:
  globalVars.get("logFile").log("CONNECTION STATUS: " + str(state))
  if state == -1:
    waitMessage(globalVars, formVars, globalVars.get("messages").CONNECTED)
    #Contatto il server:
    graph = graphicElement()
    graph.name = "SERVER_STATUS"
    anim = animation()
    anim.name = graph.name
    def code(globalVars, formVars, target):
      globalVars.get("net").serverAddress = formVars.get("formMenu").getElement("SERVER").value.split("|")[1]
      globalVars.get("net").checkServerStatus(globalVars.get("version"), statusCallback)
      target.name = "DEL_" + target.name
    anim.code = code
    graph.animation = anim
    formGraphics.set(graph)
  elif state == 99:
    #Visualizzo i selector:
    sel = formVars.get("formMenu").getGraphicElement("MENU_SELECTOR_LEFT")
    if sel:
      sel.visible = True
    sel = formVars.get("formMenu").getGraphicElement("MENU_SELECTOR_RIGHT")
    if sel:
      sel.visible = True
    waitMessage(globalVars, formVars, globalVars.get("messages").CONNECTION_ERROR, False, 5)



def statusCallback(pResponse, pError):
  #Errore:
  if pError:
    waitMessage(globalVars, formVars, pError[1][1], False, 5)
    #Visualizzo i selector:
    sel = formVars.get("formMenu").getGraphicElement("MENU_SELECTOR_LEFT")
    if sel:
      sel.visible = True
    sel = formVars.get("formMenu").getGraphicElement("MENU_SELECTOR_RIGHT")
    if sel:
      sel.visible = True
    globalVars.get("net").disconnect()
    return

  response = functions.analyzeServerString(pResponse)
  globalVars.get("net").serverStatus = response
  if response[0] == "MIN_VERSION":
    #Visualizzo i selector:
    sel = formVars.get("formMenu").getGraphicElement("MENU_SELECTOR_LEFT")
    if sel:
      sel.visible = True
    sel = formVars.get("formMenu").getGraphicElement("MENU_SELECTOR_RIGHT")
    if sel:
      sel.visible = True
    #Versione minima:
    waitMessage(globalVars, formVars, globalVars.get("messages").SERVERVERSION.replace("XX", response[1]), False, 5)
  elif response[0] == "FULL":
    #Visualizzo i selector:
    sel = formVars.get("formMenu").getGraphicElement("MENU_SELECTOR_LEFT")
    if sel:
      sel.visible = True
    sel = formVars.get("formMenu").getGraphicElement("MENU_SELECTOR_RIGHT")
    if sel:
      sel.visible = True
    #Server pieno:
    waitMessage(globalVars, formVars, globalVars.get("messages").SERVERFULL, False, 5)
  elif response[0] == "OK":
    #Mi salvo il server:
    globalVars.get("userData").SERVER = formVars.get("formMenu").getElement("SERVER").value.split("|")[1]
    globalVars.get("userData").CONNECTION = formVars.get("formMenu").getElement("CONNECTION").value.split("|")[1]
    functions.saveOptions(globalVars.get("userData"))
    #Server Welcome:
    graph = graphicElement()
    graph.name = "GOTOWELCOME"
    anim = animation()
    anim.name = graph.name
    def code(globalVars, formVars, target):
      globalVars.set("mdlServerWelcome", "formName")
      globalVars.set("YES", "breakLoop")
    anim.code = code
    graph.animation = anim
    formGraphics.set(graph)
    #hideWaitMessage()


def button_down(pbuttons):
  return False