#    Triple Triad PSP
#    Copyright (C) 2006, 2007 Sakya
#    sakya_tg@yahoo.it
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
import psp2d
from core import functions, animation, graphicElement, dataStore, menu, menuElement, buttons, vKeyboard
from mdlMessages import message
from formsFunction import *

"""Form for writing a message"""
formGraphics = dataStore()
formVars = dataStore()
formVars.set(formGraphics, "formGraphics")
globalVars = None

def init(pGlobalVars, pParams):
  global formVars, globalVars, formGraphics

  formGraphics = dataStore()
  formVars = dataStore()
  formVars.set(formGraphics, "formGraphics")
  globalVars = pGlobalVars

  pToUser = pParams[0]
  pHeader = pParams[1]
  formVars.set(pParams[2], "callingForm")
  formVars.set(pParams[3], "callingFormParams")
  if pHeader == "NEW_MSG":
    formVars.set(True, "restoreStatus")
    pHeader = ""

  formVars.set(psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_bg_newmessage.png'), "bkgImage")
  formVars.set('themes/' + globalVars.get("userData").THEME + '/gm_bg_newmessage.png', "bkgImageName")
  formVars.set(0, "bkgImagePosX")
  formVars.set(0, "bkgImagePosY")

  formVars.set(message(), "myMessage")
  formVars.get("myMessage").to = pToUser

  #Titolo:
  graph = graphicElement()
  graph.name = "TITLE"
  graph.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_bg_title.png')
  graph.posX = -476
  graph.posY = 2
  anim = animation()
  anim.name = graph.name
  anim.data = [2, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)

  graph = graphicElement()
  graph.name = "TITLET"
  graph.font = globalVars.get("fonts").get("fontTitle")
  graph.posY = 4
  graph.text = globalVars.get("messages").GM_NEWMESSAGE_TITLE + " " + formVars.get("myMessage").to
  graph.posX = -functions.textWidth(graph.font, graph.text)
  anim = animation()
  anim.name = graph.name
  anim.data = [(480 - functions.textWidth(graph.font, graph.text)) / 2, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)

  #Header:
  graph = graphicElement()
  graph.name = "HEADER"
  graph.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_nmsgheader.png')
  graph.posX = 480
  graph.posY = 41
  anim = animation()
  anim.name = graph.name
  anim.data = [154, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)

  graph = graphicElement()
  graph.name = "HEADERT"
  graph.font = globalVars.get("fonts").get("fontMenuSel")
  graph.posY = 41 + globalVars.get("themeOptions").MENU_BORDERWIDTH
  graph.posX = 154 + globalVars.get("themeOptions").MENU_BORDERWIDTH
  if pHeader:
    graph.text = pHeader
    graph.posX = 480
    anim = animation()
    anim.name = graph.name
    anim.data = [154 + globalVars.get("themeOptions").MENU_BORDERWIDTH, graph.posY, 99]
    anim.code = functions.moveFromTo
    graph.animation = anim
  formGraphics.set(graph)

  #Body:
  graph = graphicElement()
  graph.name = "BODY"
  graph.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_nmsgbody.png')
  graph.posX = 480
  graph.posY = 63
  anim = animation()
  anim.name = graph.name
  anim.data = [154, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)

  graph = graphicElement()
  graph.name = "BODYT"
  graph.font = globalVars.get("fonts").get("fontMenu")
  graph.posY = 63 + globalVars.get("themeOptions").MENU_BORDERWIDTH
  graph.posX = 154 + globalVars.get("themeOptions").MENU_BORDERWIDTH
  graph.maxWidth = 324 - 2 * globalVars.get("themeOptions").MENU_BORDERWIDTH
  graph.multiLine = True
  formGraphics.set(graph)

  #Messaggi:
  formGraphics.set(createMessagesGE(globalVars, formVars))

  #Menu di edit del messaggio:
  editMenu = menu(formGraphics, pGlobalVars, formVars)
  editMenu.name = "EDIT_MENU"
  editMenu.background_image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_nmsgmenu.png')
  editMenu.menuHeight = 150
  editMenu.menuWidth = 150
  editMenu.posX = 2
  editMenu.posY = 41
  editMenu.selector = "RIGHT"
  editMenu.menuAlignment = "LEFT"
  def code(globalVars, formVars, menu, element):
    #Torno alla form precedente:
    globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingSound")
    globalVars.get("playingSound").start()
    if formVars.get("restoreStatus"):
      globalVars.get("net").changeStatus("N")
    globalVars.set(formVars.get("callingForm"), "formName")
    globalVars.set(formVars.get("callingFormParams"), "formParams")
    globalVars.set("YES", "breakLoop")
  editMenu.trigger_cancel = code
  formVars.set(editMenu, "editMenu")

  tElement = menuElement()
  tElement.value = "HEADER"
  tElement.text = globalVars.get("messages").GM_EDIT_HEADER
  tElement.helpText = globalVars.get("messages").GM_EDIT_HEADERH
  def code(globalVars, formVars, menu, element):
    #Edito l'intestazione:
    globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
    globalVars.get("playingSound").start()
    graph = menu.formGraphics.get("HEADERT")
    virtualKeyboard = vKeyboard(globalVars, formVars, formGraphics)
    virtualKeyboard.showTextBox = False
    virtualKeyboard.posX = 0
    virtualKeyboard.posY = formVars.get("editMenu").posY
    virtualKeyboard.text = menu.formGraphics.get("HEADERT").text
    virtualKeyboard.returnGraphicElement = graph
    virtualKeyboard.createGraphicElement("LEFT")
    formVars.set(virtualKeyboard, "formKeyboard")
    formVars.set(None, "formMenu")
    #Qundo la tastiera viene chiusa:
    graph = graphicElement()
    graph.name = "CHECK_VKEY"
    graph.font = globalVars.get("fonts").get("fontMessage3")
    graph.visible = False
    anim = animation()
    anim.lockKeyboard = False
    anim.name = graph.name
    def code(globalVars, formVars, target):
      if not formVars.get("formKeyboard"):
        formVars.set(formVars.get("editMenu"), "formMenu")
        target.name = "DEL_" + target.name
    anim.code = code
    graph.animation = anim
    menu.formGraphics.set(graph)

  tElement.trigger_select = code
  formVars.get("editMenu").elements.append(tElement)

  tElement = menuElement()
  tElement.value = "BODY"
  tElement.text = globalVars.get("messages").GM_EDIT_MESSAGE
  tElement.helpText = globalVars.get("messages").GM_EDIT_MESSAGEH
  def code(globalVars, formVars, menu, element):
    #Edito il corpo:
    globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
    globalVars.get("playingSound").start()
    graph = formGraphics.get("BODYT")
    virtualKeyboard = vKeyboard(globalVars, formVars, formGraphics)
    virtualKeyboard.showTextBox = False
    virtualKeyboard.posX = 0
    virtualKeyboard.posY = formVars.get("editMenu").posY
    virtualKeyboard.text = menu.formGraphics.get("BODYT").text
    virtualKeyboard.returnGraphicElement = graph
    virtualKeyboard.createGraphicElement("LEFT")
    formVars.set(virtualKeyboard, "formKeyboard")
    formVars.set(None, "formMenu")
    #Qundo la tastiera viene chiusa:
    graph = graphicElement()
    graph.name = "CHECK_VKEY"
    graph.font = globalVars.get("fonts").get("fontMessage")
    graph.visible = False
    anim = animation()
    anim.lockKeyboard = False
    anim.name = graph.name
    def code(globalVars, formVars, target):
      if not formVars.get("formKeyboard"):
        formVars.set(formVars.get("editMenu"), "formMenu")
        target.name = "DEL_" + target.name
    anim.code = code
    graph.animation = anim
    menu.formGraphics.set(graph)
  tElement.trigger_select = code
  formVars.get("editMenu").elements.append(tElement)

  tElement = menuElement()
  tElement.value = "SEND"
  tElement.text = globalVars.get("messages").GM_SEND_MESSAGE
  tElement.helpText = globalVars.get("messages").GM_SEND_MESSAGEH
  def code(globalVars, formVars, menu, element):
    #controllo il messaggio:
    if not menu.formGraphics.get("HEADERT").text:
      globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingSound")
      globalVars.get("playingSound").start()
      waitMessage(globalVars, formVars, menu.globalVars.get("messages").GM_NOHEADER, False, 5)
      menu.selected = "HEADER"
      menu.createGraphicElements()
    elif not menu.formGraphics.get("BODYT").text:
      globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingSound")
      globalVars.get("playingSound").start()
      waitMessage(globalVars, formVars, menu.globalVars.get("messages").GM_NOBODY, False, 5)
      menu.selected = "BODY"
      menu.createGraphicElements()
    else:
      #Invio il messaggio
      globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
      globalVars.get("playingSound").start()
      waitMessage(globalVars, formVars, menu.globalVars.get("messages").GM_SENDINGMESSAGE, True)
      formVars.get("myMessage").header = menu.formGraphics.get("HEADERT").text
      formVars.get("myMessage").text = menu.formGraphics.get("BODYT").text
      menu.getGraphicElement("MENU_SELECTOR_RIGHT").visible = False
      globalVars.get("net").sendMessage(formVars.get("myMessage").to, formVars.get("myMessage").header, formVars.get("myMessage").text, sendMessageCallback)
  tElement.trigger_select = code
  formVars.get("editMenu").elements.append(tElement)

  tElement = menuElement()
  tElement.value = "CANCEL"
  tElement.text = globalVars.get("messages").GM_CANCEL_MESSAGE
  tElement.helpText = globalVars.get("messages").GM_CANCEL_MESSAGEH
  tElement.trigger_select = editMenu.trigger_cancel
  editMenu.elements.append(tElement)

  editMenu.selected = "HEADER"
  editMenu.createGraphicElements("BOTTOM")
  formVars.set(editMenu, "formMenu")
  formVars.set("MENU", "status")


def sendMessageCallback(pResponse, pError):
  """Send a message"""
  if pError:
    menu.getGraphicElement("MENU_SELECTOR_RIGHT").visible = True
    waitMessage(globalVars, formVars, pError[1][1], False, 10)
    return

  hideWaitMessage(globalVars, formVars)
  response = functions.analyzeServerString(pResponse)
  if response[0] == "OK":
    #Torno alla lista messaggi:
    if formVars.get("restoreStatus"):
      globalVars.get("net").changeStatus("N")
    globalVars.set(formVars.get("callingForm"), "formName")
    globalVars.set(formVars.get("callingFormParams"), "formParams")
    globalVars.set("YES", "breakLoop")
  else:
    menu.getGraphicElement("MENU_SELECTOR_RIGHT").visible = True
    waitMessage(globalVars, formVars, globalVars.get("messages").GM_ERROR_SENDMESSAGE, False, 5)


def button_down(pbuttons):
  return False