#    Triple Triad PSP
#    Copyright (C) 2006, 2007 Sakya
#    sakya_tg@yahoo.it
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
import psp2d
from core import functions, animation, graphicElement, menu, menuElement, buttons
from formsFunction import *

"""Form options"""
formGraphics = dataStore()
formVars = dataStore()
formVars.set(formGraphics, "formGraphics")
globalVars = None

def init(pGlobalVars, pParams):
  global formVars, globalVars, formGraphics

  formGraphics = dataStore()
  formVars = dataStore()
  formVars.set(formGraphics, "formGraphics")
  globalVars = pGlobalVars

  formVars.set(globalVars.get("images").get("defaultBkgImage"), "bkgImage")
  formVars.set(0, "bkgImagePosX")
  formVars.set(0, "bkgImagePosY")

  #Mi salvo le opzioni:
  formVars.set([globalVars.get("userData").LANG, globalVars.get("userData").THEME, globalVars.get("userData").SHOW_FPS], "data")

  #Titolo:
  graph = graphicElement()
  graph.name = "TITLE"
  graph.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_generic_title.png')
  graph.posX = -440
  graph.posY = 8
  anim = animation()
  anim.name = "TITLE"
  anim.data = [20, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)

  graph = graphicElement()
  graph.name = "TITLET"
  graph.font = globalVars.get("fonts").get("fontTitle")
  graph.text = globalVars.get("messages").OPTIONS
  graph.posY = 10
  graph.posX = -functions.textWidth(graph.font, graph.text)
  anim = animation()
  anim.name = "TITLET"
  anim.data = [(480 - functions.textWidth(graph.font, graph.text)) / 2, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)

  optionMenu = menu(formGraphics, globalVars, formVars)
  optionMenu.name = "OPTIONMENU"
  optionMenu.posX = globalVars.get("themeOptions").MENU_X
  optionMenu.posY = globalVars.get("themeOptions").MENU_Y
  optionMenu.background_image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_generic_menu.png')
  optionMenu.menuWidth = globalVars.get("themeOptions").MENU_W
  optionMenu.menuHeight = globalVars.get("themeOptions").MENU_H
  optionMenu.menuAlignment = globalVars.get("themeOptions").MENU_ALIGN
  optionMenu.menuVAlignment = globalVars.get("themeOptions").MENU_VALIGN
  formVars.set(optionMenu, "optionMenu")
  createMenu()

  if pParams:
    optionMenu.selected = pParams[0]
  else:
    optionMenu.selected = optionMenu.elements[0].value
  optionMenu.createGraphicElements("BOTTOM")


def createMenu():
  """Creates menu"""
  optionMenu = formVars.get("optionMenu")
  optionMenu.elements = []
  optionMenu.firstVisible = None
  optionMenu.lastVisible = None

  tElement = menuElement()
  tElement.text = globalVars.get("messages").LANGUAGE
  tElement.helpText = globalVars.get("messages").LANGUAGEH
  tElement.value = "LANGUAGE"
  #Leggo le lingue disponibili:
  list = __import__("languages")
  list.LIST.sort()
  for ln in list.LIST:
    tSubElement = menuElement()
    tSubElement.text = ln.title()
    tSubElement.value = ln
    #Controllo se e' la lingua in uso:
    if tSubElement.text == globalVars.get("userData").LANG.title():
      tElement.value = "LANGUAGE|" + ln
    tElement.subMenu.append(tSubElement)
  def code(globalVars, formVars, menu, element):
    #Cambio la lingua:
    globalVars.get("userData").LANG = element.value.split("|")[1]
    globalVars.set(__import__("languages." + globalVars.get("userData").LANG, None, None, globalVars.get("userData").LANG), "messages")
    createMenu()
    formVars.get("formMenu").selected = element.value
    formVars.get("formMenu").createGraphicElements()
  tElement.trigger_changeSubMenu = code
  optionMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").THEME
  tElement.helpText = globalVars.get("messages").THEMEH
  tElement.value = "THEME"

  #Leggo i temi disponibili:
  list = __import__("themes")
  for th in list.LIST:
    #Controllo il tema in uso:
    if th == globalVars.get("userData").THEME:
      tElement.value = "THEME|" + th

    tSubElement = menuElement()
    #Leggo il file di definizione:
    themeOptions = __import__("themes." + th, None, None, th)
    tSubElement.value = th
    tSubElement.text = themeOptions.NAME
    tSubElement.helpText = themeOptions.DESC
    tElement.subMenu.append(tSubElement)

  optionMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").SHOW_FPS
  tElement.helpText = globalVars.get("messages").SHOW_FPSH
  tElement.value = "FPS|" + globalVars.get("userData").SHOW_FPS
  tSubElement = menuElement()
  tSubElement.text = globalVars.get("messages").NO
  tSubElement.value = "NO"
  tElement.subMenu.append(tSubElement)
  tSubElement = menuElement()
  tSubElement.text = globalVars.get("messages").YES
  tSubElement.value = "YES"
  def code(globalVars, formVars, menu, element):
    #Cambio l'opzione:
    globalVars.get("userData").SHOW_FPS = element.value.split("|")[1]
    if globalVars.get("userData").SHOW_FPS == "NO":
      globalVars.get("commonGraphics").get("CE_FORM_FPS").visible = False
    else:
      globalVars.get("commonGraphics").get("CE_FORM_FPS").visible = True
  tElement.trigger_changeSubMenu = code
  tElement.subMenu.append(tSubElement)
  optionMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").THEMEOPTIONS
  tElement.helpText = globalVars.get("messages").THEMEOPTIONSH
  def code(globalVars, formVars, menu, element):
    #Passo al menu opzioni del tema:
    globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
    globalVars.get("playingSound").start()
    globalVars.set("mdlThemeOptions", "formName")
    globalVars.set("YES", "breakLoop")
  tElement.trigger_select = code

  tElement.value = "THEMEOPTIONS"
  optionMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").SAVEOPTION
  tElement.helpText = globalVars.get("messages").SAVEOPTIONH
  tElement.value = "SAVEOPTIONS"
  def code(globalVars, formVars, menu, element):
    #Ricarico le variabili:
    globalVars.get("userData").LANG = menu.getElement("LANGUAGE").value.split("|")[1]
    globalVars.get("userData").THEME = menu.getElement("THEME").value.split("|")[1]
    globalVars.get("userData").SHOW_FPS = menu.getElement("FPS").value.split("|")[1]
    globalVars.set(__import__("languages." + globalVars.get("userData").LANG, None, None, globalVars.get("userData").LANG), "messages")
    functions.saveOptions(globalVars.get("userData"))
    #Ricarico i cardsets:
    for set in globalVars.get("cardSets"):
      set.load(set.path[9:-1])

    globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
    globalVars.get("playingSound").start()
    globalVars.set("mdlMainMenu", "formName")
    globalVars.set(["OPTIONS"], "formParams")
    globalVars.set("YES", "breakLoop")
  tElement.trigger_select = code

  optionMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").MAIN
  tElement.helpText = globalVars.get("messages").MAINH
  tElement.value = "MAIN"
  def code(globalVars, formVars, menu, element):
    globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
    globalVars.get("playingSound").start()
    #Ricarico le opzioni:
    globalVars.get("userData").LANG = formVars.get("data")[0]
    globalVars.get("userData").THEME = formVars.get("data")[1]
    globalVars.get("userData").SHOW_FPS = formVars.get("data")[2]
    themeOptions = __import__("themes." + globalVars.get("userData").THEME, None, None, globalVars.get("userData").THEME)
    globalVars.set(__import__("languages." + globalVars.get("userData").LANG, None, None, globalVars.get("userData").LANG), "messages")

    #Torno al main menu:
    globalVars.set("mdlMainMenu", "formName")
    globalVars.set(["OPTIONS"], "formParams")
    globalVars.set("YES", "breakLoop")
  tElement.trigger_select = code
  optionMenu.elements.append(tElement)

  def code(globalVars, formVars, menu, element):
    globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingSound")
    globalVars.get("playingSound").start()

    #Ricarico le opzioni:
    globalVars.get("userData").LANG = formVars.get("data")[0]
    globalVars.get("userData").THEME = formVars.get("data")[1]
    globalVars.get("userData").SHOW_FPS = formVars.get("data")[2]
    themeOptions = __import__("themes." + globalVars.get("userData").THEME, None, None, globalVars.get("userData").THEME)
    globalVars.set(__import__("languages." + globalVars.get("userData").LANG, None, None, globalVars.get("userData").LANG), "messages")

    #Torno al main menu:
    globalVars.set("mdlMainMenu", "formName")
    globalVars.set(["OPTIONS"], "formParams")
    globalVars.set("YES", "breakLoop")
  optionMenu.trigger_cancel = code
  formVars.set(optionMenu, "formMenu")

def button_down(pbuttons):
  return False
