#    Triple Triad PSP
#    Copyright (C) 2006, 2007 Sakya
#    sakya_tg@yahoo.it
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
import psp2d
from core import graphicElement, dataStore, animation, functions, menu, menuElement, buttons
from formsFunction import *

class news(object):
  def __init__(self, pDate=None, pTitle=None, pText=None):
    self.date = pDate
    self.title = pTitle
    self.text = pText


"""Form Server News"""
bkgImage = None
bkgImagePosX = 0
bkgImagePosY = 0
formGraphics = dataStore()
formVars = dataStore()
formVars.set(formGraphics, "formGraphics")
globalVars = None

def init(pGlobalVars, pParams):
  global formVars, globalVars, formGraphics

  bkgImage = None
  bkgImagePosX = 0
  bkgImagePosY = 0
  formGraphics = dataStore()
  formVars = dataStore()
  formVars.set(formGraphics, "formGraphics")
  globalVars = pGlobalVars
  formVars.set(psp2d.Image('themes/' + pGlobalVars.get("userData").THEME + '/gm_bg_servernews.png'), "bkgImage")
  formVars.set(0, "bkgImagePosX")
  formVars.set(0, "bkgImagePosY")

  formVars.set(0, "newsNumber")
  formVars.set([], "news")

  formVars.set(psp2d.Image('themes/' + pGlobalVars.get("userData").THEME + '/next.png'), "nextImage")
  formVars.set(psp2d.Image('themes/' + pGlobalVars.get("userData").THEME + '/previous.png'), "prevImage")

  #Messaggi:
  formGraphics.set(createMessagesGE(globalVars, formVars))

  #Chiedo le news al server:
  waitMessage(globalVars, formVars, globalVars.get("messages").GM_WAIT)
  globalVars.get("net").serverNews(serverNewsCallback)


def serverNewsCallback(pResponse, pError):
  """Server news callback"""
  if pError:
    waitMessage(globalVars, formVars, pError[1][1], False, 10)
    return

  response = functions.analyzeServerString(pResponse)
  allNews = formVars.get("news")
  if len(response) > 0:
    for tNews in response:
      cn = tNews.split("||")
      if len(cn) >= 3:
        n = news(cn[0], cn[1], cn[2])
        allNews.append(n)
  hideWaitMessage(globalVars, formVars)
  formVars.set(0, "newsNumber")
  createNews(0)


def createNews(pNewsNumber, pDirection="R"):
  #Titolo:
  graph = formGraphics.get("TITLE")
  if not graph:
    graph = graphicElement()
    graph.name = "TITLE"
    graph.bufferImage = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_help_bar.png')
    graph.posX = -440
    graph.posY = 5
    anim = animation()
    anim.name = "TITLE"
    anim.priority = 20
    anim.data = [20, graph.posY, 99]
    anim.code = functions.moveFromTo
    graph.animation = anim
    formGraphics.set(graph)
  graph.image = psp2d.Image(graph.bufferImage)

  if pNewsNumber > len(formVars.get("news")) - 1:
    return

  news = formVars.get("news")[pNewsNumber]
  tHeight = functions.textHeight(globalVars.get("fonts").get("fontMenuSel"), "I")
  globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, 5, 10, news.title)
  date = functions.formatDateTime(news.date)
  tWidth = functions.textWidth(globalVars.get("fonts").get("fontMenuSel"), date)
  globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, graph.image.width - tWidth - 2, 10, date)

  #Next and previous:
  graph = formGraphics.get("NEXT")
  if not graph:
    graph = graphicElement()
    graph.name = "NEXT"
    graph.image = formVars.get("nextImage")
    graph.posX = 445
    graph.posY = 40 + 170 / 2 - graph.image.height / 2
    formGraphics.set(graph)
  if pNewsNumber == len(formVars.get("news")) - 1:
    graph.visible = False
  else:
    graph.visible = True

  graph = formVars.get("PREVIOUS")
  if not graph:
    graph = graphicElement()
    graph.name = "PREVIOUS"
    graph.image = formVars.get("prevImage")
    graph.posX = 40 - graph.image.width - 5
    graph.posY = 40 + 170 / 2 - graph.image.height / 2
    formGraphics.set(graph)
  if pNewsNumber == 0:
    graph.visible = False
  else:
    graph.visible = True

  graph = formGraphics.get("HELP_BUTTONS")
  if not graph:
    graph = graphicElement()
    graph.name = "HELP_BUTTONS"
    graph.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_help_bar.png')

    graph.image.blit(globalVars.get("images").get("buttonLeft"), 0, 0, globalVars.get("images").get("buttonLeft").width, globalVars.get("images").get("buttonLeft").height, 30, 10, True)
    graph.image.blit(globalVars.get("images").get("buttonRight"), 0, 0, globalVars.get("images").get("buttonRight").width, globalVars.get("images").get("buttonRight").height, 50, 10, True)
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, 70, 10, globalVars.get("messages").HELP_CHANGEPAGE)

    graph.image.blit(globalVars.get("images").get("buttonCircle"), 0, 0, globalVars.get("images").get("buttonCircle").width, globalVars.get("images").get("buttonCircle").height, 400, 10, True)
    tWidth = functions.textWidth(globalVars.get("fonts").get("fontMenu"), globalVars.get("messages").HELP_EXIT)
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, 400 - 10 - tWidth, 10, globalVars.get("messages").HELP_EXIT)

    graph.posX = 480
    graph.posY = 215
    anim = animation()
    anim.name = "HELP_BUTTONS"
    anim.exclusive = True
    anim.priority = 10
    anim.data = [20, graph.posY, 99]
    anim.code = functions.moveFromTo
    graph.animation = anim
    formGraphics.set(graph)

  #News:
  graph = formGraphics.get("NEWS")
  if not graph:
    graph = graphicElement()
    graph.name = "NEWS"
    graph.priority = 100
    graph.bufferImage = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_help.png')
    graph.posX = 40
    graph.posY = 275
    anim = animation()
    anim.name = "NEWS"
    anim.data = [graph.posX, 40, 99]
    anim.code = functions.moveFromTo
    graph.animation = anim
    formGraphics.set(graph)
  else:
    #Animazione di cambio pagina:
    exit = formGraphics.get("NEWS_EXIT")
    if not exit:
      exit = graphicElement()
      exit.name = "NEWS_EXIT"
      exit.priority = 100
    exit.image = psp2d.Image(graph.image)
    exit.posX = graph.posX
    exit.posY = graph.posY
    anim = animation()
    anim.name = "NEWS_EXIT"
    anim.priority = 110
    if pDirection == "R":
      anim.data = [-exit.image.width, exit.posY, 99]
    else:
      anim.data = [480, exit.posY, 99]
    anim.code = functions.moveFromTo
    exit.animation = anim
    formGraphics.set(exit)

    graph = formGraphics.get("NEWS")
    anim = animation()
    anim.name = "NEWS"
    anim.priority = 100
    anim.exclusive = True
    if pDirection == "R":
      graph.posX = 480
    else:
      graph.posX = -graph.image.width
    anim.data = [40, graph.posY, 99]
    anim.code = functions.moveFromTo
    graph.animation = anim
  graph.image = psp2d.Image(graph.bufferImage)

  #Testo della news:
  posY = 7
  for i, riga in enumerate(news.text.split("//n//")):
    posX = 10
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + i * tHeight, riga)


def button_down(pbuttons):
  #Esco:
  if buttons.circle in pbuttons:
    globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingSound")
    globalVars.get("playingSound").start()
    globalVars.get("net").changeStatus("N")
    globalVars.set(["RESTORE"], "formParams")
    globalVars.set("mdlGame", "formName")
    globalVars.set("YES", "breakLoop")

    return True
  #Cambio pagina:
  if formVars.get("newsNumber") < len(formVars.get("news")) - 1 and buttons.right in pbuttons:
    #Avanti di una pagina:
    globalVars.set(globalVars.get("sounds").get("menuChangeSound"), "playingSound")
    globalVars.get("playingSound").start()
    formVars.set(formVars.get("newsNumber") + 1, "newsNumber")
    createNews(formVars.get("newsNumber"), "R")
  elif formVars.get("newsNumber") > 0 and buttons.left in pbuttons:
    #Indietro di una pagina:
    globalVars.set(globalVars.get("sounds").get("menuChangeSound"), "playingSound")
    globalVars.get("playingSound").start()
    formVars.set(formVars.get("newsNumber") - 1, "newsNumber")
    createNews(formVars.get("newsNumber"), "L")
  return True