#    Triple Triad PSP
#    Copyright (C) 2006, 2007 Sakya
#    sakya_tg@yahoo.it
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
import psp2d, pspsnd, pspnet
from core import graphicElement, dataStore, animation, functions, menu, menuElement, buttons, deck, cardSet
from formsFunction import *

formGraphics = dataStore()
formVars = dataStore()
formVars.set(formGraphics, "formGraphics")
globalVars = None

"""Form Server Welcome"""
def init(pGlobalVars, pParams):
  global formVars, globalVars, formGraphics

  formGraphics = dataStore()
  formVars = dataStore()
  formVars.set(formGraphics, "formGraphics")
  globalVars = pGlobalVars

  formVars.set(globalVars.get("images").get("defaultBkgImage"), "bkgImage")
  formVars.set(0, "bkgImagePosX")
  formVars.set(0, "bkgImagePosY")

  #Titolo:
  graph = graphicElement()
  graph.name = "TITLE"
  graph.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_bg_title.png')
  graph.posX = -476
  graph.posY = 2
  anim = animation()
  anim.name = graph.name
  anim.data = [2, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)

  graph = graphicElement()
  graph.name = "TITLET"
  graph.font = globalVars.get("fonts").get("fontTitle")
  graph.posY = 4
  graph.text = globalVars.get("messages").GM_WELCOME
  graph.posX = -functions.textWidth(graph.font, graph.text)
  anim = animation()
  anim.name = graph.name
  anim.data = [(480 - functions.textWidth(graph.font, graph.text)) / 2, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)

  #Welcome message:
  graph = graphicElement()
  graph.name = "WMESSAGE"
  graph.priority = 5
  graph.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_welcome.png')
  graph.posX = 20
  graph.posY = 272
  graph.font = globalVars.get("fonts").get("fontMessage")
  anim = animation()
  anim.name = graph.name
  anim.data = [graph.posX, 55, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)

  #Testo del messaggio:
  posY = 10
  for i, riga in enumerate(globalVars.get("net").serverStatus[1].split('//n//')):
    graph.font.drawText(graph.image, 10, posY + posY * i + 2 * i, riga)


def button_down(tButtons):
  #Controllo lo stato del server:
  if globalVars.get("net").serverStatus[0] == "OK":
    #Passo al login:
    globalVars.set("mdlLogin", "formName")
    globalVars.set("YES", "breakLoop")
    return True
  else:
    #Torno alla connessione:
    globalVars.set("mdlNetOptions", "formName")
    globalVars.set("YES", "breakLoop")
    return True
