#    Triple Triad PSP
#    Copyright (C) 2006, 2007 Sakya
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
import psp2d
from core import functions, animation, graphicElement, dataStore, menu, menuElement, buttons
from formsFunction import *

"""Form for the shop"""
formGraphics = dataStore()
formVars = dataStore()
formVars.set(formGraphics, "formGraphics")
globalVars = None

def init(pGlobalVars, pParams):
  global formVars, globalVars, formGraphics

  formGraphics = dataStore()
  formVars = dataStore()
  formVars.set(formGraphics, "formGraphics")
  globalVars = pGlobalVars

  formVars.set(psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_bg_shop.png'), "bkgImage")
  formVars.set(globalVars.get("userData").THEME + '/gm_bg_shop.png', "bkgImageName")
  formVars.set(0, "bkgImagePosX")
  formVars.set(0, "bkgImagePosY")

  formVars.set(1, "levelShown")
  formVars.set("PRICE", "order")
  formVars.set(False, "menuCreated ")

  splitCards()

  #Carico icone degli elementi:
  formVars.set(globalVars.get("elements"), "elements")

  #Titolo:
  graph = graphicElement()
  graph.name = "TITLE"
  graph.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_bg_title.png')
  graph.data = psp2d.Image(graph.image)
  graph.posX = -476
  graph.posY = 2
  anim = animation()
  anim.name = graph.name
  anim.data = [2, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)

  graph = graphicElement()
  graph.name = "TITLET"
  graph.font = globalVars.get("fonts").get("fontTitle")
  graph.posY = 4
  graph.text = globalVars.get("messages").GM_SHOP_TITLE
  graph.posX = -functions.textWidth(graph.font, graph.text)
  anim = animation()
  anim.name = graph.name
  anim.data = [(480 - functions.textWidth(graph.font, graph.text)) / 2, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)

  #Messaggi:
  formGraphics.set(createMessagesGE(globalVars, formVars))

  #Info carta
  graph = graphicElement()
  graph.name = "CARDINFO"
  graph.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_shop_cinfo.png')
  graph.imageBuffer = psp2d.Image(graph.image)
  graph.posX = 480
  graph.posY = 41
  anim = animation()
  anim.name = graph.name
  anim.data = [154, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)

  #Info aggiuntive
  graph = graphicElement()
  graph.name = "OTHERINFO"
  graph.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_shop_oinfo.png')
  graph.imageBuffer = psp2d.Image(graph.image)
  graph.posX = 480
  graph.posY = 193
  anim = animation()
  anim.name = graph.name
  anim.data = [154, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)

  formVars.set(psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_shop_menu.png'), "menuBG")
  #Menu principale:
  mainMenu = createMainMenu()
  mainMenu.createGraphicElements("BOTTOM")

  formVars.set(mainMenu, "formMenu")
  updateGeneralInfo()
  formVars.set("MAIN", "status")

  #Buy menu:
  buyMenu = menu(formGraphics, pGlobalVars, formVars)
  buyMenu.name = "BUY_MENU"
  buyMenu.imageBuffer = formVars.get("menuBG")
  buyMenu.menuHeight = 200
  buyMenu.menuWidth = 150
  buyMenu.posX = 2
  buyMenu.posY = 41
  buyMenu.selector = "RIGHT"
  buyMenu.menuAlignment = "LEFT"
  def code(globalVars, formVars, menu, element):
    #Torno al menu principale:
    globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingSound")
    globalVars.get("playingSound").start()
    menu.delGraphics()
    formVars.set(1, "levelShown")
    showMainMenu()
  buyMenu.trigger_cancel = code
  formVars.set(buyMenu, "buyMenu")

  #Sell menu:
  sellMenu = menu(formGraphics, pGlobalVars, formVars)
  sellMenu.name = "SELL_MENU"
  sellMenu.imageBuffer = formVars.get("menuBG")
  sellMenu.menuHeight = 200
  sellMenu.menuWidth = 150
  sellMenu.posX = 2
  sellMenu.posY = 41
  sellMenu.selector = "RIGHT"
  sellMenu.menuAlignment = "LEFT"
  def code(globalVars, formVars, menu, element):
    #Torno al menu principale:
    globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingSound")
    globalVars.get("playingSound").start()
    menu.delGraphics()
    formVars.set(1, "levelShown")
    showMainMenu()
  sellMenu.trigger_cancel = code
  formVars.set(sellMenu, "sellMenu")


def createMainMenu():
  """Create main menu"""
  mainMenu = menu(formGraphics, globalVars, formVars)
  mainMenu.name = "MAIN_MENU"
  mainMenu.background_image = formVars.get("menuBG")
  mainMenu.menuHeight = 200
  mainMenu.menuWidth = 150
  mainMenu.posX = 2
  mainMenu.posY = 41
  mainMenu.selector = "RIGHT"
  mainMenu.menuAlignment = "LEFT"
  formVars.set(mainMenu, "mainMenu")

  def code(globalVars, formVars, menu, element):
    #Torno al gioco:
    globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingSound")
    globalVars.get("playingSound").start()
    globalVars.get("net").changeStatus("N")
    globalVars.set(["RESTORE"], "formParams")
    globalVars.set("mdlGame", "formName")
    globalVars.set("YES", "breakLoop")
  mainMenu.trigger_cancel = code

  tElement = menuElement()
  tElement.text = globalVars.get("messages").GM_BUY
  tElement.helpText = globalVars.get("messages").GM_BUYH
  tElement.icon = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_buy.png')
  tElement.value = "BUY"
  def code(globalVars, formVars, menu, element):
    """Buy cards"""
    globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
    globalVars.get("playingSound").start()
    formVars.set(False, "menuCreated")
    showBuyMenu()
  tElement.trigger_select = code
  mainMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").GM_SELL
  tElement.helpText = globalVars.get("messages").GM_SELLH
  tElement.icon = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_sell.png')
  tElement.value = "SELL"
  if len(globalVars.get("playerCards")) == 0:
    tElement.enabled = False
  def code(globalVars, formVars, menu, element):
    """Sell cards"""
    globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
    globalVars.get("playingSound").start()
    formVars.set(False, "menuCreated")
    showSellMenu()
  tElement.trigger_select = code
  mainMenu.elements.append(tElement)

  deckCard = 0
  for card in globalVars.get("player").deck:
    if card:
      deckCard += 1
  if deckCard + len(globalVars.get("playerCards")) < 5 \
  and globalVars.get("player").guil < 500:
    tElement = menuElement()
    tElement.text = globalVars.get("messages").GM_RESETDECK
    tElement.helpText = globalVars.get("messages").GM_RESETDECKH
    tElement.icon = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_sell.png')
    tElement.value = "RESET"
    def code(globalVars, formVars, menu, element):
      """Reset deck and money"""
      globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
      globalVars.get("playingSound").start()
      formVars.set(False, "menuCreated")
      resetDeck()
    tElement.trigger_select = code
    mainMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").GM_LEAVESHOP
  tElement.helpText = globalVars.get("messages").GM_LEAVESHOPH
  tElement.icon = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_logout.png')
  tElement.value = "LEAVE"
  def code(globalVars, formVars, menu, element):
    """Leave the shop"""
    globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingSound")
    globalVars.get("playingSound").start()
    globalVars.set(["RESTORE"], "formParams")
    globalVars.set("mdlGame", "formName")
    globalVars.set("YES", "breakLoop")
  tElement.trigger_select = code
  mainMenu.elements.append(tElement)

  mainMenu.selected = "BUY"
  return mainMenu


def showBuyMenu():
  """Show buy menu"""
  formVars.set("BUY", "status")
  buyMenu = formVars.get("buyMenu")

  #Controllo ordinamento:
  if formVars.get("order") == "PRICE":
    tCards = [[card.buyPrice, card.name, card] for card in formVars.get("cardsByLevel")[formVars.get("levelShown")]]
  elif formVars.get("order") == "CARDSET":
    tCards = [[card.cardSetName, card.name, card] for card in formVars.get("cardsByLevel")[formVars.get("levelShown")]]
  elif formVars.get("order") == "NAME":
    tCards = [[card.name, card.name, card] for card in formVars.get("cardsByLevel")[formVars.get("levelShown")]]
  tCards.sort()

  #Controllo se e' cambiato l'ordinamento:
  if formVars.get("order") != buyMenu.data:
    buyMenu.firstVisible = None
    buyMenu.lastVisible = None
    buyMenu.selected = None

  graph = formGraphics.get("TITLE")
  graph.image.blit(globalVars.get("images").get("levelDown"), 0, 0, globalVars.get("images").get("levelDown").width, globalVars.get("images").get("levelDown").height, 0, 0, True)
  graph.image.blit(globalVars.get("images").get("levelUp"), 0, 0, globalVars.get("images").get("levelUp").width, globalVars.get("images").get("levelUp").height, graph.image.width - globalVars.get("images").get("levelUp").width, 0, True)

  updateTitle()
  sel = buyMenu.selected
  firstV = None
  if buyMenu.firstVisible:
    firstV = buyMenu.firstVisible.value
  lastV = None
  if buyMenu.lastVisible:
    lastV = buyMenu.lastVisible.value

  #Creo gli elementi:
  buyMenu.delGraphics()
  buyMenu.clear()
  buyMenu.name = "BUY_MENU_" + str(formVars.get("levelShown"))
  buyMenu.background_image = psp2d.Image(buyMenu.imageBuffer)
  buyMenu.menuHeight = 200
  buyMenu.menuWidth = 150
  buyMenu.posX = 2
  buyMenu.posY = 41
  buyMenu.selector = "RIGHT"
  buyMenu.menuAlignment = "LEFT"
  buyMenu.data = formVars.get("order")
  for card in tCards:
    card = card[2]
    if card.buyPrice > 0:
      tElement = menuElement()
      tElement.text = card.name
      tElement.value = str(card.ID)
      tElement.data = card
      #controllo se il giocatore la ha gia':
      tCount = 0
      if card.ID in globalVars.get("playerCardsIndex"):
        tCount += 1
      for tCard in globalVars.get("player").deck:
        if tCard and tCard.ID == card.ID:
          tCount += 1
          break

      if tCount > 0:
        tElement.font = globalVars.get("fonts").get("fontMenu")
      else:
        tElement.font = globalVars.get("fonts").get("fontMenuSel")

      #Controllo se la posso comprare:
      if card.buyPrice > globalVars.get("player").guil:
        tElement.font = globalVars.get("fonts").get("fontMenuDisabled")
        tElement.canBuy = False
      else:
        tElement.canBuy = True
      def code(globalVars, formVars, menu, element):
        #Aggiorno le info della carta:
        updateCardInfo()
      tElement.trigger_enter = code

      def code(globalVars, formVars, menu, element):
        """Buy a card"""
        if element.canBuy == True:
          globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
          globalVars.get("playingSound").start()
          buyCard()
        else:
          globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingSound")
          globalVars.get("playingSound").start()
          waitMessage(globalVars, formVars, menu.globalVars.get("messages").GM_CANTBUY, False, 5)
      tElement.trigger_select = code
      buyMenu.elements.append(tElement)
      if tElement.value == sel:
        buyMenu.selected = sel
      if firstV and tElement.value == firstV:
        buyMenu.firstVisible = tElement
      if lastV and tElement.value == lastV:
        buyMenu.lastVisible = tElement

  if not buyMenu.selected and len(buyMenu.elements) > 0:
    if buyMenu.firstVisible:
      buyMenu.selected = buyMenu.firstVisible.value
    else:
      buyMenu.selectFirstElement()

  if not formVars.get("menuCreated"):
    buyMenu.createGraphicElements("BOTTOM")
    formVars.set(True, "menuCreated")
  else:
    buyMenu.createGraphicElements()

  if formVars.get("formMenu") != buyMenu:
    formVars.get("formMenu").delGraphics()
  formVars.set(buyMenu, "formMenu")
  updateCardInfo()


def showSellMenu():
  """Show buy menu"""
  formVars.set("SELL", "status")
  sellMenu = formVars.get("sellMenu")

  #Controllo ordinamento:
  if formVars.get("order") == "PRICE":
    tCards = [[card.sellPrice, card.name, card] for card in formVars.get("playerCardsByLevel")[formVars.get("levelShown")]]
  elif formVars.get("order") == "CARDSET":
    tCards = [[card.cardSetName, card.name, card] for card in formVars.get("playerCardsByLevel")[formVars.get("levelShown")]]
  elif formVars.get("order") == "NAME":
    tCards = [[card.name, card.name, card] for card in formVars.get("playerCardsByLevel")[formVars.get("levelShown")]]
  tCards.sort()

  #Controllo se e' cambiato l'ordinamento:
  if formVars.get("order") != sellMenu.data:
    sellMenu.firstVisible = None
    sellMenu.lastVisible = None
    sellMenu.selected = None

  updateTitle()
  sel = formVars.get("sellMenu").selected

  graph = formGraphics.get("TITLE")
  graph.image.blit(globalVars.get("images").get("levelDown"), 0, 0, globalVars.get("images").get("levelDown").width, globalVars.get("images").get("levelDown").height, 0, 0, True)
  graph.image.blit(globalVars.get("images").get("levelUp"), 0, 0, globalVars.get("images").get("levelUp").width, globalVars.get("images").get("levelUp").height, graph.image.width - globalVars.get("images").get("levelUp").width, 0, True)

  #Creo gli elementi:
  sellMenu.delGraphics()
  sellMenu.clear()
  sellMenu.name = "SELL_MENU_" + str(formVars.get("levelShown"))
  sellMenu.data = formVars.get("order")
  sellMenu.background_image = psp2d.Image(sellMenu.imageBuffer)
  sellMenu.menuHeight = 200
  sellMenu.menuWidth = 150
  sellMenu.posX = 2
  sellMenu.posY = 41
  sellMenu.selector = "RIGHT"
  sellMenu.menuAlignment = "LEFT"
  for card in tCards:
    card = card[2]
    tElement = menuElement()
    tElement.text = card.name
    tElement.value = str(card.ID)
    tElement.data = card
    def code(globalVars, formVars, menu, element):
      #Aggiorno le info della carta:
      updateCardInfo()
    tElement.trigger_enter = code

    def code(globalVars, formVars, menu, element):
      """Sell a card"""
      globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
      globalVars.get("playingSound").start()
      sellCard()
    tElement.trigger_select = code
    sellMenu.elements.append(tElement)
  sel = sellMenu.getElement(sel)
  if sel:
    sellMenu.selected = sel.value
  elif len(sellMenu.elements) > 0:
    sellMenu.selected = sellMenu.elements[0].value

  if not formVars.get("menuCreated"):
    sellMenu.createGraphicElements("BOTTOM")
    formVars.set(True, "menuCreated")
  else:
    sellMenu.createGraphicElements()
  if formVars.get("formMenu") != sellMenu:
    formVars.get("formMenu").delGraphics()
  formVars.set(sellMenu, "formMenu")
  updateCardInfo()


def updateCardInfo():
  """Update card info"""
  graph = formGraphics.get("CARDINFO")
  graph.image = None
  graph.image = psp2d.Image(graph.imageBuffer)
  sel = formVars.get("formMenu").getSelected()
  if sel:
    card = sel.data

    posX = 80
    posY = 5
    tHeight = functions.textHeight(globalVars.get("fonts").get("fontMenu"), "I")
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 0 * tHeight, globalVars.get("messages").GM_CARDSET)
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 1 * tHeight, globalVars.get("messages").LEVEL)
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 2 * tHeight, globalVars.get("messages").TOP)
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 3 * tHeight, globalVars.get("messages").RIGHT)
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 4 * tHeight, globalVars.get("messages").BOTTOM)
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 5 * tHeight, globalVars.get("messages").LEFT)
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 6 * tHeight, globalVars.get("messages").ELEMENTAL)
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 7 * tHeight, globalVars.get("messages").GM_PRICE)
    tCount = 0
    for tCard in formVars.get("cardsByLevel")[formVars.get("levelShown")]:
      if tCard.ID == card.ID:
        tCount += 1
    for tCard in globalVars.get("player").deck:
      if tCard and tCard.ID == card.ID:
        tCount += 1

    if card.ID in globalVars.get("playerCardsIndex"):
      pCard = globalVars.get("playerCards")[globalVars.get("playerCardsIndex").index(card.ID)]
      globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 8 * tHeight, globalVars.get("messages").GM_YOUHAVE + " " + str(pCard.count) + " " + globalVars.get("messages").GM_THISCARD)
    else:
      globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 8 * tHeight, globalVars.get("messages").GM_YOUDONTHAVE)

    zero = functions.textWidth(globalVars.get("fonts").get("fontMenu"), "0")
    posX = 245
    posY = 5
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX - functions.textWidth(globalVars.get("fonts").get("fontMenu"), card.cardSetName) - (zero - functions.textWidth(globalVars.get("fonts").get("fontMenu"), card.cardSetName)) / 2, posY + 0 * tHeight, card.cardSetName)
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(card.level)) - (zero - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(card.level))) / 2, posY + 1 * tHeight, str(card.level))
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(card.top)) - (zero - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(card.top))) / 2, posY + 2 * tHeight, str(card.top))
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(card.right)) - (zero - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(card.right))) / 2, posY + 3 * tHeight, str(card.right))
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(card.bottom)) - (zero - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(card.bottom))) / 2, posY + 4 * tHeight, str(card.bottom))
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(card.left)) - (zero - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(card.left))) / 2, posY + 5 * tHeight, str(card.left))
    if card.elementalString:
      globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(card.elementalString)), posY + 6 * tHeight, str(card.elementalString))
    else:
      globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX - functions.textWidth(globalVars.get("fonts").get("fontMenu"), "-") - (zero - functions.textWidth(globalVars.get("fonts").get("fontMenu"), "-")) / 2, posY + 6 * tHeight, "-")
    if formVars.get("status") == "BUY":
      globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(card.buyPrice)) - (zero - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(card.buyPrice))) / 2, posY + 7 * tHeight, str(card.buyPrice))
    else:
      globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(card.buyPrice)) - (zero - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(card.sellPrice))) / 2, posY + 7 * tHeight, str(card.sellPrice))
    #Immagine carta:
    cardImage = card.writeValues(psp2d.Image(card.imageP1))
    graph.image.blit(cardImage, 0, 0, cardImage.width, cardImage.height, 5, 5)


def updateTitle():
  """Update form title"""
  graph = formGraphics.get("TITLET")
  graph.image = None
  if formVars.get("status") == "BUY":
    graph.text = globalVars.get("messages").GM_SHOPBUY_TITLE + " " + globalVars.get("messages").LEVEL + " " + str(formVars.get("levelShown"))
  else:
    graph.text = globalVars.get("messages").GM_SHOPSELL_TITLE + " " + globalVars.get("messages").LEVEL + " " + str(formVars.get("levelShown"))
  graph.posX = (480 - functions.textWidth(graph.font, graph.text)) / 2
  updateOtherInfo()


def buyCard():
  """Buy a card"""
  #Chiedo conferma:
  formVars.set("CONFIRM_BUY", "status")
  graph = graphicElement()
  graph.name = "CONFIRM"
  graph.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_confirmshoptitle.png')
  text = globalVars.get("messages").GM_CONFIRMBUY
  globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, (graph.image.width - functions.textWidth(globalVars.get("fonts").get("fontMenuSel"), text)) / 2, 2, text)
  graph.posX = formVars.get("formMenu").posX
  graph.posY = formVars.get("formMenu").posY
  formGraphics.set(graph)

  formVars.get("formMenu").delGraphics()
  tMenu = confirm(globalVars, formVars, formGraphics, formVars.get("formMenu").menuWidth, formVars.get("formMenu").menuHeight - graph.image.height - 1, formVars.get("formMenu").posX, formVars.get("formMenu").posY + graph.image.height + 1)
  tMenu.background_image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_confirmshop.png')
  def code(globalVars, formVars, menu, element):
    #Buy a card
    waitMessage(globalVars, formVars, globalVars.get("messages").GM_WAIT)
    formVars.get("formMenu").getGraphicElement("MENU_SELECTOR_LEFT").visible = False
    globalVars.get("net").buyCard(formVars.get("buyMenu").getSelected().data.ID, buyCardCallback)
  tMenu.elements[0].trigger_select = code

  def code(globalVars, formVars, menu, element):
    #Torno al menu:
    globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingSound")
    globalVars.get("playingSound").start()
    delGraphic(formGraphics, "CONFIRM")
    showBuyMenu()
  tMenu.trigger_cancel = code
  tMenu.elements[1].trigger_select = tMenu.trigger_cancel
  formVars.set(tMenu, "formMenu")
  tMenu.createGraphicElements()


def buyCardCallback(pResponse, pError):
  """Buy a card"""
  if pError:
    waitMessage(globalVars, formVars, pError[1][1], False, 10)
    return

  response = functions.analyzeServerString(pResponse)
  if len(response) > 0:
    if response[0] == "OK":
      #Aggiungo la carta:
      card = formVars.get("buyMenu").getSelected().data.copy()
      if card.ID in globalVars.get("playerCardsIndex"):
        tCard = globalVars.get("playerCards")[globalVars.get("playerCardsIndex").index(card.ID)]
        tCard.count += 1
      else:
        card.count = 1
        globalVars.get("playerCards").append(card)
        globalVars.get("playerCardsIndex").append(card.ID)
        formVars.get("playerCardsByLevel")[card.level].append(card)
      globalVars.get("player").guil -= card.buyPrice
      hideWaitMessage(globalVars, formVars)
    else:
      waitMessage(globalVars, formVars, globalVars.get("messages").GM_ERRORBUYING, False, 5)
    delGraphic(formGraphics, "CONFIRM")
    #Chiedo i miei guil:
    globalVars.get("net").myMoney(myMoneyCallback)
    showBuyMenu()


def sellCard():
  """Sell a card"""
  #Chiedo conferma:
  formVars.set("CONFIRM_SELL", "status")
  graph = graphicElement()
  graph.name = "CONFIRM"
  graph.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_confirmshoptitle.png')
  text = globalVars.get("messages").GM_CONFIRMSELL
  globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, (graph.image.width - functions.textWidth(globalVars.get("fonts").get("fontMenuSel"), text)) / 2, 2, text)
  graph.posX = formVars.get("formMenu").posX
  graph.posY = formVars.get("formMenu").posY
  formGraphics.set(graph)

  formVars.get("formMenu").delGraphics()
  tMenu = confirm(globalVars, formVars, formGraphics, formVars.get("formMenu").menuWidth, formVars.get("formMenu").menuHeight - graph.image.height, formVars.get("formMenu").posX, formVars.get("formMenu").posY + graph.image.height + 1)
  tMenu.background_image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_confirmshop.png')
  def code(globalVars, formVars, menu, element):
    #Sell a card
    waitMessage(globalVars, formVars, globalVars.get("messages").GM_WAIT, True)
    formVars.get("formMenu").getGraphicElement("MENU_SELECTOR_LEFT").visible = False
    globalVars.get("net").sellCard(formVars.get("sellMenu").getSelected().data.ID, sellCardCallback)
  tMenu.elements[0].trigger_select = code

  def code(globalVars, formVars, menu, element):
    #Torno al menu:
    globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingSound")
    globalVars.get("playingSound").start()
    delGraphic(formGraphics, "CONFIRM")
    showSellMenu()
  tMenu.trigger_cancel = code
  tMenu.elements[1].trigger_select = tMenu.trigger_cancel
  formVars.set(tMenu, "formMenu")
  tMenu.createGraphicElements()


def sellCardCallback(pResponse, pError):
  """Sell a card"""
  if pError:
    waitMessage(globalVars, formVars, pError[1][1], False, 10)
    return

  response = functions.analyzeServerString(pResponse)
  if len(response) > 0:
    if response[0] == "OK":
      #Rimuovo la carta:
      card = formVars.get("sellMenu").getSelected().data
      if card.ID in globalVars.get("playerCardsIndex"):
        tCard = globalVars.get("playerCards")[globalVars.get("playerCardsIndex").index(card.ID)]
        tCard.count -= 1
        if tCard.count == 0:
          globalVars.get("playerCards").remove(tCard)
          globalVars.get("playerCardsIndex").remove(tCard.ID)
          formVars.get("playerCardsByLevel")[tCard.level].remove(tCard)
      globalVars.get("player").guil += card.sellPrice
      hideWaitMessage(globalVars, formVars)
    else:
      waitMessage(globalVars, formVars, globalVars.get("messages").GM_ERRORSELLING, False, 5)
    delGraphic(formGraphics, "CONFIRM")
    #Chiedo i miei guil:
    globalVars.get("net").myMoney(myMoneyCallback)
    showSellMenu()


def myMoneyCallback(pResponse, pError):
  """My money"""
  if pError:
    waitMessage(globalVars, formVars, pError[1][1], False, 10)
    return

  response = functions.analyzeServerString(pResponse)
  if len(response) > 0:
    globalVars.get("player").guil = int(response[0])
    if formVars.get("RESET"):
      formVars.get("RESET")[2] = True
      checkReset()


def showMainMenu():
  """Show main menu"""
  formVars.get("buyMenu").clear()
  formVars.get("sellMenu").clear()

  formVars.set(False, "menuCreated")
  graph = formGraphics.get("TITLE")
  graph.image = psp2d.Image(graph.data)
  graph = formGraphics.get("CARDINFO")
  graph.image = psp2d.Image(graph.imageBuffer )
  graph = formGraphics.get("TITLET")
  graph.image = None
  graph.text = globalVars.get("messages").GM_SHOP_TITLE
  graph.posX = (480 - functions.textWidth(graph.font, graph.text)) / 2
  formVars.get("formMenu").delGraphics()
  formVars.set(formVars.get("mainMenu"), "formMenu")
  formVars.get("formMenu").createGraphicElements()
  updateGeneralInfo()
  formVars.set("MAIN", "status")


def updateOtherInfo():
  """Update other info"""
  graph = formGraphics.get("OTHERINFO")
  graph.image = None
  graph.image = psp2d.Image(graph.imageBuffer )

  posX = 80
  posY = 5
  tHeight = functions.textHeight(globalVars.get("fonts").get("fontMenu"), "I")
  globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 0 * tHeight, globalVars.get("messages").GM_GUIL)
  if formVars.get("status") == "BUY":
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 1 * tHeight, globalVars.get("messages").GM_TOTALCARDS)

  zero = functions.textWidth(globalVars.get("fonts").get("fontMenu"), "0")
  posX = 245
  posY = 5
  globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(globalVars.get("player").guil)) - (zero - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(globalVars.get("player").guil))) / 2, posY + 0 * tHeight, str(globalVars.get("player").guil))

  if formVars.get("status") == "BUY":
    #Conto le carte:
    tCount = 0
    for card in formVars.get("cardsByLevel")[formVars.get("levelShown")]:
      if card.ID in globalVars.get("playerCardsIndex"):
        tCount += 1
        continue
      for tCard in globalVars.get("player").deck:
        if tCard and tCard.ID == card.ID:
          tCount += 1
          break

    tStr = str(tCount) + "/" + str(len(formVars.get("cardsByLevel")[formVars.get("levelShown")]))
    globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX - functions.textWidth(globalVars.get("fonts").get("fontMenu"), tStr ) - (zero - functions.textWidth(globalVars.get("fonts").get("fontMenu"), tStr )) / 2, posY + 1 * tHeight, tStr)



def updateGeneralInfo():
  """Update general info"""
  graph = formGraphics.get("OTHERINFO")
  graph.image = None
  graph.image = psp2d.Image(graph.imageBuffer)

  #Conto le carte:
  tCount = 0
  for card in globalVars.get("playerCards"):
    tCount += card.count
  for card in globalVars.get("player").deck:
    if card:
      tCount += 1
  graph = formGraphics.get("CARDINFO")
  graph.image = psp2d.Image(graph.imageBuffer)

  posX = 80
  posY = 50

  tHeight = functions.textHeight(globalVars.get("fonts").get("fontMenu"), "I")
  globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 0 * (tHeight + globalVars.get("themeOptions").MENU_INTERLINE), globalVars.get("messages").GM_GUIL)
  globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 1 * (tHeight + globalVars.get("themeOptions").MENU_INTERLINE), globalVars.get("messages").GM_TOTALCARDS)

  zero = functions.textWidth(globalVars.get("fonts").get("fontMenu"), "0")
  posX = 245
  posY = 50
  globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(globalVars.get("player").guil)) - (zero - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(globalVars.get("player").guil))) / 2, posY + 0 * (tHeight + globalVars.get("themeOptions").MENU_INTERLINE), str(globalVars.get("player").guil))
  globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(tCount)) - (zero - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(globalVars.get("player").guil))) / 2, posY + 1 * (tHeight + globalVars.get("themeOptions").MENU_INTERLINE), str(tCount))


def resetDeck():
  """Reset deck and money"""
  formVars.set("CONFIRM_RESET", "status")
  graph = graphicElement()
  graph.name = "CONFIRM"
  graph.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_confirmshoptitle.png')
  text = globalVars.get("messages").GM_CONFIRMRESET
  globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, (graph.image.width - functions.textWidth(globalVars.get("fonts").get("fontMenuSel"), text)) / 2, 2, text)
  graph.posX = formVars.get("formMenu").posX
  graph.posY = formVars.get("formMenu").posY
  formGraphics.set(graph)

  formVars.get("formMenu").delGraphics()
  tMenu = confirm(globalVars, formVars, formGraphics, formVars.get("formMenu").menuWidth, formVars.get("formMenu").menuHeight - graph.image.height, formVars.get("formMenu").posX, formVars.get("formMenu").posY + graph.image.height + 1)
  tMenu.background_image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_confirmshop.png')
  def code(globalVars, formVars, menu, element):
    #Conferma reset
    waitMessage(globalVars, formVars, globalVars.get("messages").GM_WAIT, True)
    formVars.get("formMenu").getGraphicElement("MENU_SELECTOR_LEFT").visible = False
    globalVars.get("net").resetDeck(resetDekCallback)
  tMenu.elements[0].trigger_select = code

  def code(globalVars, formVars, menu, element):
    #Torno al menu:
    globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingSound")
    globalVars.get("playingSound").start()
    delGraphic(formGraphics, "CONFIRM")
    showSellMenu()
  tMenu.trigger_cancel = code
  tMenu.elements[1].trigger_select = tMenu.trigger_cancel
  formVars.set(tMenu, "formMenu")
  tMenu.createGraphicElements()


def resetDekCallback(pResponse, pError):
  """Reset deck callback"""
  if pError:
    waitMessage(globalVars, formVars, pError[1][1], False, 10)
    return

  response = functions.analyzeServerString(pResponse)
  if len(response) > 0:
    if response[0] == "OK":
      formVars.set([False,False,False], "RESET")
      #Chiedo le mie carte:
      globalVars.get("net").getMyCards(getMyCardsCallback)
      #Chiedo il mio deck:
      globalVars.get("net").getMyDeck(getMyDeckCallback)
      #Chiedo i miei guil:
      globalVars.get("net").myMoney(myMoneyCallback)
    else:
      waitMessage(globalVars, formVars, globalVars.get("messages").GM_ERRORRESETTING, False, 5)
    delGraphic(formGraphics, "CONFIRM")
    showMainMenu()


def getMyCardsCallback(pResponse, pError):
  """Get my cards callback"""
  if pError:
    if "TIMEOUT" in pError[1][1].upper():
      #Ripeto la richiesta:
      globalVars.get("net").getAllCards(getAllCardsCallback)
    else:
      waitMessage(globalVars, formVars, pError[1][1], False, 10)
    return

  globalVars.set([], "playerCards")
  globalVars.set([], "playerCardsIndex")
  response = functions.analyzeServerString(pResponse)
  for c in response:
    if len(c):
      #Controllo se l'ho gia':
      if int(c) in globalVars.get("playerCardsIndex"):
        tCard = globalVars.get("playerCards")[globalVars.get("playerCardsIndex").index(int(c))]
        tCard.count += 1
      else:
        #Cerco la carta nel catalogo:
        if int(c) in globalVars.get("shopCardsIndex"):
          tCard = globalVars.get("shopCards")[globalVars.get("shopCardsIndex").index(int(c))].copy()
          tCard.count = 1
          globalVars.get("playerCards").append(tCard)
          globalVars.get("playerCardsIndex").append(tCard.ID)
        else:
          globalVars.get("logFile").log("ERROR: Card not found in catalog: " + c)
  formVars.get("RESET")[0] = True


def getMyDeckCallback(pResponse, pError):
  """Get my deck callback"""
  if pError:
    if "TIMEOUT" in pError[1][1].upper():
      #Ripeto la richiesta:
      globalVars.get("net").getMyDeck(getMyDeckCallback)
    else:
      waitMessage(globalVars, formVars, pError[1][1], False, 10)
    return

  response = functions.analyzeServerString(pResponse)
  globalVars.get("player").deck = [None] * 5
  for i, c in enumerate(response):
    #Cerco la carta nel catalogo:
    if int(c) in globalVars.get("shopCardsIndex"):
      tCard = globalVars.get("shopCards")[globalVars.get("shopCardsIndex").index(int(c))].copy()
      globalVars.get("player").deck[i] = tCard
    else:
      globalVars.get("logFile").log("ERROR: Card not found in catalog: " + c)

  formVars.get("RESET")[1] = True


def checkReset():
  """Check if reset ended"""
  if formVars.get("RESET") == [True,True,True]:
    formVars.set(None, "RESET")
    hideWaitMessage(globalVars, formVars)
    splitCards()
    mainMenu = createMainMenu()
    #mainMenu.createGraphicElements("BOTTOM")
    formVars.set(mainMenu, "formMenu")
    showMainMenu()


def splitCards():
  """Split cards by level"""
  #Divido le carte per livello:
  formVars.set([[] for i in xrange(0,11)], "cardsByLevel")
  for card in globalVars.get("shopCards"):
    formVars.get("cardsByLevel")[card.level].append(card)
  formVars.set([[] for i in xrange(0,11)], "playerCardsByLevel")
  for card in globalVars.get("playerCards"):
    formVars.get("playerCardsByLevel")[card.level].append(card)


def button_down(pbuttons):
  #Gestione tasti form shop:
  if formVars.get("status") in ["BUY", "SELL"]:
    if buttons.left_trigger in pbuttons:
      #Cambio livello
      if formVars.get("levelShown") > 1:
        formVars.set(formVars.get("levelShown") - 1, "levelShown")
        if formVars.get("status") == "BUY":
          showBuyMenu()
        else:
          showSellMenu()
      return True
    elif buttons.right_trigger in pbuttons:
      #Cambio livello
      if formVars.get("levelShown") < 10:
        formVars.set(formVars.get("levelShown") + 1, "levelShown")
        if formVars.get("status") == "BUY":
          showBuyMenu()
        else:
          showSellMenu()
      return True
    elif buttons.select in pbuttons:
      #Cambio ordinamento:
      order = ["PRICE", "CARDSET", "NAME"]
      try:
        formVars.set(order[order.index(formVars.get("order")) + 1], "order")
      except:
        formVars.set(order[0], "order")
      waitMessage(globalVars, formVars, eval("globalVars.get(\"messages\").GM_ORDER_" + formVars.get("order")), False, 5)
      if formVars.get("status") == "BUY":
        showBuyMenu()
      else:
        showSellMenu()
      return True
