#    Triple Triad PSP
#    Copyright (C) 2006, 2007 Sakya
#    sakya_tg@yahoo.it
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
import psp2d
from core import graphicElement, dataStore, animation, functions, menu, menuElement, buttons
from formsFunction import *

"""Form start"""
formGraphics = dataStore()
formVars = dataStore()
formVars.set(formGraphics, "formGraphics")

def init(pGlobalVars, pParams):
  global formVars, globalVars, formGraphics

  formGraphics = dataStore()
  formVars = dataStore()
  formVars.set(formGraphics, "formGraphics")
  globalVars = pGlobalVars

  formVars.set(globalVars.get("images").get("defaultBkgImage"), "bkgImage")
  formVars.set(0, "bkgImagePosX")
  formVars.set(0, "bkgImagePosY")

  startMenu = menu(formGraphics, pGlobalVars, formVars)
  startMenu.name = "STARTMENU"

  lang = pGlobalVars.get("userData").LANG
  theme = pGlobalVars.get("userData").THEME

  #Titolo:
  graph = graphicElement()
  graph.name = "TITLE"
  graph.image = psp2d.Image('themes/' + pGlobalVars.get("userData").THEME + '/formsbg/gm_generic_title.png')
  graph.posX = -440
  graph.posY = 8
  anim = animation()
  anim.name = "TITLE"
  anim.data = [20, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)

  graph = graphicElement()
  graph.name = "TITLET"
  graph.font = pGlobalVars.get("fonts").get("fontTitle")
  graph.posY = 10
  graph.text = pGlobalVars.get("messages").START
  graph.posX = -functions.textWidth(graph.font, graph.text)
  anim = animation()
  anim.name = "TITLE"
  anim.data = [(480 - functions.textWidth(graph.font, graph.text)) / 2, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim

  formGraphics.set(graph)

  tElement = menuElement()
  tElement.text = pGlobalVars.get("messages").QUICK
  tElement.helpText = pGlobalVars.get("messages").QUICKH
  tElement.value = "STARTQUICK"
  def code(globalVars, formVars, menu, element):
    #Passo al menu start options:
    globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
    globalVars.get("playingSound").start()
    globalVars.set("mdlStartOptions", "formName")
    globalVars.set("YES", "breakLoop")
  tElement.trigger_select = code

  startMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = pGlobalVars.get("messages").SINGLE
  tElement.helpText = pGlobalVars.get("messages").SINGLEH
  tElement.enabled = False
  tElement.value = "STARTSINGLE"
  def code(globalVars, formVars, menu, element):
    #Inizio la partita single player:
    globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
    globalVars.get("playingSound").start()
    globalVars.set("mdlGame", "formName")
    globalVars.set(["SINGLE"], "formparams")
    globalVars.set("YES", "breakLoop")
  tElement.trigger_select = code
  startMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = pGlobalVars.get("messages").MULTI
  tElement.helpText = pGlobalVars.get("messages").MULTIH
  tElement.value = "STARTMULTI|INFRA"
  tSubElement = menuElement()
  tSubElement.text = pGlobalVars.get("messages").INFRASTRUCTURE
  tSubElement.value = "INFRA"
  tElement.subMenu.append(tSubElement)
  tSubElement = menuElement()
  tSubElement.text = pGlobalVars.get("messages").ADHOC
  tSubElement.value = "ADHOC"
  tElement.subMenu.append(tSubElement)
  def code(globalVars, formVars, menu, element):
    #Scelta connessione e server:
    globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
    globalVars.get("playingSound").start()
    globalVars.set("mdlNetOptions", "formName")
    globalVars.set("YES", "breakLoop")

  tElement.trigger_select = code
  startMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = pGlobalVars.get("messages").MAIN
  tElement.helpText = pGlobalVars.get("messages").MAINH
  tElement.value = "MAIN"
  tElement.trigger_select = functions.backToMainMenu
  startMenu.elements.append(tElement)

  startMenu.trigger_cancel = functions.backToMainMenu

  startMenu.background_image = psp2d.Image('themes/' + pGlobalVars.get("userData").THEME + '/formsbg/gm_generic_menu.png')
  startMenu.posX = pGlobalVars.get("themeOptions").MENU_X
  startMenu.posY = pGlobalVars.get("themeOptions").MENU_Y
  startMenu.menuWidth = pGlobalVars.get("themeOptions").MENU_W
  startMenu.menuHeight = pGlobalVars.get("themeOptions").MENU_H
  startMenu.selectFirstElement()
  startMenu.menuAlignment = pGlobalVars.get("themeOptions").MENU_ALIGN
  startMenu.menuVAlignment = pGlobalVars.get("themeOptions").MENU_VALIGN

  if pParams:
    startMenu.selected = pParams[0]
  else:
    startMenu.selectFirstElement()
  formMenu = startMenu
  formMenu.createGraphicElements("BOTTOM")
  formVars.set(formMenu, "formMenu")
  formVars.set(None, "formToolbar")


def button_down(pbuttons):
  return False