#    Triple Triad PSP
#    Copyright (C) 2006, 2007 Sakya
#    sakya_tg@yahoo.it
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
import psp2d
from core import functions, animation, graphicElement, menu, menuElement, buttons
from formsFunction import *

"""Form theme options"""
formGraphics = dataStore()
formVars = dataStore()
formVars.set(formGraphics, "formGraphics")
globalVars = None

def init(pGlobalVars, pParams):
  global formVars, globalVars, formGraphics

  formGraphics = dataStore()
  formVars = dataStore()
  formVars.set(formGraphics, "formGraphics")
  globalVars = pGlobalVars

  formVars.set(globalVars.get("images").get("defaultBkgImage"), "bkgImage")
  formVars.set(0, "bkgImagePosX")
  formVars.set(0, "bkgImagePosY")

  #Mi salvo le opzioni:
  formVars.set([globalVars.get("themeOptions").MENU_ALIGN, globalVars.get("themeOptions").MENU_VALIGN, globalVars.get("themeOptions").MENU_SELECTOR, globalVars.get("themeOptions").MENU_ALPHA], "data")

  #Titolo:
  graph = graphicElement()
  graph.name = "TITLE"
  graph.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_generic_title.png')
  graph.posX = -440
  graph.posY = 8
  anim = animation()
  anim.name = "TITLE"
  anim.data = [20, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)

  graph = graphicElement()
  graph.name = "TITLET"
  graph.font = globalVars.get("fonts").get("fontTitle")
  graph.text = globalVars.get("messages").THEMEOPTIONS
  graph.posY = 10
  graph.posX = -functions.textWidth(graph.font, graph.text)
  anim = animation()
  anim.name = "TITLET"
  anim.data = [(480 - functions.textWidth(graph.font, graph.text)) / 2, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)

  optionMenu = menu(formGraphics, globalVars, formVars)
  optionMenu.name = "THEMEOPTIONSMENU"
  optionMenu.background_image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_generic_menu.png')
  optionMenu.posX = globalVars.get("themeOptions").MENU_X
  optionMenu.posY = globalVars.get("themeOptions").MENU_Y
  optionMenu.menuWidth = globalVars.get("themeOptions").MENU_W
  optionMenu.menuHeight = globalVars.get("themeOptions").MENU_H
  optionMenu.menuAlignment = globalVars.get("themeOptions").MENU_ALIGN
  optionMenu.menuVAlignment = globalVars.get("themeOptions").MENU_VALIGN
  formVars.set(optionMenu, "optionMenu")
  createMenu()

  optionMenu.createGraphicElements("BOTTOM")


def createMenu():
  """Creates menu"""
  optionMenu = formVars.get("optionMenu")
  optionMenu.elements = []
  optionMenu.firstVisible = None
  optionMenu.lastVisible = None

  tElement = menuElement()
  tElement.text = globalVars.get("messages").MENUALIGN
  tElement.helpText = globalVars.get("messages").MENUALIGNH
  tElement.value = "MENUALIGN"

  tSubElement = menuElement()
  tSubElement.text = globalVars.get("messages").ALIGNLEFT
  tSubElement.value = "LEFT"
  if tSubElement.value == globalVars.get("themeOptions").MENU_ALIGN:
    tElement.value = "MENUALIGN|" + globalVars.get("themeOptions").MENU_ALIGN
  tElement.subMenu.append(tSubElement)

  tSubElement = menuElement()
  tSubElement.text = globalVars.get("messages").ALIGNCENTER
  tSubElement.value = "CENTER"
  if tSubElement.value == globalVars.get("themeOptions").MENU_ALIGN:
    tElement.value = "MENUALIGN|" + globalVars.get("themeOptions").MENU_ALIGN
  tElement.subMenu.append(tSubElement)

  tSubElement = menuElement()
  tSubElement.text = globalVars.get("messages").ALIGNRIGHT
  tSubElement.value = "RIGHT"
  if tSubElement.value == globalVars.get("themeOptions").MENU_ALIGN:
    tElement.value = "MENUALIGN|" + globalVars.get("themeOptions").MENU_ALIGN
  tElement.subMenu.append(tSubElement)

  def code(globalVars, formVars, menu, element):
    #Cambio l'opzione:
    menu.globalVars.get("themeOptions").MENU_ALIGN = element.value.split("|")[1]
    menu.menuAlignment = menu.globalVars.get("themeOptions").MENU_ALIGN
    createMenu()
    menu.selected = element.value
    menu.createGraphicElements()
  tElement.trigger_changeSubMenu = code
  optionMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").MENUVALIGN
  tElement.helpText = globalVars.get("messages").MENUVALIGNH
  tElement.value = "MENUVALIGN"

  tSubElement = menuElement()
  tSubElement.text = globalVars.get("messages").ALIGNTOP
  tSubElement.value = "TOP"
  if tSubElement.value == globalVars.get("themeOptions").MENU_VALIGN:
    tElement.value = "MENUVALIGN|" + globalVars.get("themeOptions").MENU_VALIGN
  tElement.subMenu.append(tSubElement)

  tSubElement = menuElement()
  tSubElement.text = globalVars.get("messages").ALIGNCENTER
  tSubElement.value = "CENTER"
  if tSubElement.value == globalVars.get("themeOptions").MENU_VALIGN:
    tElement.value = "MENUVALIGN|" + globalVars.get("themeOptions").MENU_VALIGN
  tElement.subMenu.append(tSubElement)

  tSubElement = menuElement()
  tSubElement.text = globalVars.get("messages").ALIGNBOTTOM
  tSubElement.value = "BOTTOM"
  if tSubElement.value == globalVars.get("themeOptions").MENU_VALIGN:
    tElement.value = "MENUVALIGN|" + globalVars.get("themeOptions").MENU_VALIGN
  tElement.subMenu.append(tSubElement)
  def code(globalVars, formVars, menu, element):
    #Cambio l'opzione:
    menu.globalVars.get("themeOptions").MENU_VALIGN = element.value.split("|")[1]
    menu.menuVAlignment = menu.globalVars.get("themeOptions").MENU_VALIGN
    createMenu()
    menu.selected = element.value
    menu.createGraphicElements()
  tElement.trigger_changeSubMenu = code
  optionMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").MENUSELECTOR
  tElement.helpText = globalVars.get("messages").MENUSELECTORH
  tElement.value = "MENUSELECTOR"

  tSubElement = menuElement()
  tSubElement.text = globalVars.get("messages").ALIGNLEFT
  tSubElement.value = "LEFT"
  if tSubElement.value == globalVars.get("themeOptions").MENU_SELECTOR:
    tElement.value = "MENUSELECTOR|" + globalVars.get("themeOptions").MENU_SELECTOR
  tElement.subMenu.append(tSubElement)

  tSubElement = menuElement()
  tSubElement.text = globalVars.get("messages").ALIGNRIGHT
  tSubElement.value = "RIGHT"
  if tSubElement.value == globalVars.get("themeOptions").MENU_SELECTOR:
    tElement.value = "MENUSELECTOR|" + globalVars.get("themeOptions").MENU_SELECTOR
  tElement.subMenu.append(tSubElement)

  tSubElement = menuElement()
  tSubElement.text = globalVars.get("messages").SELECTORBOTH
  tSubElement.value = "BOTH"
  if tSubElement.value == globalVars.get("themeOptions").MENU_SELECTOR:
    tElement.value = "MENUSELECTOR|" + globalVars.get("themeOptions").MENU_SELECTOR
  tElement.subMenu.append(tSubElement)
  def code(globalVars, formVars, menu, element):
    #Cambio l'opzione:
    menu.globalVars.get("themeOptions").MENU_SELECTOR = element.value.split("|")[1]
    menu.delGraphicElement("MENU_SELECTOR_LEFT")
    menu.delGraphicElement("MENU_SELECTOR_RIGHT")
    menu.selector = menu.globalVars.get("themeOptions").MENU_SELECTOR
    createMenu()
    formVars.get("formMenu").selected = element.value
    formVars.get("formMenu").createGraphicElements()
  tElement.trigger_changeSubMenu = code
  optionMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").SAVEOPTION
  tElement.helpText = globalVars.get("messages").SAVEOPTIONH
  tElement.value = "SAVETHEMEOPTIONS"
  def code(globalVars, formVars, menu, element):
    #Ricarico le variabili:
    menu.globalVars.get("themeOptions").MENU_ALIGN= menu.getElement("MENUALIGN").value.split("|")[1]
    menu.globalVars.get("themeOptions").MENU_VALIGN= menu.getElement("MENUVALIGN").value.split("|")[1]
    menu.globalVars.get("themeOptions").MENU_SELECTOR= menu.getElement("MENUSELECTOR").value.split("|")[1]

    #Salvo il file:
    f = file("themes/" + menu.globalVars.get("userData").THEME + "/__init__.py", "w")
    f.write("#Theme definition file:\n")
    f.write("NAME=\"" + menu.globalVars.get("themeOptions").NAME + "\"\n")
    f.write("DESC=\"" + menu.globalVars.get("themeOptions").DESC + "\"\n")
    f.write("#Menu position:\n")
    f.write("MENU_X=" + str(menu.globalVars.get("themeOptions").MENU_X) + "\n")
    f.write("MENU_Y=" + str(menu.globalVars.get("themeOptions").MENU_Y) + "\n")
    f.write("#Menu dimensions:\n")
    f.write("MENU_H=" + str(menu.globalVars.get("themeOptions").MENU_H) + "\n")
    f.write("MENU_W=" + str(menu.globalVars.get("themeOptions").MENU_W) + "\n")
    f.write("#Menu alignment:\n")
    f.write("MENU_ALIGN=\"" + menu.globalVars.get("themeOptions").MENU_ALIGN + "\"\n")
    f.write("MENU_VALIGN=\"" + menu.globalVars.get("themeOptions").MENU_VALIGN + "\"\n")
    f.write("#Menu selector:\n")
    f.write("MENU_SELECTOR=\"" + menu.globalVars.get("themeOptions").MENU_SELECTOR + "\"\n")
    f.write("MENU_SELECTOR_DELTA=" + str(menu.globalVars.get("themeOptions").MENU_SELECTOR_DELTA) + "\n")
    f.write("#Menu colors:\n")
    f.write("MENU_OUTERCOLOR=" + repr(menu.globalVars.get("themeOptions").MENU_OUTERCOLOR) + "\n")
    f.write("MENU_INNERCOLOR=" + repr(menu.globalVars.get("themeOptions").MENU_INNERCOLOR) + "\n")
    f.write("MENU_CORNERCOLOR=" + repr(menu.globalVars.get("themeOptions").MENU_CORNERCOLOR) + "\n")
    f.write("#Border width:\n")
    f.write("MENU_BORDERWIDTH=" + str(menu.globalVars.get("themeOptions").MENU_BORDERWIDTH) + "\n")
    f.write("#Menu alpha:\n")
    f.write("MENU_ALPHA=" + str(menu.globalVars.get("themeOptions").MENU_ALPHA) + "\n")
    f.write("#Menu space between lines:\n")
    f.write("MENU_INTERLINE=" + str(menu.globalVars.get("themeOptions").MENU_INTERLINE) + "\n")
    f.close()

    globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
    globalVars.get("playingSound").start()
    globalVars.set("mdlOptions", "formName")
    globalVars.set(["THEMEOPTIONS"], "formParams")
    globalVars.set("YES", "breakLoop")
  tElement.trigger_select = code
  optionMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").BACKTOOPTIONS
  tElement.helpText = globalVars.get("messages").BACKTOOPTIONSH
  tElement.value = "BACKTOOPTIONS"
  def code(globalVars, formVars, menu, element):
    #Passo al menu opzioni:
    globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
    globalVars.get("playingSound").start()

    #Ripristino le opzioni:
    menu.globalVars.get("themeOptions").MENU_ALIGN = formVars.get("data")[0]
    menu.globalVars.get("themeOptions").MENU_VALIGN = formVars.get("data")[1]
    menu.globalVars.get("themeOptions").MENU_SELECTOR = formVars.get("data")[2]
    menu.globalVars.get("themeOptions").MENU_ALPHA = formVars.get("data")[3]
    globalVars.set("mdlOptions", "formName")
    globalVars.set(["THEMEOPTIONS"], "formParams")
    globalVars.set("YES", "breakLoop")
  tElement.trigger_select = code
  optionMenu.elements.append(tElement)

  def code(globalVars, formVars, menu, element):
    globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingSound")
    globalVars.get("playingSound").start()

    #Ripristino le opzioni:
    menu.globalVars.get("themeOptions").MENU_ALIGN = formVars.get("data")[0]
    menu.globalVars.get("themeOptions").MENU_VALIGN = formVars.get("data")[1]
    menu.globalVars.get("themeOptions").MENU_SELECTOR = formVars.get("data")[2]
    menu.globalVars.get("themeOptions").MENU_ALPHA = formVars.get("data")[3]

    #Passo al menu opzioni:
    globalVars.set("mdlOptions", "formName")
    globalVars.set(["THEMEOPTIONS"], "formParams")
    globalVars.set("YES", "breakLoop")
  optionMenu.trigger_cancel = code
  optionMenu.selected = optionMenu.elements[0].value
  formVars.set(optionMenu, "formMenu")


def button_down(pbuttons):
  return False
