#    Triple Triad PSP
#    Copyright (C) 2006, 2007 Sakya
#    sakya_tg@yahoo.it
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
import psp2d
from core import functions, animation, graphicElement, dataStore, menu, menuElement, buttons, TTplayer
from formsFunction import *

"""Form topList"""
formGraphics = dataStore()
formVars = dataStore()
formVars.set(formGraphics, "formGraphics")
globalVars = None

def init(pGlobalVars, pParams):
  global formVars, globalVars, formGraphics

  formGraphics = dataStore()
  formVars = dataStore()
  formVars.set(formGraphics, "formGraphics")
  globalVars = pGlobalVars

  formVars.set(psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_bg_toplist.png'), "bkgImage")
  formVars.set('themes/' + globalVars.get("userData").THEME + '/gm_bg_toplist.png', "bkgImageName")
  formVars.set(0, "bkgImagePosX")
  formVars.set(0, "bkgImagePosY")

  #Carico le icone degli elementi:
  formVars.set(globalVars.get("elements"), "elements")

  formVars.set(False, "menuCreated")

  #Titolo:
  graph = graphicElement()
  graph.name = "TITLE"
  graph.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_bg_title.png')
  graph.posX = -476
  graph.posY = 2
  anim = animation()
  anim.name = graph.name
  anim.data = [2, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)

  graph = graphicElement()
  graph.name = "TITLET"
  graph.font = globalVars.get("fonts").get("fontTitle")
  graph.posY = 4
  graph.text = globalVars.get("messages").GM_TOPLIST_TITLE
  graph.posX = -functions.textWidth(graph.font, graph.text)
  anim = animation()
  anim.name = graph.name
  anim.data = [(480 - functions.textWidth(graph.font, graph.text)) / 2, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)

  #Messaggi:
  formGraphics.set(createMessagesGE(globalVars, formVars))
  formVars.set(False, "playerMenuCreated")

  #Top list
  topList = menu(formGraphics, pGlobalVars, formVars)
  topList.name = "TOP_LIST"

  topList.menuHeight = 200
  topList.menuWidth = 200
  topList.background_image =  psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_bg_200x200.png')
  topList.posX = 2
  topList.posY = 41
  topList.selector = "RIGHT"
  topList.menuAlignment = "LEFT"
  def code(globalVars, formVars, menu, element):
    #Torno al gioco:
    globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingSound")
    globalVars.get("playingSound").start()
    globalVars.get("net").changeStatus("N")
    globalVars.set(["RESTORE"], "formParams")
    globalVars.set("mdlGame", "formName")
    globalVars.set("YES", "breakLoop")

  topList.trigger_cancel = code
  formVars.set(topList, "topList")
  formVars.set(topList, "formMenu")

  #Chiedo la lista:
  if pParams[0] == "WORLD":
    globalVars.get("net").topList(topListCallback)
  elif pParams[0] == "LOCATION":
    globalVars.get("net").topListLocation(topListCallback)

  #Player menu:
  playerMenu = menu(formGraphics, pGlobalVars, formVars)
  playerMenu.name = "PLAYER_MENU"
  playerMenu.menuWidth = 200
  playerMenu.menuHeight = 110
  playerMenu.posY = 142
  playerMenu.background_image =  psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_bg_topplayermenu.png')
  playerMenu.posX = topList.posX + topList.menuWidth + 2
  playerMenu.menuAlignment = "LEFT"
  playerMenu.menuVAlignment = "CENTER"
  playerMenu.selector = "RIGHT"
  formVars.set(playerMenu, "playerMenu")

  formVars.set("LIST", "status")


def topListCallback(pResponse, pError):
  """Get top list"""
  functions.waitSafeMenu(formVars.get("topList"))
  if pError:
    waitMessage(globalVars, formVars, pError[1][1], False, 10)
    return

  response = functions.analyzeServerString(pResponse)
  topList = formVars.get("topList")
  topList.creating = True
  topList.elements = []

  #Trigger su menu:
  def trigger_enter(globalVars, formVars, menu, element):
    #Aggiorno le informazioni del giocatore:
    updatePlayerInfoFix()
    updatePlayerInfo()

  for pos, b in enumerate(response):
    player = TTplayer()
    cb = b.split("||")
    if len(cb) >= 10:
      #Filtro i nomi vuoti (non dovrebbe succedere):
      if len(cb[0]) == 0:
        continue
      player.name = cb[0]
      player.element = cb[1]
      player.city = int(cb[2])
      #Descrizione citta':
      player.cityDescription = ""
      for tCity in globalVars.get("cityList"):
        if tCity.cityID == player.city:
          player.cityDescription = tCity.name
          break

      player.location = int(cb[3])
      #Descrizione location:
      player.locationDescription = ""
      for tCity in globalVars.get("locationList"):
        if tCity.cityID == player.location:
          player.locationDescription = tCity.name
          break

      player.status = cb[4]
      player.played = int(cb[5])
      player.won = int(cb[6])
      player.lost = int(cb[7])
      player.draw = int(cb[8])
      player.exp = int(cb[9])

      tElement = menuElement()
      tElement.data = player
      tElement.value = player.name
      tElement.text = str(pos + 1).rjust(2) + ". " + player.name
      tElement.icon = getStatusIcon(globalVars, player.status)
      def code(globalVars, formVars, menu, element):
        #Apro il player menu:
        globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
        globalVars.get("playingSound").start()
        showPlayerMenu()
      tElement.trigger_select = code
      tElement.trigger_enter = trigger_enter
      topList.elements.append(tElement)

  if not topList.selected and len(topList.elements) > 0:
    if topList.firstVisible:
      topList.selected = topList.firstVisible.value
    else:
      topList.selectFirstElement()

  if not formVars.get("menuCreated"):
    formVars.set(True, "menuCreated")
    #Info giocatore:
    graph = graphicElement()
    graph.name = "PLAYER_INFO"
    graph.imageBuffer = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_bg_topinfo.png')
    graph.posY = topList.posY
    graph.posX = 480
    anim = animation()
    anim.name = graph.name
    anim.data = [topList.posX + topList.menuWidth + 2, graph.posY, 99]
    anim.code = functions.moveFromTo
    graph.animation = anim
    formGraphics.set(graph)
    updatePlayerInfoFix()
    topList.createGraphicElements("BOTTOM")
  else:
    topList.createGraphicElements()

  topList.elements[0].trigger_enter(globalVars, formVars, topList, topList.elements[0])
  if formVars.get("status") == "LIST":
    topList.getGraphicElement("MENU_SELECTOR_RIGHT").visible = True
  topList.creating = False


def updatePlayerInfoFix():
  #Update player Info fixed text:
  graph = formGraphics.get("PLAYER_INFO")
  graph.image = psp2d.Image(graph.imageBuffer)

  posX = 5
  posY = 5
  tHeight = functions.textHeight(globalVars.get("fonts").get("fontMenu"), "I")
  globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 0 * tHeight, globalVars.get("messages").GM_NAME)
  globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 1 * tHeight, globalVars.get("messages").GM_STATUS)
  globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, posX, posY + 2 * tHeight, globalVars.get("messages").GM_PLAY)
  globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, 60 * 2 - functions.textWidth(globalVars.get("fonts").get("fontMenuSel"), globalVars.get("messages").GM_EXP), posY + 2 * tHeight, globalVars.get("messages").GM_EXP)
  globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, 60 - functions.textWidth(globalVars.get("fonts").get("fontMenuSel"), globalVars.get("messages").GM_WIN), posY + 3 * tHeight, globalVars.get("messages").GM_WIN)
  globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, 60 * 2 - functions.textWidth(globalVars.get("fonts").get("fontMenuSel"), globalVars.get("messages").GM_DRAW), posY + 3 * tHeight, globalVars.get("messages").GM_DRAW)
  globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, 60 * 3 - functions.textWidth(globalVars.get("fonts").get("fontMenuSel"), globalVars.get("messages").GM_LOSE), posY + 3 * tHeight, globalVars.get("messages").GM_LOSE)


def updatePlayerInfo():
  #Update player info:
  graph = formGraphics.get("PLAYER_INFO")
  if not graph:
    return

  player = formVars.get("formMenu").getSelected().data

  posX = 5
  posY = 5
  tHeight = functions.textHeight(globalVars.get("fonts").get("fontMenu"), "I")
  elementImage = eval("globalVars.get(\"images\").get(\"element" + player.element.title() + "Image\")")
  graph.image.blit(elementImage, 0, 0, elementImage.width, elementImage.height, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), globalVars.get("messages").GM_NAME + " "), posY + 0 * tHeight, True)
  globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), globalVars.get("messages").GM_NAME + " ") + elementImage.width, posY + 0 * tHeight, player.name)
  globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), globalVars.get("messages").GM_STATUS + " "), posY + 1 * tHeight, eval("globalVars.get(\"messages\").GM_STATUS_" + player.status))
  globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), globalVars.get("messages").GM_PLAY + " "), posY + 2 * tHeight, str(player.played))
  globalVars.get("fonts").get("fontMenu").drawText(graph.image, 60 * 3 - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(player.exp)), posY + 2 * tHeight, str(player.exp))
  globalVars.get("fonts").get("fontMenu").drawText(graph.image, 60 - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(player.won)), posY + 4 * tHeight, str(player.won))
  globalVars.get("fonts").get("fontMenu").drawText(graph.image, 60 * 2 - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(player.draw)), posY + 4 * tHeight, str(player.draw))
  globalVars.get("fonts").get("fontMenu").drawText(graph.image, 60 * 3 - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(player.lost)), posY + 4 * tHeight, str(player.lost))
  if player.status != "O":
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 5 * tHeight, globalVars.get("messages").GM_NOWIN)
    globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX + functions.textWidth(globalVars.get("fonts").get("fontMenu"), globalVars.get("messages").GM_NOWIN + " "), posY + 5 * tHeight, player.cityDescription)


def showPlayerMenu():
  #Cambio stato alla form:
  formVars.set("PLAYER", "status")

  sel = formVars.get("formMenu").getGraphicElement("MENU_SELECTOR_RIGHT")
  if sel:
    sel.visible = False

  #Cambio menu:
  pMenu = formVars.get("playerMenu")
  pMenu.elements = []
  pMenu.firsVisible = None
  pMenu.lastVisible = None
  if formVars.get("topList").getSelected().data.name != globalVars.get("player").name:
    tElement = menuElement()
    tElement.text = globalVars.get("messages").GM_MESSAGE
    tElement.helpText = globalVars.get("messages").GM_MESSAGEH
    tElement.icon = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_replymessage.png')
    tElement.value = "SEND_MSG"
    def code(globalVars, formVars, menu, element):
      #Scrivo un nuovo messaggio:
      globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
      globalVars.get("playingSound").start()
      globalVars.set("mdlNewMessage", "formName")
      globalVars.set([formVars.get("topList").getSelected().data.name, "", "mdlTopList", None], "formParams")
      globalVars.set("YES", "breakLoop")
    tElement.trigger_select = code
    pMenu.elements.append(tElement)

  sel = formVars.get("topList").getSelected().data
  if sel.status != "O" \
  and (sel.city != globalVars.get("player").city \
  or sel.location != globalVars.get("player").location):
    tElement = menuElement()
    tElement.text = globalVars.get("messages").GM_JOINBUDDY
    tElement.helpText = globalVars.get("messages").GM_JOINPLAYERH + " " + sel.cityDescription
    tElement.icon = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_join.png')
    tElement.value = "JOIN"
    def code(globalVars, formVars, menu, element):
      #Raggiungo il player:
      globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
      globalVars.get("playingSound").start()
      sel = formVars.get("topList").getSelected().data
      waitMessage(globalVars, formVars, menu.globalVars.get("messages").GM_CHANGINGCITY + " " + sel.cityDescription)
      globalVars.get("net").enterLocation(sel.city, sel.location, enterLocationCallback)
      menu.getGraphicElement("MENU_SELECTOR_RIGHT").visible = False
    tElement.trigger_select = code
    pMenu.elements.append(tElement)

  #Chiudo il menu con cerchio:
  def code(globalVars, formVars, menu, element):
    globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingSound")
    globalVars.get("playingSound").start()
    hidePlayerMenu()
  pMenu.trigger_cancel = code

  #Challenge (se non sono io):
  if formVars.get("topList").getSelected().data.name != globalVars.get("player").name \
  and formVars.get("topList").getSelected().data.status == "N":
    tElement = menuElement()
    tElement.text = globalVars.get("messages").GM_CHALLENGE
    tElement.icon = globalVars.get("iconChallenge")
    tElement.helpText = globalVars.get("messages").GM_CHALLENGEH
    tElement.value = "CHALLENGE"
    def code(globalVars, formVars, menu, element):
      #Chiedo conferma della sfida:
      graph = graphicElement()
      graph.name = "CONFIRM"
      graph.image = psp2d.Image('themes/' + menu.globalVars.get("userData").THEME + '/formsbg/gm_confirmch_title.png')
      text = menu.globalVars.get("messages").GM_CONFIRMCHALLENGE + " " + formVars.get("topList").selected + "?"
      globalVars.get("fonts").get("fontMenuSel").drawText(graph.image, (graph.image.width - functions.textWidth(globalVars.get("fonts").get("fontMenuSel"), text)) / 2, 2, text)
      graph.posX = menu.posX
      graph.posY = menu.posY
      menu.formGraphics.set(graph)

      globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
      globalVars.get("playingSound").start()

      tMenu = formVars.get("formMenu")
      tMenu.delGraphics()
      tMenu = confirm(globalVars, formVars, formGraphics, tMenu.menuWidth, tMenu.menuHeight - graph.image.height, tMenu.posX, tMenu.posY + graph.image.height + 1)
      tMenu.name = "CONFIRMCHALLENGE"
      tMenu.background_image = psp2d.Image('themes/' + menu.globalVars.get("userData").THEME + '/formsbg/gm_bg_topchallenge.png')
      def code(globalVars, formVars, menu, element):
        #Chiudo il menu:
        globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingSound")
        globalVars.get("playingSound").start()
        delGraphic(formGraphics, "CONFIRM")
        menu.delGraphics()
        showPlayerMenu()
      tMenu.elements[1].trigger_select = code
      tMenu.trigger_cancel = code
      def code(globalVars, formVars, menu, element):
        #Lancio la sfida:
        globalVars.set(globalVars.get("sounds").get("menuSelectSound"), "playingSound")
        globalVars.get("playingSound").start()
        globalVars.get("net").sendInvite(formVars.get("topList").getSelected().data.ID, None, None)
        globalVars.get("net").changeStatus("N")
        globalVars.set(["RESTORE"], "formParams")
        globalVars.set("mdlGame", "formName")
        globalVars.set("YES", "breakLoop")
      tMenu.elements[0].trigger_select = code
      formVars.set(tMenu, "formMenu")
      tMenu.createGraphicElements("RIGHT")

    tElement.trigger_select = code
    pMenu.elements.append(tElement)

  tElement = menuElement()
  tElement.text = globalVars.get("messages").GM_CLOSE
  tElement.helpText = globalVars.get("messages").GM_CLOSEH
  tElement.icon = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/gm_t_logout.png')
  tElement.value = "CLOSE"
  tElement.trigger_select = pMenu.trigger_cancel
  pMenu.elements.append(tElement)

  pMenu.selected = pMenu.elements[0].value

  formVars.set(pMenu, "formMenu")
  if not formVars.get("playerMenuCreated"):
    pMenu.createGraphicElements("RIGHT")
    formVars.set(True, "playerMenuCreated")
  else:
    pMenu.createGraphicElements()


def hidePlayerMenu():
  #Hide player menu:
  formVars.set(False, "playerMenuCreated")
  formVars.set("LIST", "status")
  formVars.get("formMenu").delGraphics()

  formVars.set(formVars.get("topList"), "formMenu")
  sel = formVars.get("topList").getGraphicElement("MENU_SELECTOR_RIGHT")
  if sel:
    sel.visible = True
  globalVars.set(None, "message")


def enterLocationCallback(pResponse, pError):
  """Change city"""
  if pError:
    menu.getGraphicElement("MENU_SELECTOR_RIGHT").visible = True
    waitMessage(globalVars, formVars, pError[1][1], False, 10)
    return

  response = functions.analyzeServerString(pResponse)
  if response[0] == "OK":
    globalVars.get("net").changeStatus("N")
    globalVars.get("newCity")
    globalVars.get("newLocation")
    globalVars.set(["RESTORE"], "formParams")
    globalVars.set("mdlGame", "formName")
    globalVars.set("YES", "breakLoop")
  else:
      menu.getGraphicElement("MENU_SELECTOR_RIGHT").visible = True


def button_down(pbuttons):
  #Gestione tasti form di gioco:
  if formVars.get("status") == "PLAYER_INFO":
    #Nascondo le informazioni del giocatore:
    globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingSound")
    globalVars.get("playingSound").start()
    delGraphic(formGraphics, "PLAYER_INFO")
    formVars.set(formVars.get("playerMenu"), "formMenu")
    formVars.get("playerMenu").createGraphicElements()
    formVars.set("PLAYER_MENU", "status")
    return True
