#    Triple Triad PSP
#    Copyright (C) 2006, 2007 Sakya
#    sakya_tg@yahoo.it
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
import psp2d
from core import functions, animation, graphicElement, dataStore, menu, menuElement, buttons
from formsFunction import *

"""Form view cardset"""
formGraphics = dataStore()
formVars = dataStore()
formVars.set(formGraphics, "formGraphics")
globalVars = None

def init(pGlobalVars, pParams):
  global formVars, globalVars, formGraphics

  formGraphics = dataStore()
  formVars = dataStore()
  formVars.set(formGraphics, "formGraphics")
  globalVars = pGlobalVars

  formVars.set(globalVars.get("images").get("defaultBkgImage"), "bkgImage")
  formVars.set(0, "bkgImagePosX")
  formVars.set(0, "bkgImagePosY")

  pCardsetName = pParams[0]

  viewMenu = menu(formGraphics, globalVars, formVars)
  viewMenu.name = "VIEWMENU"
  formVars.set(viewMenu, "formMenu")

  for cardSet in globalVars.get("cardSets"):
    if cardSet.name == pCardsetName:
      break
  viewMenu.data = cardSet

  formVars.set(1, "data")
  createMenu()

  #Sfondo titolo:
  graph = graphicElement()
  graph.name = "TITLE"
  graph.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_generic_title.png')
  graph.image.blit(globalVars.get("images").get("levelDown"), 0, 0, globalVars.get("images").get("levelDown").width, globalVars.get("images").get("levelDown").height, 0, 0, True)
  graph.image.blit(globalVars.get("images").get("levelUp"), 0, 0, globalVars.get("images").get("levelUp").width, globalVars.get("images").get("levelUp").height, graph.image.width - globalVars.get("images").get("levelUp").width, 0, True)
  graph.posX = -440
  graph.posY = 8
  anim = animation()
  anim.name = "TITLE"
  anim.data = [20, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)

  graph = graphicElement()
  graph.name = "TITLET"
  graph.font = globalVars.get("fonts").get("fontTitle")
  graph.text = globalVars.get("messages").LEVEL + " 1"
  graph.posY = 10
  graph.posX = -functions.textWidth(graph.font, graph.text)
  anim = animation()
  anim.name = "TITLET"
  anim.data = [(480 - functions.textWidth(graph.font, graph.text)) / 2, graph.posY, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim
  formGraphics.set(graph)

  #Sfondo informazioni:
  graph = graphicElement()
  graph.name = "CARD_INFO"
  graph.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_cardv_info.png')
  graph.posX = 195 + 480
  graph.posY = 48
  anim = animation()
  anim.name = "CARD_INFO"
  anim.data = [195, 48, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim

  posX = 80
  posY = 12
  tHeight = functions.textHeight(globalVars.get("fonts").get("fontMenu"), "I")
  globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 0 * (tHeight + globalVars.get("themeOptions").MENU_INTERLINE), globalVars.get("messages").LEVEL)
  globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 1 * (tHeight + globalVars.get("themeOptions").MENU_INTERLINE), globalVars.get("messages").TOP)
  globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 2 * (tHeight + globalVars.get("themeOptions").MENU_INTERLINE), globalVars.get("messages").RIGHT)
  globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 3 * (tHeight + globalVars.get("themeOptions").MENU_INTERLINE), globalVars.get("messages").BOTTOM)
  globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 4 * (tHeight + globalVars.get("themeOptions").MENU_INTERLINE), globalVars.get("messages").LEFT)
  globalVars.get("fonts").get("fontMenu").drawText(graph.image, posX, posY + 5 * (tHeight + globalVars.get("themeOptions").MENU_INTERLINE), globalVars.get("messages").ELEMENTAL)

  graph.bufferImage = psp2d.Image(graph.image)
  formGraphics.set(graph)

  #Sfondo pulsanti:
  graph = graphicElement()
  graph.name = "CARD_BUTTONS"
  graph.image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_cardv_help.png')
  graph.posX = 195 + 480
  graph.posY = 182
  anim = animation()
  anim.name = "CARD_BUTTONS"
  anim.data = [195, 182, 99]
  anim.code = functions.moveFromTo
  graph.animation = anim

  graph.image.blit(globalVars.get("images").get("buttonCircle"), 0, 0, globalVars.get("images").get("buttonCircle").width, globalVars.get("images").get("buttonCircle").height, 5, 8, True)
  graph.image.blit(globalVars.get("images").get("buttonLeftTrigger"), 0, 0, globalVars.get("images").get("buttonLeftTrigger").width, globalVars.get("images").get("buttonLeftTrigger").height, 5, 25, True)
  graph.image.blit(globalVars.get("images").get("buttonRightTrigger"), 0, 0, globalVars.get("images").get("buttonRightTrigger").width, globalVars.get("images").get("buttonRightTrigger").height, 5, 42, True)

  globalVars.get("fonts").get("fontMenu").drawText(graph.image, 30, 8, globalVars.get("messages").BACKMANCARDSETS)
  globalVars.get("fonts").get("fontMenu").drawText(graph.image, 30, 25, globalVars.get("messages").PREVIOUSLEVEL)
  globalVars.get("fonts").get("fontMenu").drawText(graph.image, 30, 42, globalVars.get("messages").NEXTLEVEL)

  formGraphics.set(graph)

  def code(globalVars, formVars, menu, element):
    globalVars.set(globalVars.get("sounds").get("menuCancelSound"), "playingSound")
    globalVars.get("playingSound").start()
    backPreviousForm()
  viewMenu.trigger_cancel = code

  viewMenu.posX = 20
  viewMenu.posY = 48
  viewMenu.menuWidth = 170
  viewMenu.menuHeight = 200
  viewMenu.menuAlignment = "CENTER"
  viewMenu.menuVAlignment = "CENTER"
  viewMenu.background_image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_cardv_menu.png')
  viewMenu.createGraphicElements("BOTTOM")
  viewMenu.elements[0].trigger_enter(globalVars, formVars, viewMenu, viewMenu.getSelected())


def backPreviousForm():
  #Torno al menu cardsets:
  globalVars.set("mdlManageCardSets", "formName")
  globalVars.set(["CARDSET_" + formVars.get("formMenu").data.name], "formParams")
  globalVars.set("YES", "breakLoop")


def createMenu():
  #Costruisco il menu:
  tMenu = formVars.get("formMenu")
  tCardSet = tMenu.data
  tMenu.delGraphics()
  tMenu.clear()
  tMenu. name = "VIEWMENU_" + str(formVars.get("data"))
  tMenu.data = tCardSet
  tMenu.posX = 20
  tMenu.posY = 48
  tMenu.menuWidth = 170
  tMenu.menuHeight = 200
  tMenu.menuAlignment = "CENTER"
  tMenu.menuVAlignment = "CENTER"
  tMenu.background_image = psp2d.Image('themes/' + globalVars.get("userData").THEME + '/formsbg/gm_cardv_menu.png')
  for i, tCard in enumerate(tMenu.data.elements):
    if tCard.level == formVars.get("data"):
      tElement = menuElement()
      tElement.text = tCard.name
      tElement.value = tCard.name
      tElement.trigger_enter = trigger_enter
      tMenu.elements.append(tElement)
  tMenu.selected = tMenu.elements[0].value


def button_down(pbuttons):
  #Gestione tasti form viewCardset:
  if buttons.left_trigger in pbuttons:
    if formVars.get("data") > 1:
      formVars.set(formVars.get("data") - 1, "data")
      createMenu()
      formVars.get("formMenu").createGraphicElements()
      formVars.get("formMenu").elements[0].trigger_enter(globalVars, formVars, formVars.get("formMenu"), formVars.get("formMenu").elements[0])
    return True
  elif buttons.right_trigger in pbuttons:
    if formVars.get("data") < 10:
      formVars.set(formVars.get("data") + 1, "data")
      createMenu()
      formVars.get("formMenu").createGraphicElements()
      formVars.get("formMenu").elements[0].trigger_enter(globalVars, formVars, formVars.get("formMenu"), formVars.get("formMenu").elements[0])
    return True


def trigger_enter(globalVars, formVars, menu, element):
  #Titolo:
  graph = formGraphics.get("TITLET")
  if not graph:
    graph = graphicElement()
    graph.name = "TITLET"
    graph.font = globalVars.get("fonts").get("fontTitle")
    graph.posY = 13
    graph.posX = (480 - functions.textWidth(graph.font, graph.text)) / 2
    menu.formGraphics.set(graph)
  graph.image = None
  graph.text = menu.globalVars.get("messages").LEVEL + " " + str(formVars.get("data"))

  #Visualizzo i valori della carta:
  graph = formGraphics.get("CARD_INFO")
  card = menu.data.getCard(element.value)
  zero = functions.textWidth(globalVars.get("fonts").get("fontMenu"), "0")

  posX = 245
  posY = 12
  tHeight = functions.textHeight(globalVars.get("fonts").get("fontMenu"), "I")

  image = psp2d.Image(graph.bufferImage)
  globalVars.get("fonts").get("fontMenu").drawText(image, posX - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(card.level)) - (zero - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(card.level))) / 2, posY + 0 * (tHeight + menu.globalVars.get("themeOptions").MENU_INTERLINE), str(card.level))
  globalVars.get("fonts").get("fontMenu").drawText(image, posX - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(card.top)) - (zero - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(card.top))) / 2, posY + 1 * (tHeight + menu.globalVars.get("themeOptions").MENU_INTERLINE), str(card.top))
  globalVars.get("fonts").get("fontMenu").drawText(image, posX - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(card.right)) - (zero - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(card.right))) / 2, posY + 2 * (tHeight + menu.globalVars.get("themeOptions").MENU_INTERLINE), str(card.right))
  globalVars.get("fonts").get("fontMenu").drawText(image, posX - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(card.bottom)) - (zero - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(card.bottom))) / 2, posY + 3 * (tHeight + menu.globalVars.get("themeOptions").MENU_INTERLINE), str(card.bottom))
  globalVars.get("fonts").get("fontMenu").drawText(image, posX - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(card.left)) - (zero - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(card.left))) / 2, posY + 4 * (tHeight + menu.globalVars.get("themeOptions").MENU_INTERLINE), str(card.left))
  if card.elementalString:
    globalVars.get("fonts").get("fontMenu").drawText(image, posX - functions.textWidth(globalVars.get("fonts").get("fontMenu"), str(card.elementalString)), posY + 5 * (tHeight + menu.globalVars.get("themeOptions").MENU_INTERLINE), str(card.elementalString))
  else:
    globalVars.get("fonts").get("fontMenu").drawText(image, posX - functions.textWidth(globalVars.get("fonts").get("fontMenu"), "-") - (zero - functions.textWidth(globalVars.get("fonts").get("fontMenu"), "-")) / 2, posY + 5 * (tHeight + menu.globalVars.get("themeOptions").MENU_INTERLINE), "-")

  cardImage = card.writeValues(psp2d.Image(card.imageP1))
  image.blit(cardImage, 0, 0, cardImage.width, cardImage.height, 5, 12)

  graph.image = image

